# emacs-mode: -*- python-*-
from wxPython.wx import *
from wxPython.lib.buttons import *
from wxPython.grid import *
from wxPython.calendar import *
from wxPython.lib.filebrowsebutton import FileBrowseButton
from wxPython.lib.maskednumctrl import wxMaskedNumCtrl, EVT_MASKEDNUM
from wxPython.lib.scrolledpanel import wxScrolledPanel
from wxentries import *
import threading
import wx
from Utilidades import Utilidades
class Ventana(wxFrame):
    __module__ = __name__

    def __init__(self, titulo, parent = None, pos = wxDefaultPosition, size = wxDefaultSize, style = wxDEFAULT_FRAME_STYLE):
        wxFrame.__init__(self, parent, -1, titulo, pos, size, style)
        EVT_CLOSE(self, self.cerrarVentanaMenu)
        icono = wxIcon('imagenes/sirhiss2.ico', wxBITMAP_TYPE_ICO)
        self.SetIcon(icono)
        self.SetFocus()
        self.Centre()



    def cerrarVentanaMenu(self, event):
        self.cerrarVentana()



    def ponTamanio(self, tamanio):
        self.SetSize(tamanio)
        self.Centre()



    def ponMenu(self, titulosmenu, menu):
        listaMenus = []
        for titulo in titulosmenu:
            elementoMenu = wxMenu()
            listaMenus.append(elementoMenu)

        for opcion in menu:
            idElemento = wxNewId()
            listaMenus[opcion[0]].Append(idElemento, opcion[1], opcion[2])
            if opcion[3]:
                listaMenus[opcion[0]].AppendSeparator()
            listaMenus[opcion[0]].Enable(idElemento, opcion[4])
            EVT_MENU(self, idElemento, opcion[5])

        barraMenuPrincipal = wxMenuBar()
        self.SetMenuBar(barraMenuPrincipal)
        for i in range(len(listaMenus)):
            barraMenuPrincipal.Append(listaMenus[i], titulosmenu[i])




    def ponBarraEstado(self):
        self.bEstado = wxStatusBar(self, -1)
        self.SetStatusBar(self.bEstado)



    def hacerModal(self):
        self.MakeModal(true)
        self.CenterOnParent(wxBOTH)
        self.Show(1)



    def cerrarVentana(self):
        self.MakeModal(0)
        self.Destroy()



class Panel(wxPanel):
    __module__ = __name__

    def __init__(self, padre, filas, columnas):
        wxPanel.__init__(self, padre, -1)
        self.sizer = wxFlexGridSizer(filas, columnas, 1, 1)



    def insertaElemento(self, elemento):
        if ((str(elemento.__class__) == 'Interfaz.Panel') or (str(elemento.__class__) == 'Interfaz.PanelScroll')):
            separacion = 0
        else:
            separacion = 5
        self.sizer.Add(elemento, 1, (((wxTOP | wxLEFT) | wxRIGHT) | wxEXPAND), separacion)



    def creceColumna(self, columna):
        self.sizer.AddGrowableCol(columna)



    def creceFila(self, fila):
        self.sizer.AddGrowableRow(fila)



    def cerrarPanel(self):
        self.SetAutoLayout(1)
        self.SetSizer(self.sizer)
        self.sizer.Fit(self)
        self.Layout()



class PanelScroll(wxScrolledPanel):
    __module__ = __name__

    def __init__(self, padre, filas, columnas):
        wxScrolledPanel.__init__(self, padre, -1, style=wxTAB_TRAVERSAL)
        self.sizer = wxFlexGridSizer(filas, columnas, 1, 1)



    def insertaElemento(self, elemento):
        self.sizer.Add(elemento, 1, (((wxTOP | wxLEFT) | wxRIGHT) | wxEXPAND), 5)



    def creceColumna(self, columna):
        self.sizer.AddGrowableCol(columna)



    def creceFila(self, fila):
        self.sizer.AddGrowableRow(fila)



    def cerrarPanel(self):
        self.SetAutoLayout(1)
        self.SetSizer(self.sizer)
        self.sizer.Fit(self)
        self.Layout()
        self.SetupScrolling()



class Etiqueta(wxStaticText):
    __module__ = __name__

    def __init__(self, padre, texto, color = None):
        wxStaticText.__init__(self, padre, -1, texto)
	if color : self.SetForegroundColour(color)



    def ponNegrita(self):
        font = self.GetFont()
        font.SetWeight(wxBOLD)
        self.SetFont(font)
        self.SetForegroundColour(wxBLUE)



    def ponEstilo(self, tamanio, fuente, negrita, subrayado):
        font = wxFont(tamanio, fuente, negrita, subrayado)
        self.SetFont(font)
        self.SetBackgroundColour(wxBLUE)
        self.SetForegroundColour(wxWHITE)



    def ponTexto(self, texto):
        self.SetLabel(texto)



    def dameTexto(self):
        return self.GetLabel()



class AreaTexto(wxTextCtrl):
    __module__ = __name__

    def __init__(self, padre):
        wxTextCtrl.__init__(self, padre, -1, '')



    def ponTamanio(self, tamanio):
        self.SetSize(tamanio)



    def dameTamanio(self):
        self.GetSize()



    def dameValor(self):
        return self.GetValue()



    def ponTexto(self, text):
        self.SetValue(text)



class AreaClave(wxTextCtrl):
    __module__ = __name__

    def __init__(self, padre):
        wxTextCtrl.__init__(self, padre, -1, '', style=wxTE_PASSWORD)



    def ponTamanio(self, tamanio):
        self.SetSize(tamanio)



    def dameValor(self):
        return self.GetValue()



    def ponTexto(self, text):
        self.SetValue(text)



class Combo(wxComboBox):
    __module__ = __name__

    def __init__(self, padre, lista):
        wxComboBox.__init__(self, padre, -1, choices=lista, style=wxCB_READONLY)



    def dameValor(self):
        return self.GetValue()



    def seleccionaValor(self, texto):
        self.SetValue(texto)



    def eliminar(self, texto):
        posicion = self.FindString(texto)
        self.Delete(posicion)



    def cambiaNombreElemento(self, nombreNuevo, nombreViejo):
        if (nombreNuevo == nombreViejo):
            return 
        self.eliminar(nombreViejo)
        self.Append(nombreNuevo)



class ComboWriter(wxComboBox):
    __module__ = __name__

    def __init__(self, padre, lista):
        wxComboBox.__init__(self, padre, -1, choices=lista)



    def dameValor(self):
        return self.GetValue()



    def seleccionaValor(self, texto):
        self.SetValue(texto)



    def eliminar(self, texto):
        posicion = self.FindString(texto)
        self.Delete(posicion)



    def cambiaNombreElemento(self, nombreNuevo, nombreViejo):
        if (nombreNuevo == nombreViejo):
            return 
        self.eliminar(nombreViejo)
        self.Append(nombreNuevo)



class Boton(wxGenBitmapTextButton):
    __module__ = __name__

    def __init__(self, padre, texto, evento = None, imagen = None):
        wxGenBitmapTextButton.__init__(self, padre, -1, None, texto)
        if evento:
            EVT_BUTTON(padre, self.GetId(), evento)
        if imagen:
            if (imagen == 'aceptar'):
                ruta = 'imagenes/ok.png'
            if (imagen == 'cancelar'):
                ruta = 'imagenes/cancelar.png'
            if (imagen == 'usuario'):
                ruta = 'imagenes/botonUsuario.png'
            if (imagen == 'calendario'):
                ruta = 'imagenes/calendario.png'
            if (imagen == 'gastos'):
                ruta = 'imagenes/gastos.png'
            if (imagen == 'nuevo'):
                ruta = 'imagenes/nuevo.png'
            if (imagen == 'izquierda'):
                ruta = 'imagenes/izquierda.png'
            if (imagen == 'derecha'):
                ruta = 'imagenes/derecha.png'
            if (imagen == 'indicadores'):
                ruta = 'imagenes/indicadores.png'
            if (imagen == 'accion'):
                ruta = 'imagenes/botonAccion.png'
            if (imagen == 'actuacion'):
                ruta = 'imagenes/botonActuacion.png'
            if (imagen == 'factura'):
                ruta = 'imagenes/botonFactura.png'
            if (imagen == 'fichero'):
                ruta = 'imagenes/fichero.png'
            if (imagen == 'gantz'):
                ruta = 'imagenes/gantz.png'
            if (imagen == 'pdf'):
                ruta = 'imagenes/pdf.png'
            if (imagen == 'socio'):
                ruta = 'imagenes/botonSocios.png'
            if (imagen == 'eliminar'):
                ruta = 'imagenes/eliminar.png'
            if (imagen == 'descargar'):
                ruta = 'imagenes/descargar.png'
            if (imagen == 'buscar'):
                ruta = 'imagenes/buscar.png'
            if (imagen == 'ayuda'):
                ruta = 'imagenes/ayuda.png'
            imagenBoton = wxImage(ruta, wxBITMAP_TYPE_PNG).ConvertToBitmap()
            self.SetBitmapLabel(imagenBoton)
        tamanio = self.GetBestSize()
        if (imagen == 'calendario') or (imagen == "ayuda"):
            tamanio[0] = 40
        self.SetSize((tamanio[0],
         -1))

class BotonHerramientas(wxGenBitmapTextButton):
    __module__ = __name__

    def __init__(self, padre, texto, evento = None, imagen = None):
        wxGenBitmapTextButton.__init__(self, padre, -1, None, texto)
        if evento: EVT_BUTTON(padre, self.GetId(), evento)
        if imagen:
            if (imagen == 'nueva'):	  ruta = 'imagenes/barraHerramientas/nueva.png'
            if (imagen == 'abrir'):	  ruta = 'imagenes/barraHerramientas/abrir.png'
            if (imagen == 'guardar'):	  ruta = 'imagenes/barraHerramientas/guardar.png'
            if (imagen == 'memoria'):	  ruta = 'imagenes/barraHerramientas/memoria.png'
            if (imagen == 'certificado'): ruta = 'imagenes/barraHerramientas/certificado.png'
            if (imagen == 'declaracion'): ruta = 'imagenes/barraHerramientas/declaracion.png'
            if (imagen == 'portada'):	  ruta = 'imagenes/barraHerramientas/portada.png'
            imagenBoton = wxImage(ruta, wxBITMAP_TYPE_PNG).ConvertToBitmap()
            self.SetBitmapLabel(imagenBoton)
        tamanio = self.GetBestSize()
        self.SetSize((40,-1))



class Imagen(wxPanel):
    __module__ = __name__

    def __init__(self, padre, ruta):
        wxPanel.__init__(self, padre, -1)
        imagen = wxImage(ruta, wxBITMAP_TYPE_PNG).ConvertToBitmap()
        wxStaticBitmap(padre, -1, imagen, wxPoint(10), wxSize(imagen.GetWidth(), imagen.GetHeight()))
        self.SetAutoLayout(1)
        self.Layout()



class Arbol(wxTreeCtrl):
    __module__ = __name__

    def __init__(self, padre, tituloArbol):
        wxTreeCtrl.__init__(self, padre, -1)
        self.iniciaArbol(tituloArbol)



    def ponTamanio(self, tamanio):
        self.SetSize(tamanio)



    def iniciaArbol(self, tituloArbol):
        isz = (16,
         16)
        il = wxImageList(isz[0], isz[1])
        self.fidridx = il.Add(wxArtProvider_GetBitmap(wxART_FOLDER, wxART_OTHER, isz))
        self.fidropenidx = il.Add(wxArtProvider_GetBitmap(wxART_FILE_OPEN, wxART_OTHER, isz))
        self.fileidx = il.Add(wxArtProvider_GetBitmap(wxART_REPORT_VIEW, wxART_OTHER, isz))
        ruta = 'imagenes/usuario.png'
        imagen = wxImage(ruta, wxBITMAP_TYPE_PNG).ConvertToBitmap()
        self.iconoUsuario = il.Add(imagen)
        ruta = 'imagenes/socios.png'
        imagen = wxImage(ruta, wxBITMAP_TYPE_PNG).ConvertToBitmap()
        self.iconoSocio = il.Add(imagen)
        ruta = 'imagenes/proyecto.png'
        imagen = wxImage(ruta, wxBITMAP_TYPE_PNG).ConvertToBitmap()
        self.iconoProyecto = il.Add(imagen)
        ruta = 'imagenes/proyectoNoPermitido.png'
        imagen = wxImage(ruta, wxBITMAP_TYPE_PNG).ConvertToBitmap()
        self.iconoProyectoProhibido = il.Add(imagen)
        ruta = 'imagenes/proyectoAdministrador.png'
        imagen = wxImage(ruta, wxBITMAP_TYPE_PNG).ConvertToBitmap()
        self.iconoProyectoAdministrador = il.Add(imagen)
        ruta = 'imagenes/proyectoUsuario.png'
        imagen = wxImage(ruta, wxBITMAP_TYPE_PNG).ConvertToBitmap()
        self.iconoProyectoUsuario = il.Add(imagen)
        ruta = 'imagenes/proyectoInvitado.png'
        imagen = wxImage(ruta, wxBITMAP_TYPE_PNG).ConvertToBitmap()
        self.iconoProyectoInvitado = il.Add(imagen)
        ruta = 'imagenes/accion.png'
        imagen = wxImage(ruta, wxBITMAP_TYPE_PNG).ConvertToBitmap()
        self.iconoAccion = il.Add(imagen)
        ruta = 'imagenes/actuacion.png'
        imagen = wxImage(ruta, wxBITMAP_TYPE_PNG).ConvertToBitmap()
        self.iconoActuacion = il.Add(imagen)
        ruta = 'imagenes/factura.png'
        imagen = wxImage(ruta, wxBITMAP_TYPE_PNG).ConvertToBitmap()
        self.iconoFactura = il.Add(imagen)
        self.SetImageList(il)
        self.il = il
        self.root = self.AddRoot(tituloArbol)
        self.SetPyData(self.root, None)
        self.SetItemImage(self.root, self.fidridx, wxTreeItemIcon_Normal)
        self.SetItemImage(self.root, self.fidropenidx, wxTreeItemIcon_Expanded)



    def aniadirNodo(self, nombre, tipo, objeto, padre = None):
        if padre:
            nodo = self.AppendItem(padre, nombre)
        else:
            nodo = self.AppendItem(self.root, nombre)
        self.SetPyData(nodo, objeto)
        if (tipo == 'socio'):
            self.SetItemImage(nodo, self.iconoSocio, wxTreeItemIcon_Normal)
            self.SetItemImage(nodo, self.iconoSocio, wxTreeItemIcon_Expanded)
            self.SetItemImage(nodo, self.iconoSocio, wxTreeItemIcon_Selected)
        if (tipo == 'usuario'):
            self.SetItemImage(nodo, self.iconoUsuario, wxTreeItemIcon_Normal)
            self.SetItemImage(nodo, self.iconoUsuario, wxTreeItemIcon_Expanded)
            self.SetItemImage(nodo, self.iconoUsuario, wxTreeItemIcon_Selected)
        if (tipo == 'proyecto'):
            self.SetItemImage(nodo, self.iconoProyecto, wxTreeItemIcon_Normal)
            self.SetItemImage(nodo, self.iconoProyecto, wxTreeItemIcon_Expanded)
            self.SetItemImage(nodo, self.iconoProyecto, wxTreeItemIcon_Selected)
        if (tipo == 'noPermitido'):
            self.SetItemImage(nodo, self.iconoProyectoProhibido, wxTreeItemIcon_Normal)
            self.SetItemImage(nodo, self.iconoProyectoProhibido, wxTreeItemIcon_Expanded)
            self.SetItemImage(nodo, self.iconoProyectoProhibido, wxTreeItemIcon_Selected)
        if (tipo == 'Administrador'):
            self.SetItemImage(nodo, self.iconoProyectoAdministrador, wxTreeItemIcon_Normal)
            self.SetItemImage(nodo, self.iconoProyectoAdministrador, wxTreeItemIcon_Expanded)
            self.SetItemImage(nodo, self.iconoProyectoAdministrador, wxTreeItemIcon_Selected)
        if (tipo == 'usuarioProyecto'):
            self.SetItemImage(nodo, self.iconoProyectoUsuario, wxTreeItemIcon_Normal)
            self.SetItemImage(nodo, self.iconoProyectoUsuario, wxTreeItemIcon_Expanded)
            self.SetItemImage(nodo, self.iconoProyectoUsuario, wxTreeItemIcon_Selected)
        if (tipo == 'invitado'):
            self.SetItemImage(nodo, self.iconoProyectoInvitado, wxTreeItemIcon_Normal)
            self.SetItemImage(nodo, self.iconoProyectoInvitado, wxTreeItemIcon_Expanded)
            self.SetItemImage(nodo, self.iconoProyectoInvitado, wxTreeItemIcon_Selected)
        if (tipo == 'accion'):
            self.SetItemImage(nodo, self.iconoAccion, wxTreeItemIcon_Normal)
            self.SetItemImage(nodo, self.iconoAccion, wxTreeItemIcon_Expanded)
            self.SetItemImage(nodo, self.iconoAccion, wxTreeItemIcon_Selected)
        if (tipo == 'actuacion'):
            self.SetItemImage(nodo, self.iconoActuacion, wxTreeItemIcon_Normal)
            self.SetItemImage(nodo, self.iconoActuacion, wxTreeItemIcon_Expanded)
            self.SetItemImage(nodo, self.iconoActuacion, wxTreeItemIcon_Selected)
        if (tipo == 'factura'):
            self.SetItemImage(nodo, self.iconoFactura, wxTreeItemIcon_Normal)
            self.SetItemImage(nodo, self.iconoFactura, wxTreeItemIcon_Expanded)
            self.SetItemImage(nodo, self.iconoFactura, wxTreeItemIcon_Selected)
        return nodo



    def buscarNodo(self, nombre, padre = None):
        if (not padre):
            padre = self.GetRootItem()
        primerHijo = self.GetFirstChild(padre, 12)
        if (self.GetItemText(primerHijo[0]) == nombre):
            return primerHijo[0]
        encontrado = 0
        hijo = [primerHijo[0],
         primerHijo[1]]
        while (not encontrado):
            hijo = self.GetNextChild(padre, hijo[1])
            if (self.GetItemText(hijo[0]) == nombre):
                return hijo[0]




    def cambiaNodo(self, nodo):
        self.SetItemImage(nodo, 4)
        self.SetItemImage(nodo, 4, wxTreeItemIcon_Selected)



    def cambiaNombreNodo(self, nombreNuevo, nombreViejo, nodo):
        if (nombreNuevo == nombreViejo):
            return 
        self.SetItemText(nodo, nombreNuevo)



class Error(wxMessageDialog):
    __module__ = __name__

    def __init__(self, padre, texto):
        wxMessageDialog.__init__(self, padre, texto, 'Error', (wxOK | wxICON_ERROR))
        self.ShowModal()
        self.Destroy()



class Confirmacion(wxMessageDialog):
    __module__ = __name__

    def __init__(self, padre, texto):
        wxMessageDialog.__init__(self, padre, texto, 'Confirmacion', (wxYES_NO | wxICON_QUESTION))



    def mostrar(self):
        if (self.ShowModal() == wxID_YES):
            self.Destroy()
            return 1
        else:
            self.Destroy()
            return 0



class Pestania(wxNotebook):
    __module__ = __name__

    def __init__(self, padre):
        wxNotebook.__init__(self, padre, -1)



    def insertaTab(self, panel, titulo):
        self.AddPage(panel, titulo)



class Memo(wxTextCtrl):
    __module__ = __name__

    def __init__(self, padre):
        wxTextCtrl.__init__(self, padre, -1, '', style=(wxTE_MULTILINE | wxTE_RICH2))



    def ponTamanio(self, tamanio):
        self.SetSize(tamanio)



    def dameValor(self):
        return self.GetValue()



    def ponTexto(self, text):
        self.SetValue(text)



class listaCheckBox(wxCheckListBox):
    __module__ = __name__

    def __init__(self, padre, lista):
        wxCheckListBox.__init__(self, padre, -1, choices=lista)



    def ponTamanio(self, tamanio):
        self.SetSize(tamanio)



    def limpiar(self):
        for i in range(self.GetCount()):
            self.Check(i, false)




    def cargar(self, lista):
        for i in range(len(lista)):
            enc = self.FindString(lista[i])
            if (not (enc == -1)):
                self.Check(enc, true)




    def devolverListaSeleccionados(self):
        items = []
        for i in range(self.GetCount()):
            if self.IsChecked(i):
                dato = self.GetString(i)
                items.append(dato)

        return items



    def elementoEncontrado(self, elemento):
        return self.FindString(elemento)



    def aniadirElemento(self, elemento):
        self.Append(elemento)



class ListaContenedor(wxListBox):
    __module__ = __name__

    def __init__(self, padre, lista):
        wxListBox.__init__(self, padre, -1, choices=lista)



    def ponTamanio(self, tamanio):
        self.SetSize(tamanio)



    def dameElementoSeleccionado(self):
        return self.GetStringSelection()



    def aniadirElemento(self, elemento):
        if (self.elementoEncontrado(elemento) < 0):
            self.Append(elemento)



    def eliminarElemento(self, elemento):
        pos_Elemento = self.GetSelections()
        self.Delete(pos_Elemento[0])



    def elementoEncontrado(self, elemento):
        return self.FindString(elemento)



    def dameElementos(self):
        items = []
        for i in range(self.GetCount()):
            dato = self.GetString(i)
            items.append(dato)

        return items



    def eliminarTodosElementos(self):
        self.Clear()



class Tabla(wxGrid):
    __module__ = __name__

    def __init__(self, padre, filas, columnas):
        wxGrid.__init__(self, padre, -1)
        self.CreateGrid(filas, columnas)
        self.SetRowLabelSize(0)
        self.nuevaFila()



    def ponTitulosColumnas(self, titulos):
        for i in range(len(titulos)):
            self.SetColLabelValue(i, str(titulos[i]))




    def completaDiagrama(self, celdas):
        i = 0
        self.ponValor(0, 0, 'Prevision')
        self.ponValor(1, 0, 'Real')
        for celda in celdas:
            self.tamanioColumna(i, 10)
            self.ponTitulo(i, str(celda['Contenido']))
            self.estiloCelda(0, i, 1, celda['EstadoP'])
            self.estiloCelda(1, i, 1, celda['EstadoR'])
            i += 1




    def ponDatos(self, datos, nuevaFila = None):
        fila = 0
        for dato in datos:
            self.nuevaFila()
            columna = 0
            for celda in dato:
                self.SetCellValue(fila, columna, celda)
                columna = (columna + 1)

            fila = (fila + 1)

        if (not nuevaFila):
            self.nuevaFila()



    def tamanioColumna(self, col, tam):
        self.SetColSize(col, tam)



    def ponTitulo(self, columna, dato):
        self.SetColLabelValue(columna, dato)



    def nuevaFila(self):
        self.AppendRows()



    def dameDatos(self):
        datos = []
        numFilas = self.GetNumberRows()
        numColumnas = self.GetNumberCols()
        for i in range(numFilas):
            fila = []
            for j in range(numColumnas):
                fila.append(self.GetCellValue(i, j))

            if (not (self.GetCellValue(i, 0) == '')):
                datos.append(fila)

        return datos



    def ponValor(self, fila, columna, dato):
        self.SetCellValue(fila, columna, dato)



    def estiloCelda(self, fila, columna, lectura, color):
        self.SetReadOnly(fila, columna, lectura)
        self.SetCellBackgroundColour(fila, columna, color)



    def dameValor(self, fila, columna):
        valor = self.GetCellValue(fila, columna)
        if (valor == ''):
            return 0
        else:
            return valor



    def eliminaFilas(self):
        self.DeleteRows(0, self.GetNumberRows())



    def dimensionarColumnas(self, col, tam):
        self.SetColumnWidth(col, tam)



    def numeroFilas(self):
        return self.GetNumberRows()



class Calendario(Ventana):
    __module__ = __name__

    def __init__(self, padre, areaTexto, fecha):
        Ventana.__init__(self, 'Calendario', padre)
        self.areaTexto = areaTexto
        if (fecha == ''):
            fechaMostrar = wxDateTime_Now()
        else:
            fechaMostrar = self.dameFecha(fecha)
        panel = Panel(self, 2, 1)
        self.cal = wxCalendarCtrl(panel, -1, fechaMostrar, style=((wxCAL_SHOW_HOLIDAYS | wxCAL_MONDAY_FIRST) | wxCAL_SEQUENTIAL_MONTH_SELECTION))
        panel.insertaElemento(self.cal)
        panel.insertaElemento(self.panelBotones(panel))
        panel.cerrarPanel()
        EVT_CALENDAR(self.cal, self.cal.GetId(), self.calendarioSeleccionado)
        self.ponTamanio([200,
         200])
        self.hacerModal()



    def dameFecha(self, cadena):
        cadena = cadena.split('/')
        if (not (len(cadena) == 3)):
            return 0
        fecha = wxDateTimeFromDMY(int(cadena[0]), (int(cadena[1]) - 1), int(cadena[2]))
        return fecha



    def panelBotones(self, padre):
        panel = Panel(padre, 1, 2)
        panel.insertaElemento(Boton(panel, 'Aceptar', self.calendarioSeleccionado, 'aceptar'))
        panel.insertaElemento(Boton(panel, 'Cancelar', self.cancelar, 'cancelar'))
        panel.cerrarPanel()
        return panel



    def cancelar(self, event):
        self.cerrarVentana()



    def calendarioSeleccionado(self, event):
        if self.areaTexto:
            date = self.cal.GetDate()
            self.areaTexto.SetValue(('%02d/%02d/%04d' % (date.GetDay(),
             (date.GetMonth() + 1),
             date.GetYear())))
        self.cerrarVentana()



class Barra(wxGauge):
    __module__ = __name__

    def __init__(self, padre, rango):
        wxGauge.__init__(self, padre, -1, 100)
        self.inicializar()



    def inicializar(self):
        self.SetBezelFace(3)
        self.SetShadowWidth(3)



class Adjuntar(FileBrowseButton):
    __module__ = __name__

    def __init__(self, padre, texto):
        FileBrowseButton.__init__(self, padre, labelText=texto, buttonText='Adjuntar')



    def dameValor(self):
        return self.GetValue()



    def ponTexto(self, texto):
        self.SetValue(texto)



class DialogoFichero(wxFileDialog):
    __module__ = __name__

    def __init__(self, padre, nombreFichero):
        wxFileDialog.__init__(self, padre, 'Elige un fichero', '', nombreFichero, '*.pdf')



class ListaColumna(wxListCtrl):
    __module__ = __name__

    def __init__(self, padre, eventoSeleccion = None, eventoDeseleccion = None):
        wxListCtrl.__init__(self, padre, -1, style=((wxLC_REPORT | wxSUNKEN_BORDER) | wxLC_SINGLE_SEL))
        if eventoSeleccion:
            EVT_LIST_ITEM_SELECTED(padre, self.GetId(), eventoSeleccion)
        if eventoDeseleccion:
            EVT_LIST_ITEM_DESELECTED(padre, self.GetId(), eventoDeseleccion)



    def ponTamanio(self, tamanio):
        self.SetSize(tamanio)



    def cabeceraColumnas(self, columnas):
        for i in range(len(columnas)):
            self.InsertColumn(i, columnas[i])




    def insertaFila(self, fecha, nombre, descripcion):
        self.Append([fecha,
         nombre,
         descripcion])



    def insertarColumna(self, pos, cabecera):
        print 'Inserto columna'
        self.InsertColumn(pos, cabecera)



    def insertarElemento(self, pos, elemento):
        self.InsertStringItem(pos, elemento)



class Radio(wxRadioBox):
    __module__ = __name__

    def __init__(self, padre, titulo, elementos):
        wxRadioBox.__init__(self, padre, wxNewId(), titulo, majorDimension=1, style=wxRA_SPECIFY_COLS, choices=elementos)



class CajaRadio:
    __module__ = __name__

    def __init__(self, padre, titulo, elementos, textos = None, check = None, numColumnas = None):
        self.padre = padre
        self.titulo = titulo
        self.elementos = elementos
        self.radios = []
        self.textos = textos
        self.check = check
        self.numColumnas = numColumnas



    def dibujaCajaRadio(self, funcion = None):
        if self.textos:
            return self.dibujaCajaTexto(funcion)
        if self.check:
            return self.dibujaCajaCheck(funcion)
        panelStatic = wxStaticBox(self.padre, -1, self.titulo)
        sizer = wxStaticBoxSizer(panelStatic, wxVERTICAL)
        tabla = wxFlexGridSizer(0, 0, 1, 0)
        i = 0
        for elemento in self.elementos:
            i += 1
            radio = wxRadioButton(self.padre, i, elemento, style=wxRB_SINGLE)
            if funcion:
                EVT_RADIOBUTTON(radio, radio.GetId(), funcion)
            self.radios.append(radio)
            tabla.AddWindow(radio, 0, ((wxLEFT | wxRIGHT) | wxTOP), 5)

        sizer.AddSizer(tabla, 0, (wxEXPAND | wxALL), 5)
        return sizer



    def dibujaCajaTexto(self, funcion = None):
        panelStatic = wxStaticBox(self.padre, -1, self.titulo)
        sizer = wxStaticBoxSizer(panelStatic, wxVERTICAL)
        tabla = wxFlexGridSizer(0, 1, 0, 0)
        i = 0
        for elemento in self.elementos:
            i += 1
            texto = Etiqueta(self.padre, elemento)
            texto.ponNegrita()
            self.radios.append(texto)
            tabla.AddWindow(texto, 0, ((wxLEFT | wxRIGHT) | wxTOP), 5)

        sizer.AddSizer(tabla, 0, (wxEXPAND | wxALL), 5)
        return sizer



    def dibujaCajaCheck(self, funcion = None):
        panelStatic = wxStaticBox(self.padre, -1, self.titulo)
        sizer = wxStaticBoxSizer(panelStatic, wxVERTICAL)
        if self.numColumnas:
            tabla = wxFlexGridSizer(0, self.numColumnas, 0, 0)
        else:
            tabla = wxFlexGridSizer(0, 2, 0, 0)
        i = 0
        for elemento in self.elementos:
            i += 1
            check = wxCheckBox(self.padre, -1, elemento)
            if funcion:
                EVT_CHECKBOX(check, check.GetId(), funcion)
            self.radios.append(check)
            tabla.AddWindow(check, 0, ((wxLEFT | wxRIGHT) | wxTOP), 5)

        sizer.AddSizer(tabla, 0, (wxEXPAND | wxALL), 5)
        return sizer



    def dameElementoSeleccionado(self):
        for i in range(len(self.radios)):
            if self.radios[i].GetValue():
                return i

        return -1



class CampoMonetario(wxNumericEntry):
    __module__ = __name__

    def __init__(self, padre, decimal):
        wxNumericEntry.__init__(self, padre, -1, '', numDec=decimal, style=wxTE_RICH)



    def ponTamanio(self, tamanio):
        self.SetSize(tamanio)



    def dameTamanio(self):
        self.GetSize()



    def dameValor(self):
        return self.GetValue()



    def ponTexto(self, text):
        self.SetValue(text)



class DialogoTexto(wxTextEntryDialog):
    __module__ = __name__

    def __init__(self, padre, texto):
        wxTextEntryDialog.__init__(self, padre, texto)



    def mostrar(self):
        if (self.ShowModal() == wxID_OK):
            self.Destroy()
            return self.GetValue()
        else:
            self.Destroy()
            return ''



class VentanaEspera(threading.Thread):
    __module__ = __name__

    def __init__(self, padre, texto):
        threading.Thread.__init__(self)
        self.padre = padre
        self.texto = texto



    def run(self):
        self.ventana = wxMessageDialog(self.padre, self.texto, 'Error', (wxOK | wxICON_ERROR))
        self.ventana.Show()



    def stop(self):
        self.ventana.Destroy()



class VentanaGuardarFichero(wxFileDialog):
    __module__ = __name__

    def __init__(self, padre):
        wxFileDialog.__init__(self, padre, 'Guarda Instalacion', '', '', '*.xml', wxSAVE)



class VentanaAbrirFichero(wxFileDialog):
    __module__ = __name__

    def __init__(self, padre):
        wxFileDialog.__init__(self, padre, 'Abrir Instalacion', '', '', '*.xml', wxOPEN)




# local variables:
# tab-width: 4
