# emacs-mode: -*- python-*-
from Interfaz import *
from wxPython.ogl import *
from Instalacion import EsquemaInstalacion
class CoeficienteLineaAerea(Ventana):
    __module__ = __name__

    def __init__(self, padre, destino):
        Ventana.__init__(self, 'Coeficiente de c\xe1lculo para L\xednea A\xe9rea', padre)
        self.padre = padre
        self.coeficiente = 1
        self.destino = destino
        self.panel = Panel(self, 8, 0)
        self.radiosSol = CajaRadio(self.panel, '\xbfInstalaci\xf3n expuesta directamente al sol?', ['Si',
         'No'])
        self.panel.insertaElemento(self.radiosSol.dibujaCajaRadio(self.radioSolSeleccionado))
        self.panel.insertaElemento(self.dibujaAreaSol())
        self.radiosCable = CajaRadio(self.panel, '\xbfN\xfamero de cables agrupados?', ['1',
         '2',
         '3',
         'mas de 3'])
        self.panel.insertaElemento(self.radiosCable.dibujaCajaRadio(self.radioCableSeleccionado))
        self.panel.insertaElemento(self.dibujaAreaCable())
        self.radiosTemperatura = CajaRadio(self.panel, '\xbfTemperatura ambiente aproximada?', ['20',
         '25',
         '30',
         '35',
         '40',
         '45',
         '50'])
        self.panel.insertaElemento(self.radiosTemperatura.dibujaCajaRadio(self.radioTemperaturaSeleccionado))
        self.panel.insertaElemento(self.dibujaAreaTemperatura())
        self.etiquetaFactorCorreccion = Etiqueta(self.panel, 'Factor de Correcci\xf3n = 1')
        self.etiquetaFactorCorreccion.ponNegrita()
        self.panel.insertaElemento(self.etiquetaFactorCorreccion)
        self.panel.insertaElemento(self.dibujaBotones())
        self.panel.cerrarPanel()
        self.SetSize([350,
         350])
        self.hacerModal()



    def dibujaAreaSol(self):
        panel = Panel(self.panel, 0, 2)
        panel.insertaElemento(Etiqueta(panel, 'factor de correcci\xf3n'))
        self.txtSol = CampoMonetario(panel, 2)
        self.txtSol.ponTexto(1)
        EVT_KILL_FOCUS(self.txtSol, self.calculaCoeficienteSol)
        panel.insertaElemento(self.txtSol)
        panel.cerrarPanel()
        return panel



    def dibujaAreaCable(self):
        panel = Panel(self.panel, 0, 2)
        panel.insertaElemento(Etiqueta(panel, 'factor de correcci\xf3n'))
        self.txtCable = CampoMonetario(panel, 2)
        self.txtCable.ponTexto(1)
        EVT_KILL_FOCUS(self.txtCable, self.calculaCoeficiente)
        panel.insertaElemento(self.txtCable)
        panel.cerrarPanel()
        return panel



    def dibujaAreaTemperatura(self):
        panel = Panel(self.panel, 0, 2)
        panel.insertaElemento(Etiqueta(panel, 'factor de correcci\xf3n'))
        self.txtTemperatura = CampoMonetario(panel, 2)
        self.txtTemperatura.ponTexto(1)
        EVT_KILL_FOCUS(self.txtTemperatura, self.calculaCoeficiente)
        panel.insertaElemento(self.txtTemperatura)
        panel.cerrarPanel()
        return panel



    def dibujaBotones(self):
        panel = Panel(self.panel, 0, 4)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.insertaElemento(Boton(panel, 'Aceptar', self.aceptarCoeficiente, 'aceptar'))
        panel.insertaElemento(Boton(panel, 'Cancelar', self.cancelarCoeficiente, 'cancelar'))
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.creceColumna(0)
        panel.creceColumna(3)
        panel.cerrarPanel()
        return panel



    def calculaCoeficienteSol(self, event):
        if ((self.radiosSol.dameElementoSeleccionado() == 0) and (self.txtSol.dameValor() > 0.90000000000000002)):
            Error(self, 'En caso de que la instalaci\xf3n est\xe9 directamente expuesta al sol el factor de correcci\xf3n no puede ser mayor que 0.9')
        else:
            self.calculaCoeficiente(event)



    def calculaCoeficiente(self, event):
        self.coeficiente = ((self.txtSol.dameValor() * self.txtCable.dameValor()) * self.txtTemperatura.dameValor())
        self.etiquetaFactorCorreccion.ponTexto(('Factor de Correcci\xf3n = ' + str(self.coeficiente)))



    def radioSolSeleccionado(self, event):
        if self.radiosSol.dameElementoSeleccionado():
            self.txtSol.ponTexto(1)
        else:
            self.txtSol.ponTexto(0.90000000000000002)
        self.calculaCoeficiente(event)



    def radioCableSeleccionado(self, event):
        if (self.radiosCable.dameElementoSeleccionado() == 0):
            self.txtCable.ponTexto(1)
        if (self.radiosCable.dameElementoSeleccionado() == 1):
            self.txtCable.ponTexto(0.89000000000000001)
        if (self.radiosCable.dameElementoSeleccionado() == 2):
            self.txtCable.ponTexto(0.80000000000000004)
        if (self.radiosCable.dameElementoSeleccionado() == 3):
            self.txtCable.ponTexto(0.75)
        self.calculaCoeficiente(event)



    def radioTemperaturaSeleccionado(self, event):
        if (self.radiosTemperatura.dameElementoSeleccionado() == 0):
            self.txtTemperatura.ponTexto(1.1799999999999999)
        if (self.radiosTemperatura.dameElementoSeleccionado() == 1):
            self.txtTemperatura.ponTexto(1.1399999999999999)
        if (self.radiosTemperatura.dameElementoSeleccionado() == 2):
            self.txtTemperatura.ponTexto(1.1000000000000001)
        if (self.radiosTemperatura.dameElementoSeleccionado() == 3):
            self.txtTemperatura.ponTexto(1.05)
        if (self.radiosTemperatura.dameElementoSeleccionado() == 4):
            self.txtTemperatura.ponTexto(1)
        if (self.radiosTemperatura.dameElementoSeleccionado() == 5):
            self.txtTemperatura.ponTexto(0.94999999999999996)
        if (self.radiosTemperatura.dameElementoSeleccionado() == 6):
            self.txtTemperatura.ponTexto(0.90000000000000002)
        self.calculaCoeficiente(event)



    def aceptarCoeficiente(self, event):
        if ((self.radiosSol.dameElementoSeleccionado() == 0) and (self.txtSol.dameValor() > 0.90000000000000002)):
            Error(self, 'En caso de que la instalaci\xf3n est\xe9 directamente expuesta al sol el factor de correcci\xf3n no puede ser mayor que 0.9')
        else:
            self.destino.ponTexto(float(self.coeficiente))
            self.cancelarCoeficiente(event)



    def cancelarCoeficiente(self, event):
        self.MakeModal(0)
        self.Close()



class CoeficienteEnterradasSubterraneas(Ventana):
    __module__ = __name__

    def __init__(self, padre, destino, aislamiento):
        Ventana.__init__(self, 'Coeficiente de c\xe1lculo para L\xednea Subterr\xe1nea Enterrada', padre)
        self.padre = padre
        self.destino = destino
        self.aislamiento = aislamiento
        self.coeficiente = 1
        self.panel = Panel(self, 12, 0)
        self.etiqueta = Etiqueta(self.panel, 'Terrenos cuya temperatura sea distinta de 25 (\xbaC)')
        self.etiqueta.ponNegrita()
        self.panel.insertaElemento(self.etiqueta)
        self.panel.insertaElemento(self.dibujaTemperaturaServicio())
        self.etiqueta = Etiqueta(self.panel, 'Terrenos de resistividad t\xe9rmica distinta de 1 (K*m/W)')
        self.etiqueta.ponNegrita()
        self.panel.insertaElemento(self.etiqueta)
        self.panel.insertaElemento(self.dibujaResistividad())
        self.etiqueta = Etiqueta(self.panel, 'Agrupaciones de cables trif\xe1sicos o ternas de cables unipolares')
        self.etiqueta.ponNegrita()
        self.panel.insertaElemento(self.etiqueta)
        self.panel.insertaElemento(self.dibujaAgrupacion())
        self.etiqueta = Etiqueta(self.panel, 'Diferentes profundidades de instalaci\xf3n')
        self.etiqueta.ponNegrita()
        self.panel.insertaElemento(self.etiqueta)
        self.panel.insertaElemento(self.dibujaCablesEnterrados())
        self.etiquetaFactorCorreccion = Etiqueta(self.panel, 'Factor de Correcci\xf3n = 1')
        self.etiquetaFactorCorreccion.ponNegrita()
        self.panel.insertaElemento(self.etiquetaFactorCorreccion)
        self.panel.insertaElemento(self.dibujaBotones())
        self.panel.cerrarPanel()
        self.SetSize([700,
         275])
        self.hacerModal()



    def dibujaTemperaturaServicio(self):
        panel = Panel(self.panel, 0, 6)
        panel.insertaElemento(Etiqueta(panel, 'Temperatura de Servicio (\xbaC)'))
        self.txtTemperaturaServicio = Combo(panel, ['90',
         '70'])
        self.txtTemperaturaServicio.Enable(0)
        if (self.aislamiento == 1):
            self.txtTemperaturaServicio.SetSelection(1)
        else:
            self.txtTemperaturaServicio.SetSelection(0)
        EVT_COMBOBOX(self.txtTemperaturaServicio, self.txtTemperaturaServicio.GetId(), self.calculoFactorTemperatura)
        panel.insertaElemento(self.txtTemperaturaServicio)
        panel.insertaElemento(Etiqueta(panel, 'Temperatura del Terreno (\xbaC)'))
        self.txtTemperaturaTerreno = CampoMonetario(panel, 0)
        EVT_KILL_FOCUS(self.txtTemperaturaTerreno, self.calculoFactorTemperatura)
        panel.insertaElemento(self.txtTemperaturaTerreno)
        panel.insertaElemento(Etiqueta(panel, 'Factor de correcci\xf3n'))
        self.txtFactorTemperatura = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtFactorTemperatura, self.calcularCoeficiente)
        self.txtFactorTemperatura.ponTexto(1)
        panel.insertaElemento(self.txtFactorTemperatura)
        panel.cerrarPanel()
        return panel



    def calculoFactorTemperatura(self, event):
        if (self.txtTemperaturaServicio.dameValor() == ''):
            return 
        if (self.txtTemperaturaTerreno.dameValor() == 0):
            return 
        dividendo = (float(self.txtTemperaturaServicio.dameValor()) - self.txtTemperaturaTerreno.dameValor())
        divisor = (float(self.txtTemperaturaServicio.dameValor()) - 25)
        division = (dividendo / divisor)
        import math
        resultado = math.sqrt(division)
        self.txtFactorTemperatura.ponTexto(resultado)
        self.calcularCoeficiente(event)



    def dibujaResistividad(self):
        panel = Panel(self.panel, 0, 6)
        panel.insertaElemento(Etiqueta(panel, 'Tipo de cable'))
        self.txtTipoCable = Combo(panel, ['Unipolar',
         'Tripolar'])
        EVT_COMBOBOX(self.txtTipoCable, self.txtTipoCable.GetId(), self.calculoFactorResistividad)
        panel.insertaElemento(self.txtTipoCable)
        panel.insertaElemento(Etiqueta(panel, 'Resistividad t\xe9rmica del terreno (K*m/W)'))
        self.txtResistividad = Combo(panel, ['0.8',
         '0.85',
         '0.9',
         '1',
         '1.10',
         '1.20',
         '1.40',
         '1.65',
         '2',
         '2.50',
         '2.80'])
        EVT_COMBOBOX(self.txtResistividad, self.txtResistividad.GetId(), self.calculoFactorResistividad)
        panel.insertaElemento(self.txtResistividad)
        panel.insertaElemento(Etiqueta(panel, 'Factor de correcci\xf3n'))
        self.txtFactorResistividad = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtFactorResistividad, self.calcularCoeficiente)
        self.txtFactorResistividad.ponTexto(1)
        panel.insertaElemento(self.txtFactorResistividad)
        panel.cerrarPanel()
        return panel



    def calculoFactorResistividad(self, event):
        if (self.txtTipoCable.dameValor() == ''):
            return 
        if (self.txtResistividad.dameValor() == ''):
            return 
        fila1 = [1.0900000000000001,
         1.0600000000000001,
         1.04,
         1,
         0.95999999999999996,
         0.93000000000000005,
         0.87,
         0.81000000000000005,
         0.75,
         0.68000000000000005,
         0.66000000000000003]
        fila2 = [1.0700000000000001,
         1.05,
         1.03,
         1,
         0.96999999999999997,
         0.93999999999999995,
         0.89000000000000001,
         0.81000000000000005,
         0.78000000000000003,
         0.70999999999999996,
         0.68999999999999995]
        tabla = [fila1,
         fila2]
        self.txtFactorResistividad.ponTexto(tabla[self.txtTipoCable.GetSelection()][self.txtResistividad.GetSelection()])
        self.calcularCoeficiente(event)



    def dibujaAgrupacion(self):
        panel = Panel(self.panel, 0, 6)
        panel.insertaElemento(Etiqueta(panel, 'Separaci\xf3n entre los cables o ternas (cm)'))
        self.txtSeparacion = Combo(panel, ['0',
         '7',
         '10',
         '15',
         '20',
         '25'])
        EVT_COMBOBOX(self.txtSeparacion, self.txtSeparacion.GetId(), self.calculoFactorAgrupacion)
        panel.insertaElemento(self.txtSeparacion)
        panel.insertaElemento(Etiqueta(panel, 'N\xfamero de cables o ternas de la zanja'))
        self.txtNumero = Combo(panel, ['2',
         '3',
         '4',
         '5',
         '6',
         '8',
         '10',
         '12'])
        EVT_COMBOBOX(self.txtNumero, self.txtNumero.GetId(), self.calculoFactorAgrupacion)
        panel.insertaElemento(self.txtNumero)
        panel.insertaElemento(Etiqueta(panel, 'Factor de correcci\xf3n'))
        self.txtFactorAgrupacion = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtFactorAgrupacion, self.calcularCoeficiente)
        self.txtFactorAgrupacion.ponTexto(1)
        panel.insertaElemento(self.txtFactorAgrupacion)
        panel.cerrarPanel()
        return panel



    def calculoFactorAgrupacion(self, event):
        if (self.txtSeparacion.dameValor() == ''):
            return 
        if (self.txtNumero.dameValor() == ''):
            return 
        fila1 = [0.80000000000000004,
         0.69999999999999996,
         0.64000000000000001,
         0.59999999999999998,
         0.56000000000000005,
         0.53000000000000003,
         0.5,
         0.46999999999999997]
        fila2 = [0.84999999999999998,
         0.75,
         0.68000000000000005,
         0.64000000000000001,
         0.59999999999999998,
         0.56000000000000005,
         0.53000000000000003,
         0.5]
        fila3 = [0.84999999999999998,
         0.76000000000000001,
         0.68999999999999995,
         0.65000000000000002,
         0.62,
         0.57999999999999996,
         0.55000000000000004,
         0.53000000000000003]
        fila4 = [0.87,
         0.77000000000000002,
         0.71999999999999997,
         0.68000000000000005,
         0.66000000000000003,
         0.62,
         0.58999999999999997,
         0.56999999999999995]
        fila5 = [0.88,
         0.79000000000000004,
         0.73999999999999999,
         0.69999999999999996,
         0.68000000000000005,
         0.64000000000000001,
         0.62,
         0.59999999999999998]
        fila6 = [0.89000000000000001,
         0.80000000000000004,
         0.76000000000000001,
         0.71999999999999997,
         0.69999999999999996,
         0.66000000000000003,
         0.64000000000000001,
         0.62]
        tabla = [fila1,
         fila2,
         fila3,
         fila4,
         fila5,
         fila6]
        self.txtFactorAgrupacion.ponTexto(tabla[self.txtSeparacion.GetSelection()][self.txtNumero.GetSelection()])
        self.calcularCoeficiente(event)



    def dibujaCablesEnterrados(self):
        panel = Panel(self.panel, 0, 6)
        panel.insertaElemento(Etiqueta(panel, 'Profundidad de instalaci\xf3n (m)'))
        self.txtProfundidad = Combo(panel, ['0.4',
         '0.5',
         '0.6',
         '0.7',
         '0.8',
         '0.9',
         '1',
         '1.20'])
        EVT_COMBOBOX(self.txtProfundidad, self.txtProfundidad.GetId(), self.calculoFactorCablesEnterrados)
        panel.insertaElemento(self.txtProfundidad)
        panel.insertaElemento(Etiqueta(panel, 'Factor de correcci\xf3n'))
        self.txtFactorCables = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtFactorCables, self.calcularCoeficiente)
        self.txtFactorCables.ponTexto(1)
        panel.insertaElemento(self.txtFactorCables)
        panel.cerrarPanel()
        return panel



    def calculoFactorCablesEnterrados(self, event):
        if (self.txtProfundidad.dameValor() == ''):
            return 
        fila = [1.03,
         1.02,
         1.01,
         1,
         0.98999999999999999,
         0.97999999999999998,
         0.96999999999999997,
         0.94999999999999996]
        self.txtFactorCables.ponTexto(fila[self.txtProfundidad.GetSelection()])
        self.calcularCoeficiente(event)



    def dibujaBotones(self):
        panel = Panel(self.panel, 0, 4)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.insertaElemento(Boton(panel, 'Aceptar', self.aceptarCoeficiente, 'aceptar'))
        panel.insertaElemento(Boton(panel, 'Cancelar', self.cancelarCoeficiente, 'cancelar'))
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.creceColumna(0)
        panel.creceColumna(3)
        panel.cerrarPanel()
        return panel



    def calcularCoeficiente(self, event):
        self.coeficiente = (((self.txtFactorTemperatura.dameValor() * self.txtFactorResistividad.dameValor()) * self.txtFactorAgrupacion.dameValor()) * self.txtFactorCables.dameValor())
        self.etiquetaFactorCorreccion.ponTexto(('Factor de Correcci\xf3n = ' + str(self.coeficiente)))



    def aceptarCoeficiente(self, event):
        self.destino.ponTexto(float(self.coeficiente))
        self.cancelarCoeficiente(event)



    def cancelarCoeficiente(self, event):
        self.MakeModal(0)
        self.Close()



class CoeficienteAireSubterraneas(Ventana):
    __module__ = __name__

    def __init__(self, padre, destino, aislamiento, fase):
        Ventana.__init__(self, 'Coeficiente de c\xe1lculo para L\xednea Subterr\xe1nea al aire', padre)
        self.padre = padre
        self.destino = destino
        self.aislamiento = aislamiento
        self.fase = fase
        self.coeficiente = 1
        self.renovacion = ''
        self.panel = Panel(self, 9, 0)
        self.etiqueta = Etiqueta(self.panel, 'Temperatura ambiente distinta de 40 (\xbaC)')
        self.etiqueta.ponNegrita()
        self.panel.insertaElemento(self.etiqueta)
        self.pregunta = CajaRadio(self.panel, 'Eficaz renovaci\xf3n de aire', ['Si',
         'No'])
        self.panel.insertaElemento(self.pregunta.dibujaCajaRadio(self.calculoFactorRenovacion))
        self.pregunta.radios[0].SetValue(1)
        self.panel.insertaElemento(self.dibujaTemperaturaServicio())
        if (self.fase == 1):
            self.etiqueta = Etiqueta(self.panel, 'Factor de correcci\xf3n para agrupaciones de cables unipolares')
            self.etiqueta.ponNegrita()
            self.panel.insertaElemento(self.etiqueta)
            self.panel.insertaElemento(self.dibujaUnipolar())
            self.etiqueta = Etiqueta(self.panel, 'Factor de correcci\xf3n para agrupaciones de cables trif\xe1sicos')
            self.etiqueta.ponNegrita()
            self.panel.insertaElemento(self.etiqueta)
            self.panel.insertaElemento(self.dibujaTrifasico())
        self.etiquetaFactorCorreccion = Etiqueta(self.panel, 'Factor de Correcci\xf3n = 1')
        self.etiquetaFactorCorreccion.ponNegrita()
        self.panel.insertaElemento(self.etiquetaFactorCorreccion)
        self.panel.insertaElemento(self.dibujaBotones())
        self.panel.cerrarPanel()
        if (self.fase == 1):
            self.SetSize([700,
             350])
        else:
            self.SetSize([700,
             200])
        self.hacerModal()



    def dibujaTemperaturaServicio(self):
        panel = Panel(self.panel, 0, 6)
        panel.insertaElemento(Etiqueta(panel, 'Temperatura de Servicio (\xbaC)'))
        self.txtTemperaturaServicio = Combo(panel, ['90',
         '70'])
        self.txtTemperaturaServicio.Enable(0)
        if (self.aislamiento == 1):
            self.txtTemperaturaServicio.SetSelection(1)
        else:
            self.txtTemperaturaServicio.SetSelection(0)
        EVT_COMBOBOX(self.txtTemperaturaServicio, self.txtTemperaturaServicio.GetId(), self.calculoFactorTemperatura)
        panel.insertaElemento(self.txtTemperaturaServicio)
        panel.insertaElemento(Etiqueta(panel, 'Temperatura Ambiente (\xbaC)'))
        self.txtTemperaturaTerreno = CampoMonetario(panel, 0)
        EVT_KILL_FOCUS(self.txtTemperaturaTerreno, self.calculoFactorTemperatura)
        panel.insertaElemento(self.txtTemperaturaTerreno)
        panel.insertaElemento(Etiqueta(panel, 'Factor de correcci\xf3n'))
        self.txtFactorTemperatura = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtFactorTemperatura, self.calcularCoeficiente)
        self.txtFactorTemperatura.ponTexto(1)
        panel.insertaElemento(self.txtFactorTemperatura)
        panel.cerrarPanel()
        return panel



    def dibujaUnipolar(self):
        panel = Panel(self.panel, 2, 0)
        panelSuperior = Panel(panel, 0, 4)
        panelSuperior.insertaElemento(Etiqueta(panel, 'Tipo Bandeja'))
        lista = ['Bandejas perforadas',
         'Bandejas verticales perforadas',
         'Bandejas escalera, soporte, etc']
        self.txtTipoBandeja = Combo(panelSuperior, lista)
        EVT_COMBOBOX(self.txtTipoBandeja, self.txtTipoBandeja.GetId(), self.calculoFactorUnipolar)
        panelSuperior.insertaElemento(self.txtTipoBandeja)
        panelSuperior.insertaElemento(Etiqueta(panelSuperior, 'Separaci\xf3n entre cables'))
        lista = ['Contiguos',
         'mayor o igual que dos veces el di\xe1metro']
        self.txtSeparacion = Combo(panelSuperior, lista)
        EVT_COMBOBOX(self.txtSeparacion, self.txtSeparacion.GetId(), self.calculoFactorUnipolar)
        panelSuperior.insertaElemento(self.txtSeparacion)
        panelSuperior.cerrarPanel()
        panel.insertaElemento(panelSuperior)
        panelInferior = Panel(panel, 0, 6)
        panelInferior.insertaElemento(Etiqueta(panelInferior, 'N\xfamero Bandejas'))
        lista = ['1',
         '2',
         '3']
        self.txtNumeroBandeja = Combo(panelInferior, lista)
        EVT_COMBOBOX(self.txtNumeroBandeja, self.txtNumeroBandeja.GetId(), self.calculoFactorUnipolar)
        panelInferior.insertaElemento(self.txtNumeroBandeja)
        panelInferior.insertaElemento(Etiqueta(panelInferior, 'N\xfamero Circuitos trif\xe1sico'))
        lista = ['1',
         '2',
         '3']
        self.txtNumeroTrifasicos = Combo(panelInferior, lista)
        EVT_COMBOBOX(self.txtNumeroTrifasicos, self.txtNumeroTrifasicos.GetId(), self.calculoFactorUnipolar)
        panelInferior.insertaElemento(self.txtNumeroTrifasicos)
        panelInferior.insertaElemento(Etiqueta(panelInferior, 'Factor de correcci\xf3n'))
        self.txtFactorUnipolar = CampoMonetario(panelInferior, 2)
        EVT_KILL_FOCUS(self.txtFactorUnipolar, self.calcularCoeficiente)
        self.txtFactorUnipolar.ponTexto(1)
        panelInferior.insertaElemento(self.txtFactorUnipolar)
        panelInferior.cerrarPanel()
        panel.insertaElemento(panelInferior)
        panel.cerrarPanel()
        return panel



    def calculoFactorUnipolar(self, event):
        if (self.txtTipoBandeja.GetSelection() == -1):
            return 
        if (self.txtSeparacion.GetSelection() == -1):
            return 
        if (self.txtNumeroBandeja.GetSelection() == -1):
            return 
        if (self.txtNumeroTrifasicos.GetSelection() == -1):
            return 
        fila1 = [0.94999999999999996,
         0.90000000000000002,
         0.84999999999999998]
        fila2 = [0.94999999999999996,
         0.84999999999999998,
         0.80000000000000004]
        fila3 = [1,
         0.84999999999999998,
         0.80000000000000004]
        fila4 = [0.94999999999999996,
         0.84999999999999998]
        fila5 = [0.90000000000000002,
         0.84999999999999998]
        fila6 = [1,
         0.94999999999999996,
         0.94999999999999996]
        fila7 = [0.94999999999999996,
         0.90000000000000002,
         0.90000000000000002]
        fila8 = [0.94999999999999996,
         0.90000000000000002,
         0.84999999999999998]
        fila9 = [1,
         1,
         0.94999999999999996]
        fila10 = [0.94999999999999996,
         0.94999999999999996,
         0.90000000000000002]
        fila11 = [0.94999999999999996,
         0.90000000000000002,
         0.84999999999999998]
        fila12 = [1,
         0.90000000000000002,
         0.90000000000000002]
        fila13 = [1,
         0.90000000000000002,
         0.84999999999999998]
        fila14 = [1,
         1,
         1]
        fila15 = [0.94999999999999996,
         0.94999999999999996,
         0.94999999999999996]
        fila16 = [0.94999999999999996,
         0.94999999999999996,
         0.90000000000000002]
        bandeja1 = [fila1,
         fila2,
         fila3]
        bandeja2 = [fila4,
         fila5]
        bandeja3 = [fila6,
         fila7,
         fila8]
        bandeja4 = [fila9,
         fila10,
         fila11]
        bandeja5 = [fila12,
         fila13]
        bandeja6 = [fila14,
         fila15,
         fila16]
        bandejaPerforada1 = [bandeja1,
         bandeja2,
         bandeja3]
        bandejaPerforada2 = [bandeja4,
         bandeja5,
         bandeja6]
        tabla = [bandejaPerforada1,
         bandejaPerforada2]
        try:
            factorUnipolar = tabla[self.txtSeparacion.GetSelection()][self.txtTipoBandeja.GetSelection()][self.txtNumeroBandeja.GetSelection()][self.txtNumeroTrifasicos.GetSelection()]
            self.txtFactorUnipolar.ponTexto(factorUnipolar)
            self.calcularCoeficiente(event)
        except:
            Error(self, 'No existen valores para estos datos')



    def dibujaTrifasico(self):
        panel = Panel(self.panel, 2, 0)
        panelSuperior = Panel(panel, 0, 4)
        panelSuperior.insertaElemento(Etiqueta(panel, 'Tipo Bandeja'))
        lista = ['Bandejas perforadas',
         'Bandejas verticales perforadas',
         'Bandejas escalera, soporte, etc']
        self.txtTipoBandeja2 = Combo(panelSuperior, lista)
        EVT_COMBOBOX(self.txtTipoBandeja2, self.txtTipoBandeja2.GetId(), self.calculoFactorTrifasico)
        panelSuperior.insertaElemento(self.txtTipoBandeja2)
        panelSuperior.insertaElemento(Etiqueta(panelSuperior, 'Separaci\xf3n entre cables'))
        lista = ['Contiguos',
         'espaciados']
        self.txtSeparacion2 = Combo(panelSuperior, lista)
        EVT_COMBOBOX(self.txtSeparacion2, self.txtSeparacion2.GetId(), self.calculoFactorTrifasico)
        panelSuperior.insertaElemento(self.txtSeparacion2)
        panelSuperior.cerrarPanel()
        panel.insertaElemento(panelSuperior)
        panelInferior = Panel(panel, 0, 6)
        panelInferior.insertaElemento(Etiqueta(panelInferior, 'N\xfamero Bandejas'))
        lista = ['1',
         '2',
         '3']
        self.txtNumeroBandeja2 = Combo(panelInferior, lista)
        EVT_COMBOBOX(self.txtNumeroBandeja2, self.txtNumeroBandeja2.GetId(), self.calculoFactorTrifasico)
        panelInferior.insertaElemento(self.txtNumeroBandeja2)
        panelInferior.insertaElemento(Etiqueta(panelInferior, 'N\xfamero Circuitos trif\xe1sico'))
        lista = ['1',
         '2',
         '3',
         '4',
         '6',
         '9']
        self.txtNumeroTrifasicos2 = Combo(panelInferior, lista)
        EVT_COMBOBOX(self.txtNumeroTrifasicos2, self.txtNumeroTrifasicos2.GetId(), self.calculoFactorTrifasico)
        panelInferior.insertaElemento(self.txtNumeroTrifasicos2)
        panelInferior.insertaElemento(Etiqueta(panelInferior, 'Factor de correcci\xf3n'))
        self.txtFactorTrifasico = CampoMonetario(panelInferior, 2)
        EVT_KILL_FOCUS(self.txtFactorTrifasico, self.calcularCoeficiente)
        self.txtFactorTrifasico.ponTexto(1)
        panelInferior.insertaElemento(self.txtFactorTrifasico)
        panelInferior.cerrarPanel()
        panel.insertaElemento(panelInferior)
        panel.cerrarPanel()
        return panel



    def calculoFactorTrifasico(self, event):
        if (self.txtTipoBandeja2.GetSelection() == -1):
            return 
        if (self.txtSeparacion2.GetSelection() == -1):
            return 
        if (self.txtNumeroBandeja2.GetSelection() == -1):
            return 
        if (self.txtNumeroTrifasicos2.GetSelection() == -1):
            return 
        fila1 = [1,
         0.90000000000000002,
         0.80000000000000004,
         0.80000000000000004,
         0.75,
         0.75]
        fila2 = [1,
         0.84999999999999998,
         0.80000000000000004,
         0.75,
         0.75,
         0.69999999999999996]
        fila3 = [1,
         0.84999999999999998,
         0.80000000000000004,
         0.75,
         0.69999999999999996,
         0.65000000000000002]
        fila4 = [1,
         1,
         1,
         0.94999999999999996,
         0.90000000000000002]
        fila5 = [1,
         1,
         0.94999999999999996,
         0.90000000000000002,
         0.84999999999999998]
        fila6 = [1,
         1,
         0.94999999999999996,
         0.90000000000000002,
         0.84999999999999998]
        fila7 = [1,
         0.90000000000000002,
         0.80000000000000004,
         0.75,
         0.75,
         0.69999999999999996]
        fila8 = [1,
         0.90000000000000002,
         0.80000000000000004,
         0.75,
         0.69999999999999996,
         0.69999999999999996]
        fila9 = [1,
         0.90000000000000002,
         0.90000000000000002,
         0.90000000000000002,
         0.84999999999999998]
        fila10 = [1,
         0.90000000000000002,
         0.90000000000000002,
         0.84999999999999998,
         0.84999999999999998]
        fila11 = [1,
         0.84999999999999998,
         0.80000000000000004,
         0.80000000000000004,
         0.80000000000000004,
         0.80000000000000004]
        fila12 = [1,
         0.84999999999999998,
         0.80000000000000004,
         0.80000000000000004,
         0.75,
         0.75]
        fila13 = [1,
         0.84999999999999998,
         0.80000000000000004,
         0.75,
         0.75,
         0.69999999999999996]
        fila14 = [1,
         1,
         1,
         1,
         1]
        fila15 = [1,
         1,
         1,
         0.94999999999999996,
         0.94999999999999996]
        fila16 = [1,
         1,
         0.94999999999999996,
         0.94999999999999996,
         0.75]
        bandeja1 = [fila1,
         fila2,
         fila3]
        bandeja2 = [fila4,
         fila5,
         fila6]
        bandeja3 = [fila7,
         fila8]
        bandeja4 = [fila9,
         fila10]
        bandeja5 = [fila11,
         fila12,
         fila13]
        bandeja6 = [fila14,
         fila15,
         fila16]
        bandejaPerforada1 = [bandeja1,
         bandeja2]
        bandejaPerforada2 = [bandeja3,
         bandeja4]
        bandejaPerforada3 = [bandeja5,
         bandeja6]
        tabla = [bandejaPerforada1,
         bandejaPerforada2,
         bandejaPerforada3]
        try:
            factorTrifasico = tabla[self.txtTipoBandeja2.GetSelection()][self.txtSeparacion2.GetSelection()][self.txtNumeroBandeja2.GetSelection()][self.txtNumeroTrifasicos2.GetSelection()]
            self.txtFactorTrifasico.ponTexto(factorTrifasico)
            self.calcularCoeficiente(event)
        except:
            Error(self, 'No existen valores para estos datos')



    def calculoFactorRenovacion(self, event):
        if (self.txtTemperaturaServicio.dameValor() == ''):
            return 
        if self.pregunta.radios[1].GetValue():
            temperatura = (self.txtTemperaturaTerreno.dameValor() + 15)
            dividendo = (float(self.txtTemperaturaServicio.dameValor()) - temperatura)
            divisor = (float(self.txtTemperaturaServicio.dameValor()) - 40)
            division = (dividendo / divisor)
            import math
            resultado = math.sqrt(division)
            self.renovacion = resultado
            self.calcularCoeficiente(event)
        else:
            self.renovacion = ''



    def calculoFactorTemperatura(self, event):
        if (self.txtTemperaturaServicio.dameValor() == ''):
            return 
        if self.pregunta.radios[1].GetValue():
            temperatura = (self.txtTemperaturaTerreno.dameValor() + 15)
        else:
            temperatura = self.txtTemperaturaTerreno.dameValor()
        dividendo = (float(self.txtTemperaturaServicio.dameValor()) - temperatura)
        divisor = (float(self.txtTemperaturaServicio.dameValor()) - 40)
        division = (dividendo / divisor)
        import math
        resultado = math.sqrt(division)
        self.txtFactorTemperatura.ponTexto(resultado)
        self.calcularCoeficiente(event)



    def dibujaBotones(self):
        panel = Panel(self.panel, 0, 4)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.insertaElemento(Boton(panel, 'Aceptar', self.aceptarCoeficiente, 'aceptar'))
        panel.insertaElemento(Boton(panel, 'Cancelar', self.cancelarCoeficiente, 'cancelar'))
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.creceColumna(0)
        panel.creceColumna(3)
        panel.cerrarPanel()
        return panel



    def calcularCoeficiente(self, event):
        try:
            self.coeficiente = ((self.txtFactorTemperatura.dameValor() * self.txtFactorUnipolar.dameValor()) * self.txtFactorTrifasico.dameValor())
        except:
            self.coeficiente = self.txtFactorTemperatura.dameValor()
        if (not (self.renovacion == '')):
            self.coeficiente = (self.coeficiente * self.renovacion)
        self.etiquetaFactorCorreccion.ponTexto(('Factor de Correcci\xf3n = ' + str(self.coeficiente)))



    def aceptarCoeficiente(self, event):
        self.destino.ponTexto(float(self.coeficiente))
        self.cancelarCoeficiente(event)



    def cancelarCoeficiente(self, event):
        self.MakeModal(0)
        self.Close()



class CoeficienteFacil(Ventana):
    __module__ = __name__

    def __init__(self, padre, titulo, destino):
        Ventana.__init__(self, titulo, padre)
        self.destino = destino
        self.coeficiente = 1
        self.panel = Panel(self, 8, 0)
        self.panel.insertaElemento(self.dibujaSimultaneidad())
        self.panel.insertaElemento(self.dibujaUtilizacion())
        self.etiquetaFactorCorreccion = Etiqueta(self.panel, 'Factor de Correcci\xf3n = 1')
        self.etiquetaFactorCorreccion.ponNegrita()
        self.panel.insertaElemento(self.etiquetaFactorCorreccion)
        self.panel.insertaElemento(self.dibujaBotones())
        self.panel.cerrarPanel()
        self.SetSize([250,
         150])
        self.hacerModal()



    def dibujaSimultaneidad(self):
        panel = Panel(self.panel, 0, 2)
        panel.insertaElemento(Etiqueta(panel, 'Coeficiente de Simultaneidad'))
        self.txtSimultaneidad = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtSimultaneidad, self.calcularCoeficiente)
        self.txtSimultaneidad.ponTexto(1)
        panel.insertaElemento(self.txtSimultaneidad)
        panel.cerrarPanel()
        return panel



    def dibujaUtilizacion(self):
        panel = Panel(self.panel, 0, 2)
        panel.insertaElemento(Etiqueta(panel, 'Coeficiente de Utilizaci\xf3n'))
        self.txtUtilizacion = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtUtilizacion, self.calcularCoeficiente)
        self.txtUtilizacion.ponTexto(1)
        panel.insertaElemento(self.txtUtilizacion)
        panel.cerrarPanel()
        return panel



    def dibujaBotones(self):
        panel = Panel(self.panel, 0, 4)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.insertaElemento(Boton(panel, 'Aceptar', self.aceptarCoeficiente, 'aceptar'))
        panel.insertaElemento(Boton(panel, 'Cancelar', self.cancelarCoeficiente, 'cancelar'))
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.creceColumna(0)
        panel.creceColumna(3)
        panel.cerrarPanel()
        return panel



    def calcularCoeficiente(self, event):
        self.coeficiente = (self.txtSimultaneidad.dameValor() * self.txtUtilizacion.dameValor())
        self.etiquetaFactorCorreccion.ponTexto(('Factor de Correcci\xf3n = ' + str(self.coeficiente)))



    def aceptarCoeficiente(self, event):
        self.destino.ponTexto(float(self.coeficiente))
        self.cancelarCoeficiente(event)



    def cancelarCoeficiente(self, event):
        self.MakeModal(0)
        self.Close()



class ResistenciaCalculada(Ventana):
    __module__ = __name__

    def __init__(self, padre):
        Ventana.__init__(self, 'Datos para el c\xe1lculo de la resistencia', padre)
        self.padre = padre
        self.coeficiente = 1
        self.resistencia = 0
        self.panel = Panel(self, 8, 0)
        self.panel.insertaElemento(Etiqueta(self.panel, 'Resistividad del terreno (Ohm * m)'))
        self.panel.insertaElemento(self.dibujaCombo())
        self.panel.insertaElemento(self.dibujaElementos())
        self.etiquetaResultado = Etiqueta(self.panel, 'Resistencia (Ohm) = 0')
        self.etiquetaResultado.ponNegrita()
        self.panel.insertaElemento(self.etiquetaResultado)
        self.panel.insertaElemento(self.dibujaBotones())
        self.panel.cerrarPanel()
        self.SetSize([465,
         250])
        self.hacerModal()



    def dibujaCombo(self):
        panel = Panel(self.panel, 0, 2)
        lista = ['Terrenos pantanosos',
         'Limo',
         'Humus',
         'Turba H\xfameda',
         'Arcilla pl\xe1stica',
         'Margas y arcillas compactas',
         'Margas del jurasico',
         'Arenas arcillosas',
         'Arenas silicias',
         'Suelo pedregoso cubierto de c\xe9sped',
         'Suelo pedregoso desnudo',
         'Calizas blandas',
         'Calizas compactas',
         'calizas agrietadas',
         'Pizarra',
         'Roca de mica y cuarzo',
         'granitos y gres procedente de alteraci\xf3n',
         'granito y gres muy alterados',
         'Terrenos cultivables y f\xe9rtiles',
         'Terraplenes compactos y h\xfamedos',
         'Terraplenes cultivables poco f\xe9rtiles',
         'Arenas secas permeables']
        self.txtListaTerrenos = Combo(panel, lista)
        EVT_COMBOBOX(self.txtListaTerrenos, self.txtListaTerrenos.GetId(), self.dameResistividad)
        panel.insertaElemento(self.txtListaTerrenos)
        self.txtResistividad = CampoMonetario(panel, 0)
        self.txtResistividad.Enable(0)
        EVT_KILL_FOCUS(self.txtResistividad, self.comprobarResistividad)
        panel.insertaElemento(self.txtResistividad)
        panel.cerrarPanel()
        return panel



    def dameResistividad(self, event):
        lista = [2,
         20,
         10,
         5,
         50,
         100,
         30,
         50,
         200,
         300,
         1500,
         100,
         1000,
         500,
         50,
         800,
         1500,
         100,
         50,
         500,
         3000]
        listaMaximo = [30,
         100,
         150,
         100,
         50,
         200,
         40,
         500,
         3000,
         5000,
         3000,
         300,
         5000,
         1000,
         300,
         800,
         10000,
         600,
         50,
         500,
         3000]
        activo = [1,
         1,
         1,
         1,
         0,
         1,
         1,
         1,
         1,
         1,
         1,
         1,
         1,
         1,
         1,
         0,
         1,
         1,
         0,
         0,
         0]
        self.txtResistividad.ponTexto(((listaMaximo[self.txtListaTerrenos.GetSelection()] + lista[self.txtListaTerrenos.GetSelection()]) / 2))
        self.txtResistividad.Enable(activo[self.txtListaTerrenos.GetSelection()])
        self.calculaResistencia(event)



    def comprobarResistividad(self, event):
        listaMinimo = [2,
         20,
         10,
         5,
         50,
         100,
         30,
         50,
         200,
         300,
         1500,
         100,
         1000,
         500,
         50,
         800,
         1500,
         100,
         50,
         500,
         3000]
        listaMaximo = [30,
         100,
         150,
         100,
         50,
         200,
         40,
         500,
         3000,
         5000,
         3000,
         300,
         5000,
         1000,
         300,
         800,
         10000,
         600,
         50,
         500,
         3000]
        numero = self.txtResistividad.dameValor()
        if ((numero > listaMaximo[self.txtListaTerrenos.GetSelection()]) or (numero < listaMinimo[self.txtListaTerrenos.GetSelection()])):
            self.txtResistividad.ponTexto(listaMinimo[self.txtListaTerrenos.GetSelection()])
            Error(self, 'El n\xfamero indicado no se encuentra en un intervalo correcto')
        self.calculaResistencia(event)



    def dibujaElementos(self):
        panel = Panel(self.panel, 4, 4)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.insertaElemento(Etiqueta(panel, 'N\xfamero'))
        panel.insertaElemento(Etiqueta(panel, 'Largo / Longitud (m)'))
        panel.insertaElemento(Etiqueta(panel, 'Alto (m)'))
        panel.insertaElemento(Etiqueta(panel, 'Placa enterrada'))
        self.txtNumeroPlaca = CampoMonetario(panel, 0)
        EVT_KILL_FOCUS(self.txtNumeroPlaca, self.calculaResistencia)
        panel.insertaElemento(self.txtNumeroPlaca)
        self.txtAlto = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtAlto, self.calculaResistencia)
        panel.insertaElemento(self.txtAlto)
        self.txtLargo = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtLargo, self.calculaResistencia)
        panel.insertaElemento(self.txtLargo)
        panel.insertaElemento(Etiqueta(panel, 'Pica Vertical'))
        self.txtNumeroPicaV = CampoMonetario(panel, 0)
        EVT_KILL_FOCUS(self.txtNumeroPicaV, self.calculaResistencia)
        panel.insertaElemento(self.txtNumeroPicaV)
        self.txtLongitud1 = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtLongitud1, self.calculaResistencia)
        panel.insertaElemento(self.txtLongitud1)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.insertaElemento(Etiqueta(panel, 'Conductor Horizontal'))
        self.txtNumeroPicaH = CampoMonetario(panel, 0)
        panel.insertaElemento(self.txtNumeroPicaH)
        EVT_KILL_FOCUS(self.txtNumeroPicaH, self.calculaResistencia)
        self.txtLongitud2 = CampoMonetario(panel, 2)
        panel.insertaElemento(self.txtLongitud2)
        EVT_KILL_FOCUS(self.txtLongitud2, self.calculaResistencia)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.cerrarPanel()
        return panel



    def dibujaBotones(self):
        panel = Panel(self.panel, 0, 4)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.insertaElemento(Boton(panel, 'Aceptar', self.aceptarResistencia, 'aceptar'))
        panel.insertaElemento(Boton(panel, 'Cancelar', self.cancelarResistencia, 'cancelar'))
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.creceColumna(0)
        panel.creceColumna(3)
        panel.cerrarPanel()
        return panel



    def calculaResistencia(self, event):
        if (self.txtListaTerrenos.GetSelection() == -1):
            return 
        try:
            self.resistencia = (1 / ((self.dameResistenciaPlaca() + self.dameResistenciaPicaV()) + self.dameResistenciaPicaH()))
        except:
            self.resistencia = 0
        self.etiquetaResultado.ponTexto(('Resistencia (Ohm) = ' + str(self.resistencia)))



    def dameResistenciaPlaca(self):
        suma = 0
        for r in range(self.txtNumeroPlaca.dameValor()):
            try:
                res = ((0.80000000000000004 * self.txtResistividad.dameValor()) / ((self.txtLargo.dameValor() * self.txtAlto.dameValor()) * 2))
                suma = (suma + (1 / res))
            except:
                pass

        return suma



    def dameResistenciaPicaV(self):
        suma = 0
        for r in range(self.txtNumeroPicaV.dameValor()):
            try:
                res = (self.txtResistividad.dameValor() / self.txtLongitud1.dameValor())
                suma = (suma + (1 / res))
            except:
                pass

        return suma



    def dameResistenciaPicaH(self):
        suma = 0
        for r in range(self.txtNumeroPicaH.dameValor()):
            try:
                res = ((2 * self.txtResistividad.dameValor()) / self.txtLongitud2.dameValor())
                suma = (suma + (1 / res))
            except:
                pass

        return suma



    def aceptarResistencia(self, event):
        cadena = self.dameCadenaResistencia()
        self.padre.objeto.txtTomaTierra.ponTexto(cadena)
        self.padre.objeto.txtResistencia.ponTexto(self.resistencia)
        self.cancelarResistencia(event)



    def dameCadenaResistencia(self):
        cadena = ''
        numeroPlaca = self.txtNumeroPlaca.dameValor()
        cadenaPlaca = ''
        if (numeroPlaca > 0):
            cadenaPlaca = (str(numeroPlaca) + ' Placa/s Enterrada/s')
        numeroPicaV = self.txtNumeroPicaV.dameValor()
        cadenaPicaV = ''
        if (numeroPicaV > 0):
            cadenaPicaV = (str(numeroPicaV) + ' Pica/s Vertical/es')
        numeroPicaH = self.txtNumeroPicaH.dameValor()
        cadenaPicaH = ''
        if (numeroPicaH > 0):
            cadenaPicaH = (str(numeroPicaH) + ' Conductor/es Horizontal/es')
        if (not (cadenaPlaca == '')):
            cadena = cadenaPlaca
        if ((not (cadena == '')) and (not (cadenaPicaV == ''))):
            if (cadenaPicaH == ''):
                cadena = (cadena + ' y ')
            else:
                cadena = (cadena + ' , ')
        if (not (cadenaPicaV == '')):
            cadena = (cadena + cadenaPicaV)
        if ((not (cadena == '')) and (not (cadenaPicaH == ''))):
            cadena = (cadena + ' y ')
        if (not (cadenaPicaH == '')):
            cadena = (cadena + cadenaPicaH)
        return cadena



    def cancelarResistencia(self, event):
        self.MakeModal(0)
        self.Close()



class NumeroDiferenciales(Ventana):
    __module__ = __name__

    def __init__(self, padre, dato, Numero = false):
        Ventana.__init__(self, 'N\xfamero de diferenciales', padre)
        self.padre = padre
        self.dato = dato
        self.panel = Panel(self, 2, 0)
        self.panel.insertaElemento(self.dibujaNumero())
        self.panel.insertaElemento(self.dibujaBotones())
        self.panel.creceColumna(0)
        self.panel.cerrarPanel()
        self.SetSize([250,
         100])
        self.hacerModal()



    def dibujaNumero(self):
        panel = Panel(self.panel, 0, 2)
        panel.insertaElemento(Etiqueta(panel, 'N\xfamero de Diferenciales'))
        self.txtNumeroDiferenciales = CampoMonetario(panel, 0)
        self.txtNumeroDiferenciales.ponTexto(self.dato.numDiferenciales)
        panel.insertaElemento(self.txtNumeroDiferenciales)
        panel.cerrarPanel()
        return panel



    def dibujaBotones(self):
        panel = Panel(self.panel, 0, 4)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.insertaElemento(Boton(panel, 'Datos Esquema', self.asignarCircuitos, 'aceptar'))
        panel.insertaElemento(Boton(panel, 'Cancelar', self.cancelarCircuitos, 'cancelar'))
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.creceColumna(0)
        panel.creceColumna(3)
        panel.cerrarPanel()
        return panel



    def asignarCircuitos(self, event):
        numero = self.dato.numeroCircuitos()
        max = numero
        min = (numero / 5)
        modulo = (numero % 5)
        if (not (modulo == 0)):
            min = (min + 1)
        numeroDif = self.txtNumeroDiferenciales.dameValor()
        if ((numeroDif > max) or (numeroDif < min)):
            Error(self, ((('El n\xfamero de diferenciales tiene que estar entre ' + str(max)) + ' y ') + str(min)))
        else:
            self.dato.numDiferenciales = numeroDif
            self.cancelarCircuitos(event)
            AsignarCircuitos(self.padre, self.dato)



    def cancelarCircuitos(self, event):
        self.MakeModal(0)
        self.Close()



class AsignarCircuitos(Ventana):
    __module__ = __name__

    def __init__(self, padre, dato):
        Ventana.__init__(self, 'Datos para el esquema unifilar', padre)
        self.padre = padre
        self.dato = dato
        self.circuitos = self.dato.dameCircuitos()
        self.resultadoCircuitos = []
        self.textoCircuitos = []
        self.comboPolos = []
        self.listaDiferenciales = self.dameListaDiferenciales(self.dato.numDiferenciales)
        self.listaDiferenciales.append('Dom\xf3tica')
        self.panel = Panel(self, 2, 0)
        self.panel.insertaElemento(self.dibujaPanelCircuitos())
        self.panel.insertaElemento(self.dibujaBotones())
        self.panel.creceColumna(0)
        self.panel.cerrarPanel()
        tamanio = self.GetBestSize()
        tamanio[1] = (tamanio[1] + 30)
        tamanio[0] = (tamanio[0] + 100)
        self.SetSize(tamanio)
        self.hacerModal()



    def dibujaPanelCircuitos(self):
        panel = Panel(self.panel, (len(self.circuitos) + 1), 4)
        etiqueta = Etiqueta(panel, 'Circuito')
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        etiqueta = Etiqueta(panel, 'Descripci\xf3n')
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        etiqueta = Etiqueta(panel, 'Diferencial Asignado')
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        etiqueta = Etiqueta(panel, 'Numero de Polos del Automatico')
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        for circuito in self.circuitos:
            panel.insertaElemento(Etiqueta(panel, circuito.nombre))
            texto = AreaTexto(panel)
            texto.ponTexto(circuito.descripcion)
            self.textoCircuitos.append(texto)
            panel.insertaElemento(texto)
            combo = Combo(panel, self.listaDiferenciales)
            if (len(self.listaDiferenciales) == 1):
                combo.SetSelection(0)
            else:
                try:
                    combo.seleccionaValor(circuito.diferencial)
                except:
                    pass
            self.resultadoCircuitos.append(combo)
            panel.insertaElemento(combo)
            comboPolos = Combo(panel, ['Unipolar + N',
             'Bipolar',
             'Tripolar',
             'Tetrapolar'])
            try:
                comboPolos.seleccionaValor(circuito.polos)
            except:
                pass
            self.comboPolos.append(comboPolos)
            panel.insertaElemento(comboPolos)

        panel.creceColumna(1)
        panel.cerrarPanel()
        return panel



    def dameListaDiferenciales(self, numero):
        lista = []
        for i in range(numero):
            lista.append(('Diferencial ' + str((i + 1))))

        return lista



    def dibujaBotones(self):
        panel = Panel(self.panel, 0, 4)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.insertaElemento(Boton(panel, 'Aceptar', self.aceptarAsignacion, 'aceptar'))
        panel.insertaElemento(Boton(panel, 'Cancelar', self.cancelarAsignacion, 'cancelar'))
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.creceColumna(0)
        panel.creceColumna(3)
        panel.cerrarPanel()
        return panel



    def aceptarAsignacion(self, event):
        resultado = []
        for combo in self.resultadoCircuitos:
            if (combo.GetSelection() == -1):
                Error(self, 'Debe asignar todos los circuitos')
                return 
            else:
                resultado.append(combo.dameValor())

        polos = []
        for combo in self.comboPolos:
            if (combo.GetSelection() == -1):
                Error(self, 'Debe asignar el n\xfamero de polos al autom\xe1tico')
                return 
            else:
                polos.append(combo.dameValor())

        textos = []
        for texto in self.textoCircuitos:
            textos.append(texto.dameValor())

        self.dato.esquema = EsquemaInstalacion(self.circuitos, resultado, textos, self.listaDiferenciales, polos)
        self.MakeModal(0)
        self.Close()
        VentanaDiferenciales(self.padre, self.dato)



    def cancelarAsignacion(self, event):
        self.MakeModal(0)
        self.Close()
        NumeroDiferenciales(self.padre, self.dato)



class VentanaDiferenciales(Ventana):
    __module__ = __name__

    def __init__(self, padre, dato):
        Ventana.__init__(self, 'Protecci\xf3n diferenciales', padre)
        self.resultadoCircuitos = []
        self.listaComboPolos = []
        self.esquemaInstalacion = dato.esquema
        self.dato = dato
        self.sumaDI = 0
        for diferencial in self.esquemaInstalacion.diferenciales:
            if (diferencial.nombre != 'Dom\xf3tica'):
                if (diferencial.minimaProteccion == 0):
                    diferencial.calculaMinimaProteccion()
                if (diferencial.sensibilidad == 1000):
                    diferencial.calculaSensibilidad()
                self.sumaDI += diferencial.minimaProteccion

        self.padre = padre
        self.panel = Panel(self, 3, 0)
        self.panel.insertaElemento(self.dibujaPanelDiferenciales())
        self.panel.insertaElemento(self.dibujaProteccionSobre())
        self.panel.insertaElemento(self.dibujaBotones())
        self.panel.creceColumna(0)
        self.panel.cerrarPanel()
        tamanio = self.GetBestSize()
        tamanio[1] = (tamanio[1] + 30)
        self.SetSize(tamanio)
        self.hacerModal()



    def dibujaProteccionSobre(self):
        self.checkProteccion = wxCheckBox(self.panel, -1, 'Protecci\xf3n SobreTensiones')
        self.checkProteccion.SetValue(self.esquemaInstalacion.protecciones)
        return self.checkProteccion



    def dibujaPanelDiferenciales(self):
        di = 0
        for dato in self.dato.datosCircuitos:
            if ((dato.linea == 1) and (dato.LSensibilidad != '0')):
                di = 1

        panel = Panel(self.panel, (len(self.esquemaInstalacion.diferenciales) + 1), 0)
        panelInterno = Panel(panel, 0, 3)
        panelInterno.insertaElemento(Etiqueta(panelInterno, 'Diff. General (A):'))
        comboPolos = Combo(panelInterno, ['Unipolar + neutro',
         'Bipolar',
         'Tetrapolar'])
        if (not di):
            comboPolos.Enable(0)
        EVT_COMBOBOX(comboPolos, comboPolos.GetId(), self.comboPolosSeleccionado)
        panelInterno.insertaElemento(comboPolos)
        self.listaComboPolos.append(comboPolos)
        self.txtProteccion = CampoMonetario(panelInterno, 0)
        if (not di):
            self.txtProteccion.Enable(0)
        self.resultadoCircuitos.append(self.txtProteccion)
        panelInterno.insertaElemento(self.txtProteccion)
        panelInterno.cerrarPanel()
        panel.insertaElemento(panelInterno)
        for diferencial in self.esquemaInstalacion.diferenciales:
            if (diferencial.nombre != 'Dom\xf3tica'):
                panelInterno = Panel(panel, 0, 3)
                panelInterno.insertaElemento(Etiqueta(panelInterno, (diferencial.nombre + ' (A):')))
                comboPolos = Combo(panelInterno, ['Unipolar + neutro',
                 'Bipolar',
                 'Tetrapolar'])
                EVT_COMBOBOX(comboPolos, comboPolos.GetId(), self.comboPolosSeleccionado)
                panelInterno.insertaElemento(comboPolos)
                self.listaComboPolos.append(comboPolos)
                self.txtProteccion = CampoMonetario(panelInterno, 0)
                self.resultadoCircuitos.append(self.txtProteccion)
                panelInterno.insertaElemento(self.txtProteccion)
                panelInterno.cerrarPanel()
                panel.insertaElemento(panelInterno)

        panel.cerrarPanel()
        return panel



    def comboPolosSeleccionado(self, event):
        for i in range(len(self.listaComboPolos)):
            if (not (self.listaComboPolos[i].GetSelection() == -1)):
                if (self.listaComboPolos[i].GetSelection() == 0):
                    lista = [16,
                     20,
                     25,
                     32]
                elif (self.listaComboPolos[i].GetSelection() == 1):
                    lista = [16,
                     25,
                     40,
                     63,
                     80,
                     100]
                elif (self.listaComboPolos[i].GetSelection() == 2):
                    lista = [25,
                     40,
                     63,
                     80,
                     100,
                     125]
                if (i == 0):
                    intensidad = self.dameIntensidad(lista, self.sumaDI)
                else:
                    intensidad = self.dameIntensidad(lista, self.esquemaInstalacion.diferenciales[(i - 1)].minimaProteccion)
                self.resultadoCircuitos[i].ponTexto(intensidad)




    def dameIntensidad(self, lista, diferencial):
        for i in range(len(lista)):
            if (lista[i] > diferencial):
                return lista[i]

        return lista[i]



    def dibujaBotones(self):
        panel = Panel(self.panel, 0, 4)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.insertaElemento(Boton(panel, 'Aceptar', self.aceptarAsignacion, 'aceptar'))
        panel.insertaElemento(Boton(panel, 'Cancelar', self.cancelarAsignacion, 'cancelar'))
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.creceColumna(0)
        panel.creceColumna(3)
        panel.cerrarPanel()
        return panel



    def aceptarAsignacion(self, event):
        resultado = []
        polos = {'-1': '0',
         '0': 'II',
         '1': 'II',
         '2': 'III'}
        esta = 0
        for diferencial in self.esquemaInstalacion.diferenciales:
            if (diferencial.nombre == 'Dom\xf3tica'):
                esta = 1

        if esta:
            numero = (len(self.esquemaInstalacion.diferenciales) - 1)
        else:
            numero = len(self.esquemaInstalacion.diferenciales)
        for i in range(numero):
            if (i == 0):
                polo = polos[str(self.listaComboPolos[i].GetSelection())]
                datoDiffGeneral = [self.listaComboPolos[i].GetSelection(),
                 self.resultadoCircuitos[i].dameValor(),
                 polo]
            self.esquemaInstalacion.diferenciales[i].minimaProteccion = self.resultadoCircuitos[(i + 1)].dameValor()
            self.esquemaInstalacion.diferenciales[i].poloSeleccionado = self.listaComboPolos[(i + 1)].GetSelection()
            self.esquemaInstalacion.diferenciales[i].polos = polos[str(self.listaComboPolos[(i + 1)].GetSelection())]

        self.esquemaInstalacion.protecciones = self.checkProteccion.GetValue()
        self.MakeModal(0)
        self.Close()
        VentanaEsquema(self.padre, self.esquemaInstalacion, self.dato, datoDiffGeneral)



    def cancelarAsignacion(self, event):
        self.MakeModal(0)
        self.Close()
        AsignarCircuitos(self.padre, self.dato)



class VentanaEsquema(Ventana):
    __module__ = __name__
    wxOGLInitialize()

    def __init__(self, padre, esquemaInstalacion, dato, diffGeneral):
        Ventana.__init__(self, 'Esquema Unifilar', padre, style=(((wxMINIMIZE_BOX | wxRESIZE_BORDER) | wxSYSTEM_MENU) | wxCAPTION))
        self.padre = padre
	tamanio = self.padre.GetSize()
	if tamanio[0] > 600: self.SetSize([800,700])
	else: self.SetSize([800,600])
        self.esquemaInstalacion = esquemaInstalacion
        self.dato = dato
        self.diffGeneral = diffGeneral
        self.corY = self.damePuntoMedio()
        self.corX = 70
        self.canvas = wxShapeCanvas(self)
        self.canvas.SetBackgroundColour('WHITE')
        self.diagrama = wxDiagram()
        self.canvas.SetDiagram(self.diagrama)
        self.diagrama.SetCanvas(self.canvas)
        listaDiferenciales = []
        for diferencial in self.esquemaInstalacion.diferenciales:
            if (diferencial.nombre != 'Dom\xf3tica'):
                listaCirculoVacio = []
                for circuito in diferencial.circuitos:
                    listaCirculoVacio.append(self.dibujaCircuito(circuito))
		self.corY += 12

                for i in range(len(listaCirculoVacio)):
                    if (not ((i + 1) == len(listaCirculoVacio))):
                        self.dibujaLinea(listaCirculoVacio[i], listaCirculoVacio[(i + 1)])

                listaDiferenciales.append(self.dibujaDiferencial(listaCirculoVacio, diferencial.minimaProteccion, diferencial.sensibilidad, diferencial.polos))

        dom = ''
        for diferencial in self.esquemaInstalacion.diferenciales:
            if (diferencial.nombre == 'Dom\xf3tica'):
                for circuito in diferencial.circuitos:
                    dom = self.dibujaCircuitoDomotica(circuito)


        for i in range(len(listaDiferenciales)):
            if (not ((i + 1) == len(listaDiferenciales))):
                self.dibujaLinea(listaDiferenciales[i], listaDiferenciales[(i + 1)])

        self.dibujaRaiz(listaDiferenciales)
        if (dom.__class__ != str):
            self.dibujaLinea(dom, self.raizDomotica)
	"""
	tamanio = self.padre.GetSize()
	if tamanio[0] > 600: self.SetSize([800,700])
	else: self.SetSize([800,600])
	"""
        self.hacerModal()



    def damePuntoMedio(self):
        distancia = 0
        for i in range(len(self.esquemaInstalacion.diferenciales)):
            distancia = (distancia + (40 * (len(self.esquemaInstalacion.diferenciales[i].circuitos) - 1)))

        total = self.GetClientSizeTuple()
        puntoMedio = (((total[1] - distancia) / 2) - 30)
        return puntoMedio



    def cerrarVentanaMenu(self, event):
        self.grabar()
        self.MakeModal(0)
        self.Destroy()



    def grabar(self):
        (thisScreenX, thisScreenY,) = self.canvas.GetClientSizeTuple()
        self.bitmap = wxEmptyBitmap(thisScreenX, thisScreenY)
        self.memoryCanvas = wxMemoryDC()
        self.memoryCanvas.SelectObject(self.bitmap)
        client = wxClientDC(self)
        self.memoryCanvas.Blit(0, 0, thisScreenX, thisScreenY, client, 0, 0, wxCOPY, true)
        self.image = wxImageFromBitmap(self.bitmap)
        import time
        fecha = time.strftime('%Y%m%d%H%M%S')
        nombre = (('imagenes/esquemas/E' + fecha) + '.png')
        self.image.SaveFile(nombre, wxBITMAP_TYPE_PNG)
        self.dato.ficheroEsquemaAplicacion = nombre



    def dameProteccionDI(self):
        for circuito in self.dato.datosCircuitos:
            if (circuito.linea == 1):
                return circuito.LProteccionSobre

        return '0'



    def dameIntensidadDI(self):
        for circuito in self.dato.datosCircuitos:
            if (circuito.linea == 1):
                return circuito.LSensibilidad

        return '0'



    def dibujaRaiz(self, listaDiferenciales):
        yOrigen = listaDiferenciales[0].GetY()
        yDestino = listaDiferenciales[(len(listaDiferenciales) - 1)].GetY()
        if (not (yOrigen == yDestino)):
            medio = (((yDestino - yOrigen) / 2) + yOrigen)
        else:
            medio = yOrigen
        if (not (self.padre.instalacion.contadorInstalacion == -1)):
            bp = wxBitmap('imagenes/simbolos electricos/contador2.png')
            circuloRaiz = wxBitmapShape()
            circuloRaiz.SetBitmap(bp)
            circuloRaiz.SetBrush(wxBrush('WHITE'))
        else:
            circuloRaiz = wxCircleShape(0)
        circuloRaiz.SetCanvas(self.canvas)
        circuloRaiz.SetX((self.corX - 30))
        circuloRaiz.SetY(medio)
        self.diagrama.AddShape(circuloRaiz)
        circuloRaiz.Show(True)
        bp = wxBitmap('imagenes/simbolos electricos/icp1.png')
        circuloICP = wxBitmapShape()
        circuloICP.SetBitmap(bp)
        circuloICP.SetBrush(wxBrush('WHITE'))
        circuloICP.SetCanvas(self.canvas)
        circuloICP.SetX((self.corX + 10))
        circuloICP.SetY(medio)
        self.diagrama.AddShape(circuloICP)
        circuloICP.Show(True)
        self.dibujaLinea(circuloRaiz, circuloICP)
        texto = wxTextShape(100, 40)
        texto.SetFont(wxFont(1, wxDEFAULT, wxNORMAL, wxNORMAL), texto.GetId())
        texto.AddText('ICP')
        texto.SetX((self.corX + 10))
        texto.SetY((medio + 20))
        self.diagrama.AddShape(texto)
        texto.Show(True)
        bp = wxBitmap('imagenes/simbolos electricos/Automatico5.png')
        circuloIGA = wxBitmapShape()
        circuloIGA.SetBitmap(bp)
        circuloIGA.SetBrush(wxBrush('WHITE'))
        circuloIGA.SetCanvas(self.canvas)
        circuloIGA.SetX((self.corX + 60))
        circuloIGA.SetY(medio)
        self.diagrama.AddShape(circuloIGA)
        circuloIGA.Show(True)
        self.dibujaLinea(circuloICP, circuloIGA)
        texto = wxTextShape(100, 40)
        texto.SetFont(wxFont(1, wxDEFAULT, wxNORMAL, wxNORMAL))
        texto.AddText('IGA')
        texto.SetX((self.corX + 60))
        texto.SetY((medio + 20))
        self.diagrama.AddShape(texto)
        texto.Show(True)
        texto = wxTextShape(100, 40)
        nombre = (self.dameProteccionDI() + ' A')
        if (self.padre.instalacion.tipoSuministro == 0):
            nombre = (nombre + ', II')
        elif (self.padre.instalacion.tipoSuministro == 1):
            nombre = (nombre + ', III')
        texto.SetFont(wxFont(1, wxDEFAULT, wxNORMAL, wxNORMAL))
        texto.AddText(nombre)
        texto.SetX((self.corX + 60))
        texto.SetY((medio + 40))
        self.diagrama.AddShape(texto)
        texto.Show(True)
        texto = wxTextShape(100, 40)
        texto.SetFont(wxFont(1, wxDEFAULT, wxNORMAL, wxNORMAL))
        nombre = (str(self.padre.instalacion.poderCorte) + ' kA')
        texto.AddText(nombre)
        texto.SetX((self.corX + 60))
        texto.SetY((medio + 60))
        self.diagrama.AddShape(texto)
        texto.Show(True)
        if self.esquemaInstalacion.protecciones:
            bp = wxBitmap('imagenes/simbolos electricos/Sobretensiones2.png')
            circuloPro = wxBitmapShape()
            circuloPro.SetBitmap(bp)
            circuloPro.SetBrush(wxBrush('WHITE'))
        else:
            circuloPro = wxCircleShape(0)
        circuloPro.SetCanvas(self.canvas)
        circuloPro.SetX((self.corX + 110))
        circuloPro.SetY(medio)
        self.diagrama.AddShape(circuloPro)
        circuloPro.Show(True)
        self.dibujaLinea(circuloIGA, circuloPro)
        circuloUnionDomotica = wxCircleShape(0)
        circuloUnionDomotica.SetCanvas(self.canvas)
        circuloUnionDomotica.SetX((self.corX + 130))
        circuloUnionDomotica.SetY(medio)
        self.diagrama.AddShape(circuloUnionDomotica)
        circuloUnionDomotica.Show(True)
        self.raizDomotica = circuloUnionDomotica
        if (self.diffGeneral[0] != -1):
            bp = wxBitmap('imagenes/simbolos electricos/Diferencial6.png')
            circuloDiffGen = wxBitmapShape()
            circuloDiffGen.SetBitmap(bp)
            circuloDiffGen.SetBrush(wxBrush('WHITE'))
        else:
            circuloDiffGen = wxCircleShape(0)
        circuloDiffGen.SetCanvas(self.canvas)
        circuloDiffGen.SetX((self.corX + 170))
        if (self.diffGeneral[0] != -1):
            circuloDiffGen.SetY((medio - 3))
        else:
            circuloDiffGen.SetY(medio)
        self.diagrama.AddShape(circuloDiffGen)
        circuloDiffGen.Show(True)
        self.dibujaLinea(circuloPro, circuloDiffGen)
        if (self.diffGeneral[0] != -1):
            texto = wxTextShape(100, 40)
            texto.SetFont(wxFont(1, wxDEFAULT, wxNORMAL, wxNORMAL))
            nombre = ((str(self.diffGeneral[1]) + ' A, ') + self.diffGeneral[2])
            texto.AddText(nombre)
            texto.SetX((self.corX + 170))
            texto.SetY((medio - 48))
            self.diagrama.AddShape(texto)
            texto.Show(True)
            texto = wxTextShape(100, 40)
            texto.SetFont(wxFont(1, wxDEFAULT, wxNORMAL, wxNORMAL))
            nombre = (self.dameIntensidadDI() + ' mA')
            texto.AddText(nombre)
            texto.SetX((self.corX + 170))
            texto.SetY((medio - 28))
            self.diagrama.AddShape(texto)
            texto.Show(True)
        circuloVacio = wxCircleShape(0)
        circuloVacio.SetCanvas(self.canvas)
        circuloVacio.SetX((self.corX + 210))
        circuloVacio.SetY(medio)
        self.diagrama.AddShape(circuloVacio)
        circuloVacio.Show(True)
        self.dibujaLinea(circuloDiffGen, circuloVacio)



    def dibujaDiferencial(self, listaCirculoVacio, proteccion, sensibilidad, polo):
        yOrigen = listaCirculoVacio[0].GetY()
        yDestino = listaCirculoVacio[(len(listaCirculoVacio) - 1)].GetY()
        if (not (yOrigen == yDestino)):
            medio = (((yDestino - yOrigen) / 2) + yOrigen)
        else:
            medio = yOrigen
        circuloDiferencialVacio = wxCircleShape(0)
        circuloDiferencialVacio.SetCanvas(self.canvas)
        circuloDiferencialVacio.SetX((self.corX + 290))
        circuloDiferencialVacio.SetY(medio)
        self.diagrama.AddShape(circuloDiferencialVacio)
        circuloDiferencialVacio.Show(True)
        bp = wxBitmap('imagenes/simbolos electricos/Diferencial6.png')
        circuloDiferencial = wxBitmapShape()
        circuloDiferencial.SetBitmap(bp)
        circuloDiferencial.SetBrush(wxBrush('WHITE'))
        circuloDiferencial.SetCanvas(self.canvas)
        circuloDiferencial.SetX((self.corX + 250))
        circuloDiferencial.SetY((medio - 3))
        self.diagrama.AddShape(circuloDiferencial)
        circuloDiferencial.Show(True)
        texto = wxTextShape(100, 40)
        texto.SetFont(wxFont(1, wxDEFAULT, wxNORMAL, wxNORMAL))
        nombre = ((str(proteccion) + ' A, ') + polo)
        texto.AddText(nombre)
        texto.SetX((self.corX + 250))
        texto.SetY((medio - 48))
        self.diagrama.AddShape(texto)
        texto.Show(True)
        texto = wxTextShape(100, 40)
        texto.SetFont(wxFont(1, wxDEFAULT, wxNORMAL, wxNORMAL))
        nombre = (str(sensibilidad) + ' mA')
        texto.AddText(nombre)
        texto.SetX((self.corX + 250))
        texto.SetY((medio - 28))
        self.diagrama.AddShape(texto)
        texto.Show(True)
        circuloDiferencialVacio2 = wxCircleShape(0)
        circuloDiferencialVacio2.SetCanvas(self.canvas)
        circuloDiferencialVacio2.SetX((self.corX + 210))
        circuloDiferencialVacio2.SetY(medio)
        self.diagrama.AddShape(circuloDiferencialVacio2)
        circuloDiferencialVacio2.Show(True)
        self.dibujaLinea(circuloDiferencialVacio, circuloDiferencial)
        self.dibujaLinea(circuloDiferencialVacio2, circuloDiferencial)
        return circuloDiferencialVacio2



    def dibujaCircuitoDomotica(self, circuito):
        circuloVacio = wxCircleShape(0)
        circuloVacio.SetCanvas(self.canvas)
        circuloVacio.SetX((self.corX + 130))
        circuloVacio.SetY(self.corY)
        self.diagrama.AddShape(circuloVacio)
        circuloVacio.Show(True)
        bp = wxBitmap('imagenes/simbolos electricos/Automatico5.png')
        imagenAutomatico = wxBitmapShape()
        imagenAutomatico.SetBitmap(bp)
        imagenAutomatico.SetBrush(wxBrush('WHITE'))
        imagenAutomatico.SetCanvas(self.canvas)
        imagenAutomatico.SetX((self.corX + 250))
        imagenAutomatico.SetY(self.corY)
        self.diagrama.AddShape(imagenAutomatico)
        imagenAutomatico.Show(True)
        self.dibujaLinea(circuloVacio, imagenAutomatico)
        texto = wxTextShape(100, 40)
        nombre = (circuito.datos.LProteccionSobre + ' A')
        if (circuito.polos == 'Unipolar + N'):
            nombre = (nombre + ', II')
        elif (circuito.polos == 'Bipolar'):
            nombre = (nombre + ', II')
        elif (circuito.polos == 'Tripolar'):
            nombre = (nombre + ', III')
        elif (circuito.polos == 'Tetrapolar'):
            nombre = (nombre + ', IV')
        texto.SetFont(wxFont(1, wxDEFAULT, wxNORMAL, wxNORMAL))
        texto.AddText(nombre)
        texto.SetX((self.corX + 280))
        texto.SetY((self.corY - 16))
        self.diagrama.AddShape(texto)
        texto.Show(True)
        if (circuito.datos.fase == 0):
            bp = wxBitmap('imagenes/simbolos electricos/Monofasico1.png')
        else:
            bp = wxBitmap('imagenes/simbolos electricos/Trifasico1.png')
        imagenFase = wxBitmapShape()
        imagenFase.SetBitmap(bp)
        imagenFase.SetBrush(wxBrush('WHITE'))
        imagenFase.SetCanvas(self.canvas)
        imagenFase.SetX((self.corX + 360))
        imagenFase.SetY(self.corY)
        self.diagrama.AddShape(imagenFase)
        imagenFase.Show(True)
        self.dibujaLinea(imagenAutomatico, imagenFase)
        texto = wxTextShape(100, 40)
        nombre = self.dameNombreFase(circuito.datos.LFase, circuito.datos.LSeccion, circuito.datos.material)
        texto.SetFont(wxFont(1, wxDEFAULT, wxNORMAL, wxNORMAL))
        texto.AddText(nombre)
        texto.SetX((self.corX + 330))
        texto.SetY((self.corY - 16))
        self.diagrama.AddShape(texto)
        texto.Show(True)
        bp = wxBitmap('imagenes/simbolos electricos/transformador.png')
        imagenTras = wxBitmapShape()
        imagenTras.SetBitmap(bp)
        imagenTras.SetBrush(wxBrush('WHITE'))
        imagenTras.SetCanvas(self.canvas)
        imagenTras.SetX((self.corX + 430))
        imagenTras.SetY(self.corY)
        self.diagrama.AddShape(imagenTras)
        imagenTras.Show(True)
        self.dibujaLinea(imagenFase, imagenTras)
        circuloVacio2 = wxCircleShape(0)
        circuloVacio2.SetCanvas(self.canvas)
        circuloVacio2.SetX((self.corX + 510))
        circuloVacio2.SetY(self.corY)
        self.diagrama.AddShape(circuloVacio2)
        circuloVacio2.Show(True)
        self.dibujaLinea(imagenTras, circuloVacio2)
        texto = wxTextShape(40, 40)
        texto.SetFont(wxFont(1, wxDEFAULT, wxNORMAL, wxNORMAL))
        texto.AddText(circuito.nombre)
        texto.SetX((self.corX + 530))
        texto.SetY(self.corY)
        self.diagrama.AddShape(texto)
        texto.Show(True)
        texto = wxTextShape(200, 40)
        texto.SetFont(wxFont(1, wxDEFAULT, wxNORMAL, wxNORMAL))
        texto.AddText(circuito.descripcion)
        texto.SetX((self.corX + 620))
        texto.SetY(self.corY)
        self.diagrama.AddShape(texto)
        texto.Show(True)
        self.corY = (self.corY + 40)
        return circuloVacio



    def dibujaCircuito(self, circuito):
        circuloVacio = wxCircleShape(0)
        circuloVacio.SetCanvas(self.canvas)
        circuloVacio.SetX((self.corX + 290))
        circuloVacio.SetY(self.corY)
        self.diagrama.AddShape(circuloVacio)
        circuloVacio.Show(True)
        bp = wxBitmap('imagenes/simbolos electricos/Automatico5.png')
        imagenAutomatico = wxBitmapShape()
        imagenAutomatico.SetBitmap(bp)
        imagenAutomatico.SetBrush(wxBrush('WHITE'))
        imagenAutomatico.SetCanvas(self.canvas)
        imagenAutomatico.SetX((self.corX + 330))
        imagenAutomatico.SetY(self.corY)
        self.diagrama.AddShape(imagenAutomatico)
        imagenAutomatico.Show(True)
        self.dibujaLinea(circuloVacio, imagenAutomatico)
        texto = wxTextShape(100, 40)
        nombre = (circuito.datos.LProteccionSobre + ' A')
        if (circuito.polos == 'Unipolar + N'):
            nombre = (nombre + ', II')
        elif (circuito.polos == 'Bipolar'):
            nombre = (nombre + ', II')
        elif (circuito.polos == 'Tripolar'):
            nombre = (nombre + ', III')
        elif (circuito.polos == 'Tetrapolar'):
            nombre = (nombre + ', IV')
        texto.SetFont(wxFont(1, wxDEFAULT, wxNORMAL, wxNORMAL))
        texto.AddText(nombre)
        texto.SetX((self.corX + 360))
        texto.SetY((self.corY - 16))
        self.diagrama.AddShape(texto)
        texto.Show(True)
        if (circuito.datos.fase == 0):
            bp = wxBitmap('imagenes/simbolos electricos/Monofasico1.png')
        else:
            bp = wxBitmap('imagenes/simbolos electricos/Trifasico1.png')
        imagenFase = wxBitmapShape()
        imagenFase.SetBitmap(bp)
        imagenFase.SetBrush(wxBrush('WHITE'))
        imagenFase.SetCanvas(self.canvas)
        imagenFase.SetX((self.corX + 450))
        imagenFase.SetY(self.corY)
        self.diagrama.AddShape(imagenFase)
        imagenFase.Show(True)
        self.dibujaLinea(imagenAutomatico, imagenFase)
        texto = wxTextShape(100, 40)
        nombre = self.dameNombreFase(circuito.datos.LFase, circuito.datos.LSeccion, circuito.datos.material)
        texto.SetFont(wxFont(1, wxDEFAULT, wxNORMAL, wxNORMAL))
        texto.AddText(nombre)
        texto.SetX((self.corX + 420))
        texto.SetY((self.corY - 16))
        self.diagrama.AddShape(texto)
        texto.Show(True)
        circuloVacio2 = wxCircleShape(0)
        circuloVacio2.SetCanvas(self.canvas)
        circuloVacio2.SetX((self.corX + 510))
        circuloVacio2.SetY(self.corY)
        self.diagrama.AddShape(circuloVacio2)
        circuloVacio2.Show(True)
        self.dibujaLinea(imagenFase, circuloVacio2)
        texto = wxTextShape(40, 40)
        texto.SetFont(wxFont(1, wxDEFAULT, wxNORMAL, wxNORMAL))
        texto.AddText(circuito.nombre)
        texto.SetX((self.corX + 530))
        texto.SetY(self.corY)
        self.diagrama.AddShape(texto)
        texto.Show(True)
        texto = wxTextShape(200, 40)
        texto.SetFont(wxFont(1, wxDEFAULT, wxNORMAL, wxNORMAL))
        texto.AddText(circuito.descripcion)
        texto.SetX((self.corX + 620))
        texto.SetY(self.corY)
        self.diagrama.AddShape(texto)
        texto.Show(True)
        self.corY = (self.corY + 40)
        return circuloVacio



    def dibujaLinea(self, origen, destino):
        dc = wxClientDC(self.canvas)
        self.canvas.PrepareDC(dc)
        linea = wxLineShape()
        linea.SetCanvas(self.canvas)
        linea.SetPen(wxPen(wxBLACK, 2))
        linea.MakeLineControlPoints(2)
        origen.AddLine(linea, destino)
        self.diagrama.AddShape(linea)
        linea.Show(True)
        destino.Move(dc, destino.GetX(), destino.GetY())



    def dameNombreFase(self, fase, seccion, material):
        neutro = {'25': '16',
         '35': '16',
         '50': '25',
         '70': '35',
         '95': '50',
         '120': '70',
         '150': '70',
         '185': '95',
         '240': '120',
         '300': '150',
         '400': '185'}
        seccionCadena = str(seccion)
        datos = seccionCadena.split('.')
        if (datos.__class__ == list):
            if (len(datos) == 1):
                seccionCadena = datos[0]
            elif (datos[1] == '0'):
                seccionCadena = datos[0]
        if (fase == 'II - Monof\xe1sico'):
            if (float(seccion) < 17):
                conductor = seccionCadena
            elif (float(seccion) > 35):
                conductor = str((float(seccion) / 2))
            else:
                conductor = '16'
            cadena = ((('2x' + seccionCadena) + '+') + conductor)
        else:
            if (float(seccion) < 11):
                cadena = ('4x' + seccionCadena)
            elif (float(seccion) == 16):
                if (material == 0):
                    cadena = '3x16/10'
                else:
                    cadena = '4x16'
            else:
                try:
                    cadena = ((('3x' + seccionCadena) + '/') + neutro[seccionCadena])
                except:
                    cadena = (('3x' + seccionCadena) + '/185')
            if (float(seccion) < 17):
                conductor = str(seccion)
            elif (float(seccion) > 35):
                conductor = str((float(seccion) / 2))
            else:
                conductor = '16'
            if (not (cadena[0] == '4')):
                cadena = ((cadena + '+') + conductor)
        return cadena



class CalculoIntensidadesAdmisibles(Ventana):
    __module__ = __name__

    def __init__(self, padre, dato, tab):
        Ventana.__init__(self, 'Protecci\xf3n sobre intensidades', padre)
        self.padre = padre
        self.dato = dato
        self.tab = tab
        self.panel = Panel(self, 4, 0)
        self.panel.insertaElemento(Etiqueta(self.panel, (('La potencia calculada es ' + dato.LPotenciaCalculo) + ' W ')))
        self.panel.insertaElemento(Etiqueta(self.panel, 'Seleccione una protecci\xf3n sobre intensidades'))
        self.panel.insertaElemento(self.dibujaCombo())
        self.panel.insertaElemento(self.dibujaBotones())
        self.panel.cerrarPanel()
        self.SetSize([250,
         150])
        self.hacerModal()



    def dibujaCombo(self):
        panel = Panel(self.panel, 0, 2)
        for i in range(len(self.dato.listaProtecciones)):
            self.dato.listaProtecciones[i] = str(self.dato.listaProtecciones[i])

        self.txtIntensidades = Combo(panel, self.dato.listaProtecciones)
        EVT_COMBOBOX(self.txtIntensidades, self.txtIntensidades.GetId(), self.compruebaComboIntensidades)
        self.txtIntensidades.SetSelection(0)
        panel.insertaElemento(self.txtIntensidades)
        self.numeroIntensidades = CampoMonetario(panel, 0)
        if (len(self.dato.listaProtecciones) == 0):
            self.numeroIntensidades.ponTexto(800)
        else:
            self.numeroIntensidades.ponTexto(int(self.txtIntensidades.dameValor()))
        panel.insertaElemento(self.numeroIntensidades)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def compruebaComboIntensidades(self, event):
        self.numeroIntensidades.ponTexto(int(self.txtIntensidades.dameValor()))



    def dibujaBotones(self):
        panel = Panel(self.panel, 0, 3)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.insertaElemento(Boton(panel, 'Aceptar', self.aceptarCoeficiente, 'aceptar'))
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.creceColumna(0)
        panel.creceColumna(2)
        panel.cerrarPanel()
        return panel



    def aceptarCoeficiente(self, event):
        self.dato.LProteccionSobre = str(self.numeroIntensidades.dameValor())
        self.tab.finalizaAceptar(self.dato)
        self.MakeModal(0)
        self.Close()



class ListaTitulares(Ventana):
    __module__ = __name__

    def __init__(self, padre):
        Ventana.__init__(self, 'Lista de titulares', padre)
        self.padre = padre
        panel = Panel(self, 2, 0)
        self.nombres = []
        self.dameListaTitulares()
        for i in range(len(self.resultado)):
            self.nombres.append(self.resultado[i][0])

        self.lista = ListaContenedor(panel, self.nombres)
        panel.insertaElemento(self.lista)
        panel.insertaElemento(self.dibujaBotones(panel))
        panel.creceFila(0)
        panel.creceColumna(0)
        panel.cerrarPanel()
        self.SetSize([300,
         300])
        self.hacerModal()



    def dibujaBotones(self, padre):
        panel = Panel(padre, 0, 4)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.insertaElemento(Boton(panel, 'Aceptar', self.aceptarTitular, 'aceptar'))
        panel.insertaElemento(Boton(panel, 'Cancelar', self.cancelarTitular, 'cancelar'))
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.creceColumna(0)
        panel.creceColumna(3)
        panel.cerrarPanel()
        return panel



    def dameListaTitulares(self):
        self.resultado = []
        import xml.dom.minidom
        datosXML = xml.dom.minidom.parse('datos/Titulares.xml')
        titulares = datosXML.childNodes[0]
        for titular in titulares.childNodes:
            if isinstance(titular, xml.dom.minidom.Element):
                persona = []
                persona.append(titular.getAttribute('Nombre'))
                persona.append(titular.getAttribute('DNI'))
                persona.append(titular.getAttribute('Domicilio'))
                persona.append(titular.getAttribute('Telefono'))
                persona.append(titular.getAttribute('Provincia'))
                persona.append(titular.getAttribute('Localidad'))
                persona.append(titular.getAttribute('CodigoPostal'))
                persona.append(titular.getAttribute('Correo'))
                persona.append(titular.getAttribute('IdTitular'))
                persona.append(titular.getAttribute('NombreRepresentante'))
                persona.append(titular.getAttribute('CorreoRepresentante'))
                persona.append(titular.getAttribute('DniRepresentante'))
                if (not self.estaEnResultado(titular.getAttribute('Nombre'))):
                    self.resultado.append(persona)

        self.resultado.sort()



    def estaEnResultado(self, nombre):
        for dato in self.resultado:
            if (dato[0] == nombre):
                return 1

        return 0



    def aceptarTitular(self, event):
        if (self.lista.GetSelection() == -1):
            return 
        datos = self.resultado[self.lista.GetSelection()]
        from Utilidades import Utilidades
        util = Utilidades()
        datos = util.convierteElementosISO(datos)
        self.padre.objeto.txtNombre.ponTexto(datos[0])
        self.padre.objeto.txtDNI.ponTexto(datos[1])
        self.padre.objeto.txtDomicilio.ponTexto(datos[2])
        self.padre.objeto.txtTelefono.ponTexto(datos[3])
        self.padre.objeto.txtProvincia.ponTexto(datos[4])
        self.padre.objeto.txtLocalidad.ponTexto(datos[5])
        self.padre.objeto.txtCodigoPostal.ponTexto(datos[6])
        self.padre.objeto.txtCorreo.ponTexto(datos[7])
        self.padre.instalacion.idTitular = datos[8]
        self.padre.objeto.txtNombreRepresentante.ponTexto(datos[9])
        self.padre.objeto.txtCorreoRepresentante.ponTexto(datos[10])
        self.padre.objeto.txtDNIRepresentante.ponTexto(datos[11])
        self.cancelarTitular(event)



    def cancelarTitular(self, event):
        self.MakeModal(0)
        self.Close()



class ListaRedactores(Ventana):
    __module__ = __name__

    def __init__(self, padre):
        Ventana.__init__(self, 'Lista de Redactores', padre)
        self.padre = padre
        panel = Panel(self, 2, 0)
        self.nombres = []
        self.dameListaRedactores()
        for i in range(len(self.resultado)):
            self.nombres.append(self.resultado[i][0])

        self.lista = ListaContenedor(panel, self.nombres)
        panel.insertaElemento(self.lista)
        panel.insertaElemento(self.dibujaBotones(panel))
        panel.creceFila(0)
        panel.creceColumna(0)
        panel.cerrarPanel()
        self.SetSize([300,
         300])
        self.hacerModal()



    def dibujaBotones(self, padre):
        panel = Panel(padre, 0, 4)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.insertaElemento(Boton(panel, 'Aceptar', self.aceptarRedactor, 'aceptar'))
        panel.insertaElemento(Boton(panel, 'Cancelar', self.cancelarRedactor, 'cancelar'))
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.creceColumna(0)
        panel.creceColumna(3)
        panel.cerrarPanel()
        return panel



    def dameListaRedactores(self):
        self.resultado = []
        import xml.dom.minidom
        datosXML = xml.dom.minidom.parse('datos/Redactores.xml')
        titulares = datosXML.childNodes[0]
        for titular in titulares.childNodes:
            if isinstance(titular, xml.dom.minidom.Element):
                persona = []
                persona.append(titular.getAttribute('Nombre'))
                persona.append(titular.getAttribute('DNI'))
                persona.append(titular.getAttribute('Domicilio'))
                persona.append(titular.getAttribute('Telefono'))
                persona.append(titular.getAttribute('Provincia'))
                persona.append(titular.getAttribute('Localidad'))
                persona.append(titular.getAttribute('CodigoPostal'))
                persona.append(titular.getAttribute('Correo'))
                persona.append(titular.getAttribute('Carne'))
                persona.append(titular.getAttribute('Categoria'))
                persona.append(titular.getAttribute('Registro'))
                persona.append(titular.getAttribute('Ingeniero'))
                persona.append(titular.getAttribute('IdRedactor'))
                persona.append(titular.getAttribute('NombreRepresentante'))
                persona.append(titular.getAttribute('CorreoRepresentante'))
                persona.append(titular.getAttribute('DniRepresentante'))
                persona.append(titular.getAttribute('NombreEmpresa'))
                if (not self.estaEnResultado(titular.getAttribute('Nombre'))):
                    self.resultado.append(persona)

        self.resultado.sort()



    def estaEnResultado(self, nombre):
        for dato in self.resultado:
            if (dato[0] == nombre):
                return 1

        return 0



    def aceptarRedactor(self, event):
        if (self.lista.GetSelection() == -1):
            return 
        datos = self.resultado[self.lista.GetSelection()]
        from Utilidades import Utilidades
        util = Utilidades()
        datos = util.convierteElementosISO(datos)
        self.padre.objeto.txtNombre.ponTexto(datos[0])
        self.padre.objeto.txtDNI.ponTexto(datos[1])
        self.padre.objeto.txtDomicilio.ponTexto(datos[2])
        self.padre.objeto.txtTelefono.ponTexto(datos[3])
        self.padre.objeto.txtProvincia.ponTexto(datos[4])
        self.padre.objeto.txtLocalidad.ponTexto(datos[5])
        self.padre.objeto.txtCodigoPostal.ponTexto(datos[6])
        self.padre.objeto.txtCorreo.ponTexto(datos[7])
        self.padre.objeto.txtNumeroRegistro.ponTexto(datos[10])
        self.padre.objeto.txtCarne.ponTexto(datos[8])
        self.padre.objeto.txtCategoria.ponTexto(datos[9])
        if (int(datos[11]) > -1):
            self.padre.objeto.radiosIngeniero.radios[int(datos[11])].SetValue(1)
        self.padre.instalacion.idRegistro = datos[12]
        self.padre.objeto.txtNombreRepresentante.ponTexto(datos[13])
        self.padre.objeto.txtCorreoRepresentante.ponTexto(datos[14])
        self.padre.objeto.txtDNIRepresentante.ponTexto(datos[15])
        self.padre.objeto.txtNombreEmpresa.ponTexto(datos[16])
        self.cancelarRedactor(event)



    def cancelarRedactor(self, event):
        self.MakeModal(0)
        self.Close()



class CalculoNuevaSeccion(Ventana):
    __module__ = __name__

    def __init__(self, padre, dato, tab):
        Ventana.__init__(self, 'Secci\xf3n', padre)
        self.padre = padre
        self.dato = dato
        self.tab = tab
        self.panel = Panel(self, 3, 0)
        self.panel.insertaElemento(Etiqueta(self.panel, 'Seleccione la secci\xf3n'))
        self.panel.insertaElemento(self.dibujaCombo())
        self.panel.insertaElemento(self.dibujaBotones())
        self.panel.cerrarPanel()
        self.SetSize([150,
         125])
        self.hacerModal()



    def dibujaCombo(self):
        panel = Panel(self.panel, 0, 1)
        resultado = self.dato.dameResultado()
        lista = []
        for numero in resultado:
            if (numero >= float(self.dato.LSeccion)):
                lista.append(str(numero))

        self.numeroIntensidades = Combo(panel, lista)
        panel.insertaElemento(self.numeroIntensidades)
        self.numeroIntensidades.SetSelection(0)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaBotones(self):
        panel = Panel(self.panel, 0, 3)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.insertaElemento(Boton(panel, 'Aceptar', self.aceptarCoeficiente, 'aceptar'))
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.creceColumna(0)
        panel.creceColumna(2)
        panel.cerrarPanel()
        return panel



    def aceptarCoeficiente(self, event):
        self.dato.LSeccion = self.numeroIntensidades.dameValor()
        self.dato.construyeCaidaTension()
        self.dato.construyeDensidad()
        self.MakeModal(0)
        self.Close()
        self.tab.calculaProteccionSobreIntensidad(self.dato)



class InformacionFuerzaAlumbrado(Ventana):
    __module__ = __name__

    def __init__(self, padre):
        Ventana.__init__(self, 'Informaci\xf3n', padre)
        lista = ['Usos varios : 20 puntos m\xe1ximo',
         'Cocina y ba\xf1o : 6 puntos m\xe1ximo',
         'Cocina y horno : 2 puntos m\xe1ximo']
        titulo = 'Restricci\xf3n fuerza'
        self.panel = Panel(self, 7, 0)
        etiqueta = Etiqueta(self.panel, titulo)
        etiqueta.ponNegrita()
        self.panel.insertaElemento(etiqueta)
        for texto in lista:
            self.panel.insertaElemento(Etiqueta(self.panel, texto))

        lista = ['M\xe1ximo 30 puntos de luz']
        titulo = 'Restricci\xf3n Alumbrado'
        etiqueta = Etiqueta(self.panel, titulo)
        etiqueta.ponNegrita()
        self.panel.insertaElemento(etiqueta)
        for texto in lista:
            self.panel.insertaElemento(Etiqueta(self.panel, texto))

        self.panel.insertaElemento(self.dibujaBotones())
        self.panel.cerrarPanel()
        self.SetSize([200,
         200])
        self.hacerModal()



    def dibujaBotones(self):
        panel = Panel(self.panel, 0, 3)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.insertaElemento(Boton(panel, 'Aceptar', self.aceptarCoeficiente, 'aceptar'))
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.creceColumna(0)
        panel.creceColumna(2)
        panel.cerrarPanel()
        return panel



    def aceptarCoeficiente(self, event):
        self.MakeModal(0)
        self.Close()



class ObservacionesCalculo(Ventana):
    __module__ = __name__

    def __init__(self, padre, dato):
        Ventana.__init__(self, 'Observaciones C\xe1lculos justificativos', padre)
        self.dato = dato
        self.panel = Panel(self, 2, 0)
        self.txtObservaciones = Memo(self.panel)
        self.txtObservaciones.ponTexto(self.dato.observaciones)
        self.panel.insertaElemento(self.txtObservaciones)
        self.panel.insertaElemento(self.dibujaBotones())
        self.panel.creceFila(0)
        self.panel.creceColumna(0)
        self.panel.cerrarPanel()
        self.SetSize([600,
         300])
        self.hacerModal()



    def dibujaBotones(self):
        panel = Panel(self.panel, 0, 4)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.insertaElemento(Boton(panel, 'Aceptar', self.aceptarCoeficiente, 'aceptar'))
        panel.insertaElemento(Boton(panel, 'Cancelar', self.cancelarCoeficiente, 'cancelar'))
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.creceColumna(0)
        panel.creceColumna(3)
        panel.cerrarPanel()
        return panel



    def aceptarCoeficiente(self, event):
        self.dato.observaciones = self.txtObservaciones.dameValor()
        self.MakeModal(0)
        self.Close()



    def cancelarCoeficiente(self, event):
        self.MakeModal(0)
        self.Close()



class AsignarEsquema(Ventana):
    __module__ = __name__

    def __init__(self, padre, dato):
        Ventana.__init__(self, 'Asignar Esquema unifilar a la memoria t\xe9cnica', padre)
        self.dato = dato
        self.panel = Panel(self, 3, 0)
        etiqueta = Etiqueta(self.panel, 'Esquema Unifilar')
        etiqueta.ponNegrita()
        self.panel.insertaElemento(etiqueta)
        self.panel.insertaElemento(self.dibujaRadiosEsquema())
        self.panel.insertaElemento(self.dibujaBotones())
        self.panel.creceColumna(0)
        self.panel.cerrarPanel()
        self.SetSize([600,
         170])
        self.hacerModal()
        self.cargaDatos()



    def cargaDatos(self):
        self.esquemaPropio.SetValue(self.dato.esquemaAplicacion)
        self.esquemaDibujo.SetValue(self.dato.esquemaAdjunto)
        if self.dato.esquemaAdjunto:
            self.esquemaAdjunto.ponTexto(self.dato.ficheroEsquema)
            self.esquemaAdjunto.Enable(1)
        else:
            self.esquemaAdjunto.Enable(0)



    def dibujaRadiosEsquema(self):
        panel = Panel(self.panel, 3, 0)
        self.esquemaPropio = wxRadioButton(panel, -1, 'Generado por Aplicaci\xf3n', style=wxRB_SINGLE)
        EVT_RADIOBUTTON(self.esquemaPropio, self.esquemaPropio.GetId(), self.esquemaSeleccionado)
        panel.insertaElemento(self.esquemaPropio)
        self.esquemaDibujo = wxRadioButton(panel, -1, 'Esquema adjuntado por el usuario', style=wxRB_SINGLE)
        EVT_RADIOBUTTON(self.esquemaDibujo, self.esquemaDibujo.GetId(), self.esquemaSeleccionado)
        panel.insertaElemento(self.esquemaDibujo)
        self.esquemaAdjunto = Adjuntar(panel, 'Adjunte el Fichero del esquema Unifilar')
        self.esquemaAdjunto.Enable(0)
        panel.insertaElemento(self.esquemaAdjunto)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def esquemaSeleccionado(self, event):
        if self.esquemaDibujo.GetValue():
            self.esquemaAdjunto.Enable(1)
        else:
            self.esquemaAdjunto.Enable(0)



    def dibujaBotones(self):
        panel = Panel(self.panel, 0, 4)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.insertaElemento(Boton(panel, 'Aceptar', self.aceptarCoeficiente, 'aceptar'))
        panel.insertaElemento(Boton(panel, 'Cancelar', self.cancelarCoeficiente, 'cancelar'))
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.creceColumna(0)
        panel.creceColumna(3)
        panel.cerrarPanel()
        return panel



    def aceptarCoeficiente(self, event):
        self.dato.esquemaAplicacion = self.esquemaPropio.GetValue()
        self.dato.esquemaAdjunto = self.esquemaDibujo.GetValue()
        if self.dato.esquemaAdjunto:
            self.dato.ficheroEsquema = self.esquemaAdjunto.dameValor()
        self.MakeModal(0)
        self.Close()



    def cancelarCoeficiente(self, event):
        self.MakeModal(0)
        self.Close()



class ImagenesCroquis(Ventana):
    __module__ = __name__

    def __init__(self, padre):
        Ventana.__init__(self, 'Imagenes del Croquis', padre)
        self.padre = padre
        self.panel = Panel(self, 4, 0)
        self.itemSeleccionado = ''
        self.listaImg = ListaColumna(self.panel, self.seleccionandoImagen, self.deseleccionandoImagen)
        self.listaImg.cabeceraColumnas(['Imagen'])
        self.listaImg.SetColumnWidth(0, 550)
        for imagen in self.padre.instalacion.imagenesCroquis:
            self.listaImg.Append([imagen])

        self.panel.insertaElemento(self.listaImg)
        self.panel.insertaElemento(self.dibujaBotonEliminar())
        self.panel.insertaElemento(self.dibujaAdjuntar())
        self.panel.insertaElemento(self.dibujaBotones())
        self.panel.creceColumna(0)
        self.panel.creceFila(0)
        self.panel.cerrarPanel()
        self.SetSize([600,
         300])
        self.hacerModal()



    def seleccionandoImagen(self, event):
        self.itemSeleccionado = event.m_itemIndex
        self.botonEliminar.Enable(1)



    def deseleccionandoImagen(self, event):
        self.itemSeleccionado = ''
        self.botonEliminar.Enable(0)



    def dibujaBotonEliminar(self):
        panel = Panel(self.panel, 1, 0)
        self.botonEliminar = Boton(panel, 'Eliminar', self.eliminarImagen, 'eliminar')
        self.botonEliminar.Enable(0)
        panel.insertaElemento(self.botonEliminar)
        panel.cerrarPanel()
        return panel



    def eliminarImagen(self, event):
        self.listaImg.DeleteItem(self.itemSeleccionado)



    def dibujaAdjuntar(self):
        panel = Panel(self.panel, 0, 2)
        self.txtAdjuntar = Adjuntar(panel, '')
        panel.insertaElemento(self.txtAdjuntar)
        panel.insertaElemento(Boton(panel, 'Aceptar', self.aceptaAdjuntar, 'aceptar'))
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def aceptaAdjuntar(self, event):
        ruta = self.txtAdjuntar.dameValor()
        if (ruta == ''):
            Error(self, 'No ha seleccionado ningun archivo')
            return 
        self.listaImg.Append([ruta])
        self.txtAdjuntar.ponTexto('')



    def dibujaBotones(self):
        panel = Panel(self.panel, 0, 4)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.insertaElemento(Boton(panel, 'Aceptar', self.aceptarCoeficiente, 'aceptar'))
        panel.insertaElemento(Boton(panel, 'Cancelar', self.cancelarCoeficiente, 'cancelar'))
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.creceColumna(0)
        panel.creceColumna(3)
        panel.cerrarPanel()
        return panel



    def aceptarCoeficiente(self, event):
        lista = []
        for i in range(self.listaImg.GetItemCount()):
            lista.append(self.listaImg.GetItem(i).GetText())

        self.padre.instalacion.imagenesCroquis = lista
        self.MakeModal(0)
        self.Close()



    def cancelarCoeficiente(self, event):
        self.MakeModal(0)
        self.Close()




# local variables:
# tab-width: 4
