# emacs-mode: -*- python-*-
from Interfaz import *
from Utilidades import Utilidades
from Instalacion import *
from VentanasAuxiliares import *
from InformesPDF import *
from wxPython.lib.maskedctrl import wxMaskedCtrl
import wx

class VentanaPrincipal(Ventana): #{{{
    __module__ = __name__

    def __init__(self):
        Ventana.__init__(self, 'Documentaci\xf3n para instaladores de baja tensi\xf3n - v1.3.j', style=(((wxMINIMIZE_BOX | wxRESIZE_BORDER) | wxSYSTEM_MENU) | wxCAPTION))
        self.instalacionVacia = 1
        self.caceresCP = {}
        self.badajozCP = {}
        self.coeficienteSimultaneidad = {'1': '1',
         '2': '2',
         '3': '3',
         '4': '3.8',
         '5': '4.6',
         '6': '5.4',
         '7': '6.2',
         '8': '7',
         '9': '7.8',
         '10': '8.5',
         '11': '9.2',
         '12': '9.9',
         '13': '10.6',
         '14': '11.3',
         '15': '11.9',
         '16': '12.5',
         '17': '13.1',
         '18': '13.7',
         '19': '14.3',
         '20': '14.8',
         '21': '15.3'}
        titulosMenu = ('Instalaci\xf3n',
         'Ver',
         'Ayuda')
        menu = ((0,
          'Nueva',
          'Crea una nueva instalaci\xf3n',
          0,
          1,
          self.nuevaInstalacion),
         (0,
          'Abrir',
          'Carga los datos de una instalaci\xf3n previamente guardada',
          0,
          1,
          self.abrirInstalacion),
         (0,
          'Cerrar',
          'Cierra la instalaci\xf3n con la que estemos trabajando actualmente',
          0,
          0,
          self.cerrarInstalacion),
         (0,
          'Guardar',
          'Guarda una instalaci\xf3n en disco',
          0,
          0,
          self.guardarInstalacion),
         (0,
          'Guardar como',
          'Guarda una instalaci\xf3n en disco',
          1,
          0,
          self.guardarComoInstalacion),
         (0,
          'Salir',
          'Cierra la aplicaci\xf3n',
          0,
          1,
          self.cerrarVentanaMenu),
         (1,
          'Memoria T\xe9cnica',
          'Presenta la memoria t\xe9cnica en formato pdf',
          0,
          0,
          self.mostrarMemoria),
         (1,
          'Certificado',
          'Presenta el certificado de la instalacion en formato pdf',
          0,
          0,
          self.mostrarCertificado),
         (1,
          'Declaraci\xf3n',
          'Presenta la declaraci\xf3n para el registro en formato pdf',
          0,
          0,
          self.mostrarDeclaracion),
         (1,
          'Portada',
          'Presenta la portada de la instalaci\xf3n en formato pdf',
          0,
          0,
          self.mostrarPortada),
         (2,
          'Memoria T\xe9cnica',
          'Presenta la ayuda de la memoria t\xe9cnica en formato pdf',
          0,
          1,
          self.mostrarAyudaMT),
         (2,
          'Certificado',
          'Presenta la ayuda del certificado en formato pdf',
          0,
          1,
          self.mostrarAyudaC),
         (2,
          'Declaraci\xf3n',
          'Presenta la ayuda de la declaraci\xf3n en formato pdf',
          0,
          1,
          self.mostrarAyudaD),
         (2,
          'Reglamento',
          'Presenta el reglamento en formato html',
          0,
          1,
          self.mostrarReglamento))
        self.ponMenu(titulosMenu, menu)
        self.panel = Panel(self, 0, 0)
	self.ponBarraHerramientas()
        self.ponBarraEstado()
        self.cargarCodigosPostales()
        self.Maximize()

    def toolPulsado(self,event):
	if event.GetId() == 10 : self.nuevaInstalacion(event)
	elif event.GetId() == 11 : self.abrirInstalacion(event)
	elif event.GetId() == 12 : self.guardarInstalacion(event)
	elif event.GetId() == 13 : self.mostrarMemoria(event)
	elif event.GetId() == 14 : self.mostrarCertificado(event)
	elif event.GetId() == 15 : self.mostrarDeclaracion(event)
	elif event.GetId() == 16 : self.mostrarPortada(event)
	    
    def ponBarraHerramientas(self):
	self.tb = self.CreateToolBar(wxTB_HORIZONTAL | wxTB_3DBUTTONS)
	self.tb.AddSimpleTool(10,wxImage("imagenes/barraHerramientas/nueva.png",wxBITMAP_TYPE_PNG).ConvertToBitmap(), "Nuevo")
	EVT_TOOL(self,10,self.toolPulsado)
	self.tb.AddSimpleTool(11,wxImage("imagenes/barraHerramientas/abrir.png",wxBITMAP_TYPE_PNG).ConvertToBitmap(), "abrir")
	EVT_TOOL(self,11,self.toolPulsado)
	self.tb.AddSimpleTool(12,wxImage("imagenes/barraHerramientas/guardar.png",wxBITMAP_TYPE_PNG).ConvertToBitmap(),"guardar")
	EVT_TOOL(self,12,self.toolPulsado)
	self.tb.AddSimpleTool(13,wxImage("imagenes/barraHerramientas/memoria.png",wxBITMAP_TYPE_PNG).ConvertToBitmap(),"memoria.pdf")
	EVT_TOOL(self,13,self.toolPulsado)
	self.tb.AddSimpleTool(14,wxImage("imagenes/barraHerramientas/certificado.png",wxBITMAP_TYPE_PNG).ConvertToBitmap(),"certificado.pdf")
	EVT_TOOL(self,14,self.toolPulsado)
	self.tb.AddSimpleTool(15,wxImage("imagenes/barraHerramientas/declaracion.png",wxBITMAP_TYPE_PNG).ConvertToBitmap(),"declaracion.pdf")
	EVT_TOOL(self,15,self.toolPulsado)
	self.tb.AddSimpleTool(16,wxImage("imagenes/barraHerramientas/portada.png",wxBITMAP_TYPE_PNG).ConvertToBitmap(),"portada.pdf")
	EVT_TOOL(self,16,self.toolPulsado)
	self.tb.EnableTool(10,1)	
	self.tb.EnableTool(11,1)	
	self.tb.EnableTool(12,0)	
	self.tb.EnableTool(13,0)	
	self.tb.EnableTool(14,0)	
	self.tb.EnableTool(15,0)	
	self.tb.EnableTool(16,0)	
	"""
	self.nuevaHerramienta = BotonHerramientas(tb,"",self.nuevaInstalacion,"nueva")
	tb.AddControl(self.nuevaHerramienta)
	self.abrirHerramienta = BotonHerramientas(tb,"",self.abrirInstalacion,"abrir")
	tb.AddControl(self.abrirHerramienta)
	self.guardarHerramienta = BotonHerramientas(tb,"",self.guardarInstalacion,"guardar")
	self.guardarHerramienta.Enable(0)
	tb.AddControl(self.guardarHerramienta)
	self.memoriaHerramienta = BotonHerramientas(tb,"",self.mostrarMemoria,"memoria")
	self.memoriaHerramienta.Enable(0)
	tb.AddControl(self.memoriaHerramienta)
	self.certificadoHerramienta = BotonHerramientas(tb,"",self.mostrarCertificado,"certificado")
	self.certificadoHerramienta.Enable(0)
	tb.AddControl(self.certificadoHerramienta)
	self.declaracionHerramienta = BotonHerramientas(tb,"",self.mostrarDeclaracion,"declaracion")
	self.declaracionHerramienta.Enable(0)
	tb.AddControl(self.declaracionHerramienta)
	self.portadaHerramienta = BotonHerramientas(tb,"",self.mostrarPortada,"portada")
	self.portadaHerramienta.Enable(0)
	tb.AddControl(self.portadaHerramienta)
	"""
	self.tb.Realize()



    def mostrarAyudaMT(self, event):
        try:
            import webbrowser
            webbrowser.open('ayuda/memoria.pdf')
        except:
            Error(self, 'Ocurrio un problema al abrir el documento')



    def mostrarAyudaC(self, event):
        try:
            import webbrowser
            webbrowser.open('ayuda/certificado.pdf')
        except:
            Error(self, 'Ocurrio un problema al abrir el documento')



    def mostrarAyudaD(self, event):
        try:
            import webbrowser
            webbrowser.open('ayuda/declaracion.pdf')
        except:
            Error(self, 'Ocurrio un problema al abrir el documento')



    def mostrarReglamento(self, event):
        try:
            import webbrowser
            import os
            webbrowser.open((('file://' + os.getcwd()) + '/ayuda/reglamento/Nuevo Reglamento.htm'))
        except:
            Error(self, 'Ocurrio un problema al abrir el documento')



    def mostrarMemoria(self, event):
        try:
            self.objeto.guardaDatos()
        except:
            pass
        try:
            Memoria(self.instalacion)
            import webbrowser
            webbrowser.open('datos/memoria.pdf')
        except:
            Error(self, 'El documento ya se encuentra abierto, Cierrelo y vuelva a abrir')



    def mostrarCertificado(self, event):
        try:
            self.objeto.guardaDatos()
        except:
            pass
        try:
            Certificado(self.instalacion)
            import webbrowser
            webbrowser.open('datos/certificado.pdf')
        except:
            Error(self, 'El documento ya se encuentra abierto, Cierrelo y vuelva a abrir')



    def mostrarDeclaracion(self, event):
        try:
            self.objeto.guardaDatos()
        except:
            pass
        try:
            Registro(self.instalacion)
            import webbrowser
            webbrowser.open('datos/registro.pdf')
        except:
            Error(self, 'El documento ya se encuentra abierto, Cierrelo y vuelva a abrir')



    def mostrarPortada(self, event):
        try:
            self.objeto.guardaDatos()
        except:
            pass
        try:
            Portada(self.instalacion)
            import webbrowser
            webbrowser.open('datos/portada.pdf')
        except:
            Error(self, 'El documento ya se encuentra abierto, Cierrelo y vuelva a abrir')
    
    def mostrarFondo(self):
	"""
	tamanio = self.GetSize()
	if tamanio[0] > 600: imagen = Imagen(self.panel,"imagenes/fondos/fondo1.png")
	else: imagen = Imagen(self.panel,"imagenes/fondos/fondo2.png")
	self.panel.insertaElemento(imagen)
        self.panel.creceFila(0)
        self.panel.creceColumna(1)
        self.panel.cerrarPanel()
        #self.compruebaBotonesAsistentes()
        #(self.w, self.h,) = self.panelActivo.GetSize()
	"""
	tamanio = self.GetSize()
	if tamanio[0] > 1000: imagen = Imagen(self.panel,"imagenes/fondos/fondo1.png")
	else: imagen = Imagen(self.panel,"imagenes/fondos/fondo2.png")
      



    def nuevaInstalacion(self, event):
        self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Instalaci\xf3n', 'Nueva'), 0)
        self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Instalaci\xf3n', 'Abrir'), 0)
        self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Instalaci\xf3n', 'Cerrar'), 1)
        self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Instalaci\xf3n', 'Guardar'), 1)
        self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Instalaci\xf3n', 'Guardar como'), 1)
        self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Ver', 'Memoria T\xe9cnica'), 1)
        self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Ver', 'Certificado'), 1)
        self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Ver', 'Declaraci\xf3n'), 1)
        self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Ver', 'Portada'), 1)
	self.tb.EnableTool(10,0)	
	self.tb.EnableTool(11,0)	
	self.tb.EnableTool(12,1)	
	self.tb.EnableTool(13,1)	
	self.tb.EnableTool(14,1)	
	self.tb.EnableTool(15,1)	
	self.tb.EnableTool(16,1)	
	"""
	self.nuevaHerramienta.Enable(0)
	self.abrirHerramienta.Enable(0)
	self.guardarHerramienta.Enable(1)
	self.memoriaHerramienta.Enable(1)
	self.certificadoHerramienta.Enable(1)
	self.declaracionHerramienta.Enable(1)
	self.portadaHerramienta.Enable(1)
	"""
	self.panel.DestroyChildren()
        (w, h,) = self.panel.GetClientSizeTuple()
        self.instalacion = Instalacion()
        self.instalacionVacia = 0
        import copy
        self.instalacionCopia = copy.copy(self.instalacion)
        self.panel.insertaElemento(self.panelAsistente(w, h))
        self.panel.creceFila(0)
        self.panel.creceColumna(1)
        self.panel.cerrarPanel()
        self.compruebaBotonesAsistentes()
        (self.w, self.h,) = self.panelActivo.GetSize()



    def panelAsistente(self, w, h):
        miPanel = Panel(self.panel, 0, 2)
        self.listaPasos = Arbol(miPanel, 'Instalaci\xf3n')
        self.listaPasos.ponTamanio([200,
         -1])
        self.rellenarArbol()
        EVT_TREE_SEL_CHANGED(self.listaPasos, self.listaPasos.GetId(), self.elementoListaSeleccionado)
        miPanel.insertaElemento(self.listaPasos)
        miPanel.insertaElemento(self.dameAsistente(miPanel))
        miPanel.creceFila(0)
        miPanel.creceColumna(1)
        miPanel.cerrarPanel()
        miPanel.SetSize([w,
         h])
        return miPanel



    def elementoListaSeleccionado(self, event):
        paso = self.listaPasos.GetPyData(self.listaPasos.GetSelection())
        if (not (self.listaPasos.GetItemImage(self.listaPasos.GetSelection()) == 3)):
            if paso:
                try:
                    self.objeto.guardaDatos()
                except:
                    pass
                (w, h,) = self.panelActivo.GetClientSizeTuple()
                import wx
                wx.SafeYield()
                self.panelActivo.DestroyChildren()
                self.panelActivo.sizer = wxFlexGridSizer(2, 0, 1, 1)
                self.objeto = eval((paso + '(self.panelActivo,w,h,self)'))
                self.compruebaBotonesAsistentes()
        event.Skip()



    def rellenarArbol(self):
        self.listaPasos.aniadirNodo('1. Titular de la instalaci\xf3n', 'socio', 'Paso1')
        self.listaPasos.aniadirNodo('2. Redactor de la Memoria T\xe9cnica de Dise\xf1o', 'socio', 'Paso2')
        self.listaPasos.aniadirNodo('3. Datos de la instalaci\xf3n', 'socio', 'Paso3')
        nodo4 = self.listaPasos.aniadirNodo('4. Datos de potencia instalada o prevista', 'socio', '')
        nodo41 = self.listaPasos.aniadirNodo('4.1 Relaci\xf3n nominal de receptores que se prevea instalar y su potencia', 'socio', '', nodo4)
        self.listaPasos.aniadirNodo('4.1.A Receptores de alumbrado', 'socio', 'Paso41A', nodo41)
        self.listaPasos.aniadirNodo('4.1.B Receptores de fuerza', 'socio', 'Paso41B', nodo41)
        self.listaPasos.aniadirNodo('4.1.C Resumen de Receptores', 'socio', 'Paso41C', nodo41)
        self.listaPasos.aniadirNodo('4.2 Previsi\xf3n de potencia de vivienda unifamiliar', 'socio', 'Paso42', nodo4)
        nodo43 = self.listaPasos.aniadirNodo('4.3 Carga total de edificio destinado a viviendas', 'socio', '', nodo4)
        self.listaPasos.aniadirNodo('4.3.A Datos Generales', 'socio', 'Paso43A', nodo43)
        self.listaPasos.aniadirNodo('4.3.B Viviendas', 'socio', 'Paso43B', nodo43)
        self.listaPasos.aniadirNodo('4.3.C Locales comerciales y oficinas', 'socio', 'Paso43C', nodo43)
        self.listaPasos.aniadirNodo('4.3.D Servicios generales', 'socio', 'Paso43D', nodo43)
        self.listaPasos.aniadirNodo('4.3.E Resumen', 'socio', 'Paso43E', nodo43)
        nodo44 = self.listaPasos.aniadirNodo('4.4 Ampliaciones de potencia en edificios destinados a vivienda', 'socio', '', nodo4)
        self.listaPasos.aniadirNodo('4.4.A Datos de las viviendas, locales y servicios generales', 'socio', 'Paso44A', nodo44)
        self.listaPasos.aniadirNodo('4.4.B Prevision de carga del edificio', 'socio', 'Paso44B', nodo44)
        self.listaPasos.aniadirNodo('5. Memoria descriptiva de la instalaci\xf3n', 'socio', 'Paso5')
        self.listaPasos.aniadirNodo('6. Aclaraciones a la memoria', 'socio', 'Paso6')
        self.listaPasos.aniadirNodo('7. Calculos justificativos', 'socio', 'Paso7')
        self.listaPasos.aniadirNodo('8. Esquema y Croquis', 'socio', 'Paso8')
        self.listaPasos.aniadirNodo('9. Resumen instalaci\xf3n', 'socio', 'Paso9')
        self.listaPasos.aniadirNodo('10. Datos Proyecto', 'socio', 'Paso10')
        self.listaPasos.aniadirNodo('11. Fecha y Firma', 'socio', 'Paso11')
        self.listaPasos.Expand(self.listaPasos.root)
        self.listaPasos.Expand(nodo4)
        self.listaPasos.Expand(nodo41)
        self.listaPasos.Expand(nodo43)
        self.listaPasos.Expand(nodo44)



    def dameAsistente(self, padre):
        self.panelContenedor = Panel(padre, 2, 0)
        self.panelActivo = Paso1(self.panelContenedor, clasePrincipal=self)
        self.panelContenedor.insertaElemento(self.panelActivo)
        import copy
        self.objeto = copy.copy(self.panelActivo)
        self.panelContenedor.insertaElemento(self.dibujaPanelBotones(self.panelContenedor))
        self.panelContenedor.creceColumna(0)
        self.panelContenedor.creceFila(0)
        self.panelContenedor.cerrarPanel()
        return self.panelContenedor



    def dibujaPanelBotones(self, padre):
        panel = Panel(padre, 0, 3)
        panel.insertaElemento(Etiqueta(panel, ''))
        self.botonAnterior = Boton(panel, ' << Anterior', self.pasoAnterior)
        panel.insertaElemento(self.botonAnterior)
        self.botonSiguiente = Boton(panel, 'Siguiente >>', self.pasoSiguiente)
        panel.insertaElemento(self.botonSiguiente)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def pasoAnterior(self, event):
        try:
            self.objeto.guardaDatos()
        except:
            pass
        paso = self.objeto.pasoAnterior
        (w, h,) = self.panelActivo.GetClientSizeTuple()
        import wx
        wx.SafeYield()
        self.panelActivo.DestroyChildren()
        self.panelActivo.sizer = wxFlexGridSizer(2, 0, 1, 1)
        self.objeto = eval((paso + '(self.panelActivo,w,h,self)'))
        self.compruebaBotonesAsistentes()



    def pasoSiguiente(self, event):
        try:
            self.objeto.comprobarSiguientePaso()
        except:
            pass
        paso = self.objeto.pasoSiguiente
        (w, h,) = self.panelActivo.GetClientSizeTuple()
        import wx
        wx.SafeYield()
        self.panelActivo.DestroyChildren()
        self.panelActivo.sizer = wxFlexGridSizer(2, 0, 1, 1)
        self.objeto = eval((paso + '(self.panelActivo,w,h,self)'))
        self.compruebaBotonesAsistentes()



    def abrirInstalacion(self, event):
        dialogo = VentanaAbrirFichero(self)
        dialogo.ShowModal()
        nombre = dialogo.GetPath()
        self.instalacion = Instalacion()
        if (not (nombre == '')):
            try:
                self.instalacion.abreFichero(nombre)
            except:
                Error(self, 'Fichero no valido')
                return 
            self.instalacionVacia = 0
            self.instalacion.nombreFichero = nombre
            import copy
            self.instalacionCopia = copy.copy(self.instalacion)
	    self.panel.DestroyChildren()
            (w, h,) = self.panel.GetClientSizeTuple()
            self.panel.insertaElemento(self.panelAsistente(w, h))
            self.panel.creceFila(0)
            self.panel.creceColumna(0)
            self.panel.cerrarPanel()
            self.compruebaBotonesAsistentes()
            (self.w, self.h,) = self.panelActivo.GetSize()
            self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Instalaci\xf3n', 'Nueva'), 0)
            self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Instalaci\xf3n', 'Abrir'), 0)
            self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Instalaci\xf3n', 'Cerrar'), 1)
            self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Instalaci\xf3n', 'Guardar'), 1)
            self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Instalaci\xf3n', 'Guardar como'), 1)
            if self.instalacion.compruebaProyecto():
                self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Ver', 'Memoria T\xe9cnica'), 0)
		self.tb.EnableTool(13,0)
            else:
                self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Ver', 'Memoria T\xe9cnica'), 1)
		self.tb.EnableTool(13,1)	
            self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Ver', 'Certificado'), 1)
            self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Ver', 'Declaraci\xf3n'), 1)
            self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Ver', 'Portada'), 1)
	    self.tb.EnableTool(10,0)	
	    self.tb.EnableTool(11,0)	
	    self.tb.EnableTool(12,1)	
	    self.tb.EnableTool(14,1)	
	    self.tb.EnableTool(15,1)	
	    self.tb.EnableTool(16,1)	
	    """
	    self.nuevaHerramienta.Enable(0)
	    self.abrirHerramienta.Enable(0)
	    self.guardarHerramienta.Enable(1)
	    self.memoriaHerramienta.Enable(1)
	    self.certificadoHerramienta.Enable(1)
	    self.declaracionHerramienta.Enable(1)
	    self.portadaHerramienta.Enable(1)
	    """



    def dameSuma41(self):
        sumaAlumbrado = 0
        sumaFuerza = 0
        for receptor in self.instalacion.receptoresAlumbrado:
            sumaAlumbrado = (sumaAlumbrado + float(receptor[2]))

        for receptor in self.instalacion.receptoresFuerza:
            sumaFuerza = (sumaFuerza + float(receptor[2]))

        sumaTotal = (sumaAlumbrado + sumaFuerza)
        return sumaTotal



    def cerrarInstalacion(self, event):
        if (not (self.instalacion == self.instalacionCopia)):
            d = Confirmacion(self, 'La instalacion no ha sido guardada, \xbfDesea Guardarla?')
            if d.mostrar():
                self.guardarInstalacion(event)
        self.instalacionVacia = 1
        self.panel.DestroyChildren()
        self.panel.sizer = wxFlexGridSizer(0, 0, 1, 1)
	self.mostrarFondo()
        self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Instalaci\xf3n', 'Nueva'), 1)
        self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Instalaci\xf3n', 'Abrir'), 1)
        self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Instalaci\xf3n', 'Cerrar'), 0)
        self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Instalaci\xf3n', 'Guardar'), 0)
        self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Instalaci\xf3n', 'Guardar como'), 0)
        self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Ver', 'Memoria T\xe9cnica'), 0)
        self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Ver', 'Certificado'), 0)
        self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Ver', 'Declaraci\xf3n'), 0)
        self.GetMenuBar().Enable(self.GetMenuBar().FindMenuItem('Ver', 'Portada'), 0)
	self.tb.EnableTool(10,1)	
	self.tb.EnableTool(11,1)	
	self.tb.EnableTool(12,0)	
	self.tb.EnableTool(13,0)	
	self.tb.EnableTool(14,0)	
	self.tb.EnableTool(15,0)	
	self.tb.EnableTool(16,0)	
	"""
	self.nuevaHerramienta.Enable(1)
	self.abrirHerramienta.Enable(1)
	self.guardarHerramienta.Enable(0)
	self.memoriaHerramienta.Enable(0)
	self.certificadoHerramienta.Enable(0)
	self.declaracionHerramienta.Enable(0)
	self.portadaHerramienta.Enable(0)
	"""



    def guardarInstalacion(self, event):
        try:
            self.objeto.guardaDatos()
        except:
            pass
        if (self.instalacion.nombreFichero == ''):
            dialogo = VentanaGuardarFichero(self)
            dialogo.ShowModal()
            nombre = dialogo.GetPath()
            if (not (nombre == '')):
                self.instalacion.nombreFichero = nombre
                self.instalacion.guardaFichero(nombre)
                del self.instalacionCopia
                import copy
                self.instalacionCopia = copy.copy(self.instalacion)
        else:
            self.instalacion.guardaFichero(self.instalacion.nombreFichero)
            del self.instalacionCopia
            import copy
            self.instalacionCopia = copy.copy(self.instalacion)



    def guardarComoInstalacion(self, event):
        self.objeto.guardaDatos()
        dialogo = VentanaGuardarFichero(self)
        dialogo.ShowModal()
        nombre = dialogo.GetPath()
        if (not (nombre == '')):
	    self.instalacion.nombreFichero = nombre
            self.instalacion.guardaFichero(nombre)
            del self.instalacionCopia
            import copy
            self.instalacionCopia = copy.copy(self.instalacion)



    def cerrarVentanaMenu(self, event):
        if (not self.instalacionVacia):
            if (not (self.instalacion == self.instalacionCopia)):
                d = Confirmacion(self, 'La instalacion no ha sido guardada, \xbfDesea Guardarla?')
                if d.mostrar():
                    self.guardarInstalacion(event)
        self.MakeModal(0)
        self.Destroy()



    def compruebaBotonesAsistentes(self):
        if (self.objeto.pasoSiguiente == ''):
            self.botonSiguiente.Enable(0)
        else:
            self.botonSiguiente.Enable(1)
        if (self.objeto.pasoAnterior == ''):
            self.botonAnterior.Enable(0)
        else:
            self.botonAnterior.Enable(1)



    def cargarCodigosPostales(self):
        import xml.dom.minidom
        import os
        ficheroCP = os.path.join('datos', 'CodigosPostales.xml')
        datosXML = xml.dom.minidom.parse(ficheroCP)
        for nodoLocalidad in datosXML.childNodes[0].childNodes:
            elementos = []
            for nodoDatosLocalidad in nodoLocalidad.childNodes:
                if isinstance(nodoDatosLocalidad, xml.dom.minidom.Element):
                    elementos.append(nodoDatosLocalidad)

            try:
                pueblo = elementos[1].childNodes
                cp = elementos[2].childNodes
                nombrePueblo = pueblo[0].data
                codigoPueblo = cp[0].data
                if (codigoPueblo[0] == '1'):
                    self.caceresCP[nombrePueblo] = codigoPueblo
                else:
                    self.badajozCP[nombrePueblo] = codigoPueblo
            except:
                pass

#}}}

class Paso1(Panel): #{{{
    __module__ = __name__

    def __init__(self, padre, w = None, h = None, clasePrincipal = None):
        Panel.__init__(self, padre, 4, 0)
        self.padre = clasePrincipal
        self.pasoSiguiente = 'Paso2'
        self.pasoAnterior = ''
        self.insertaElemento(self.dibujaTitulo(self))
        self.insertaElemento(self.dibujaDatos(self))
        self.creceColumna(0)
        self.creceFila(1)
        self.cerrarPanel()
        if w:
            self.SetSize([w,
             h])
        self.cargaDatos()



    def dibujaTitulo(self, padre):
        panel = Panel(padre, 0, 3)
        centrado = Etiqueta(panel, '')
        centrado.ponEstilo(15, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(centrado)
        titulo = Etiqueta(panel, '1. TITULAR DE LA INSTALACI\xd3N')
        titulo.ponEstilo(15, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(titulo)
        panel.insertaElemento(centrado)
        panel.creceColumna(0)
        panel.creceColumna(2)
        panel.cerrarPanel()
        panel.SetBackgroundColour(wxBLUE)
        return panel



    def dibujaDatos(self, padre):
        panel = Panel(padre, 5, 0)
        panel.insertaElemento(self.dibujaBotonTitulares(panel))
        panel.insertaElemento(self.dibujaDatosNombre(panel))
        panel.insertaElemento(self.dibujaLocalidad(panel))
        panel.insertaElemento(self.dibujaCorreoElectronico(panel))
        panel.insertaElemento(self.dibujaRepresentante(panel))
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaRepresentante(self, padre):
        panel = Panel(padre, 2, 3)
        panel.insertaElemento(Etiqueta(panel, 'Representante:'))
        panel.insertaElemento(Etiqueta(panel, 'Correo:'))
        panel.insertaElemento(Etiqueta(panel, 'DNI:'))
        self.txtNombreRepresentante = AreaTexto(panel)
        panel.insertaElemento(self.txtNombreRepresentante)
        self.txtCorreoRepresentante = AreaTexto(panel)
        panel.insertaElemento(self.txtCorreoRepresentante)
        self.txtDNIRepresentante = AreaTexto(panel)
        panel.insertaElemento(self.txtDNIRepresentante)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaBotonTitulares(self, padre):
        panel = Panel(padre, 0, 2)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.insertaElemento(Boton(panel, 'Titulares', self.mostrarListaTitulares, 'usuario'))
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def mostrarListaTitulares(self, event):
        ListaTitulares(self.padre)



    def dibujaDatosNombre(self, padre):
        panel = Panel(padre, 4, 2)
        panel.insertaElemento(Etiqueta(panel, 'Nombre o Raz\xf3n social:', wxRED))
        panel.insertaElemento(Etiqueta(panel, 'D.N.I. - C.I.F.:', wxRED))
        self.txtNombre = AreaTexto(panel)
        panel.insertaElemento(self.txtNombre)
        self.txtDNI = AreaTexto(panel)
        panel.insertaElemento(self.txtDNI)
        panel.insertaElemento(Etiqueta(panel, 'Domicilio:', wxRED))
        panel.insertaElemento(Etiqueta(panel, 'Tel\xe9fono:'))
        self.txtDomicilio = AreaTexto(panel)
        panel.insertaElemento(self.txtDomicilio)
        self.txtTelefono = AreaTexto(panel)
        panel.insertaElemento(self.txtTelefono)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaLocalidad(self, padre):
        panel = Panel(padre, 2, 3)
        panel.insertaElemento(Etiqueta(panel, 'Provincia:', wxRED))
        panel.insertaElemento(Etiqueta(panel, 'Localidad:', wxRED))
        panel.insertaElemento(Etiqueta(panel, 'C\xf3digo Postal:', wxRED))
        self.txtProvincia = AreaTexto(panel)
        panel.insertaElemento(self.txtProvincia)
        self.txtLocalidad = AreaTexto(panel)
        panel.insertaElemento(self.txtLocalidad)
        self.txtCodigoPostal = AreaTexto(panel)
        panel.insertaElemento(self.txtCodigoPostal)
        panel.creceColumna(1)
        panel.cerrarPanel()
        return panel



    def dibujaCorreoElectronico(self, padre):
        panel = Panel(padre, 2, 0)
        panel.insertaElemento(Etiqueta(panel, 'Correo Electr\xf3nico:'))
        self.txtCorreo = AreaTexto(panel)
        panel.insertaElemento(self.txtCorreo)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def comprobarSiguientePaso(self):
        self.guardaDatos()



    def guardaDatos(self):
        try:
            self.padre.instalacion.nombre = self.txtNombre.dameValor()
            self.padre.instalacion.domicilio = self.txtDomicilio.dameValor()
            self.padre.instalacion.provincia = self.txtProvincia.dameValor()
            self.padre.instalacion.localidad = self.txtLocalidad.dameValor()
            self.padre.instalacion.codigoPostal = self.txtCodigoPostal.dameValor()
            self.padre.instalacion.dni = self.txtDNI.dameValor()
            self.padre.instalacion.mail = self.txtCorreo.dameValor()
            self.padre.instalacion.telefono = self.txtTelefono.dameValor()
            self.padre.instalacion.nombreRepresentante = self.txtNombreRepresentante.dameValor()
            self.padre.instalacion.correoRepresentante = self.txtCorreoRepresentante.dameValor()
            self.padre.instalacion.dniRepresentante = self.txtDNIRepresentante.dameValor()
        except:
            pass



    def cargaDatos(self):
        self.txtNombre.ponTexto(self.padre.instalacion.nombre)
        self.txtDomicilio.ponTexto(self.padre.instalacion.domicilio)
        self.txtProvincia.ponTexto(self.padre.instalacion.provincia)
        self.txtLocalidad.ponTexto(self.padre.instalacion.localidad)
        self.txtCodigoPostal.ponTexto(self.padre.instalacion.codigoPostal)
        self.txtDNI.ponTexto(self.padre.instalacion.dni)
        self.txtCorreo.ponTexto(self.padre.instalacion.mail)
        self.txtTelefono.ponTexto(self.padre.instalacion.telefono)
        self.txtNombreRepresentante.ponTexto(self.padre.instalacion.nombreRepresentante)
        self.txtCorreoRepresentante.ponTexto(self.padre.instalacion.correoRepresentante)
        self.txtDNIRepresentante.ponTexto(self.padre.instalacion.dniRepresentante)


#}}}

class Paso2(Panel): #{{{
    __module__ = __name__

    def __init__(self, padre, w, h, clasePrincipal):
        Panel.__init__(self, padre, 2, 0)
        self.padre = clasePrincipal
        self.pasoSiguiente = 'Paso3'
        self.pasoAnterior = 'Paso1'
        self.insertaElemento(self.dibujaTitulo(self))
        self.insertaElemento(self.dibujaDatos(self))
        self.creceColumna(0)
        self.cerrarPanel()
        self.SetSize([w,
         h])
        self.cargaDatos()



    def dibujaTitulo(self, padre):
        panel = Panel(padre, 0, 3)
        centrado = Etiqueta(panel, '')
        centrado.ponEstilo(15, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(centrado)
        titulo = Etiqueta(panel, '2. REDACTOR DE LA MEMORIA T\xc9CNICA DE DISE\xd1O')
        titulo.ponEstilo(15, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(titulo)
        panel.insertaElemento(centrado)
        panel.creceColumna(0)
        panel.creceColumna(2)
        panel.cerrarPanel()
        panel.SetBackgroundColour(wxBLUE)
        return panel



    def dibujaDatos(self, padre):
        panel = Panel(padre, 9, 0)
        panel.insertaElemento(self.dibujaBotonRedactores(panel))
        self.radiosIngeniero = CajaRadio(panel, 'Memoria T\xe9cnica de Dise\xf1o realizado por:', ['Instalador autorizado en baja Tensi\xf3n',
         'T\xe9cnico titulado competente'])
        panel.insertaElemento(self.radiosIngeniero.dibujaCajaRadio())
        panel.insertaElemento(self.dibujaDatosNombreEmpresa(panel))
        panel.insertaElemento(self.dibujaDatosNombre(panel))
        panel.insertaElemento(self.dibujaLocalidad(panel))
        panel.insertaElemento(self.dibujaCorreoElectronico(panel))
        panel.insertaElemento(self.dibujaNumeroCarne(panel))
        panel.insertaElemento(self.dibujaNumeroRegistro(panel))
        panel.insertaElemento(self.dibujaRepresentante(panel))
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaRepresentante(self, padre):
        panel = Panel(padre, 2, 3)
        panel.insertaElemento(Etiqueta(panel, 'Representante:'))
        panel.insertaElemento(Etiqueta(panel, 'Correo:'))
        panel.insertaElemento(Etiqueta(panel, 'DNI:'))
        self.txtNombreRepresentante = AreaTexto(panel)
        panel.insertaElemento(self.txtNombreRepresentante)
        self.txtCorreoRepresentante = AreaTexto(panel)
        panel.insertaElemento(self.txtCorreoRepresentante)
        self.txtDNIRepresentante = AreaTexto(panel)
        panel.insertaElemento(self.txtDNIRepresentante)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaDatosNombreEmpresa(self, padre):
        panel = Panel(padre, 2, 0)
        panel.insertaElemento(Etiqueta(panel, 'Nombre Empresa:', wxRED))
        self.txtNombreEmpresa = AreaTexto(panel)
        panel.insertaElemento(self.txtNombreEmpresa)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaNumeroRegistro(self, padre):
        panel = Panel(padre, 2, 0)
        panel.insertaElemento(Etiqueta(panel, 'N\xba de registro', wxRED))
        self.txtNumeroRegistro = AreaTexto(panel)
        panel.insertaElemento(self.txtNumeroRegistro)
        panel.cerrarPanel()
        return panel



    def dibujaBotonRedactores(self, padre):
        panel = Panel(padre, 0, 2)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.insertaElemento(Boton(panel, 'Redactores', self.mostrarListaRedactores, 'usuario'))
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def mostrarListaRedactores(self, event):
        ListaRedactores(self.padre)



    def dibujaDatosNombre(self, padre):
        panel = Panel(padre, 4, 2)
        panel.insertaElemento(Etiqueta(panel, 'Nombre y Apellidos:', wxRED))
        panel.insertaElemento(Etiqueta(panel, 'D.N.I.:', wxRED))
        self.txtNombre = AreaTexto(panel)
        panel.insertaElemento(self.txtNombre)
        self.txtDNI = AreaTexto(panel)
        panel.insertaElemento(self.txtDNI)
        panel.insertaElemento(Etiqueta(panel, 'Domicilio:', wxRED))
        panel.insertaElemento(Etiqueta(panel, 'Tel\xe9fono:'))
        self.txtDomicilio = AreaTexto(panel)
        panel.insertaElemento(self.txtDomicilio)
        self.txtTelefono = AreaTexto(panel)
        panel.insertaElemento(self.txtTelefono)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaLocalidad(self, padre):
        panel = Panel(padre, 2, 3)
        panel.insertaElemento(Etiqueta(panel, 'Provincia:', wxRED))
        panel.insertaElemento(Etiqueta(panel, 'Localidad:', wxRED))
        panel.insertaElemento(Etiqueta(panel, 'C\xf3digo Postal:', wxRED))
        self.txtProvincia = AreaTexto(panel)
        panel.insertaElemento(self.txtProvincia)
        self.txtLocalidad = AreaTexto(panel)
        panel.insertaElemento(self.txtLocalidad)
        self.txtCodigoPostal = AreaTexto(panel)
        panel.insertaElemento(self.txtCodigoPostal)
        panel.creceColumna(1)
        panel.cerrarPanel()
        return panel



    def dibujaCorreoElectronico(self, padre):
        panel = Panel(padre, 2, 0)
        panel.insertaElemento(Etiqueta(panel, 'Correo Electr\xf3nico:'))
        self.txtCorreo = AreaTexto(panel)
        panel.insertaElemento(self.txtCorreo)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaNumeroCarne(self, padre):
        panel = Panel(padre, 2, 2)
        panel.insertaElemento(Etiqueta(panel, 'N\xba Carn\xe9 de Instalador / N\xba Colegiado:', wxRED))
        panel.insertaElemento(Etiqueta(panel, 'Categor\xeda-Especialidad / Colegio Oficial  de:', wxRED))
        self.txtCarne = AreaTexto(panel)
        panel.insertaElemento(self.txtCarne)
        self.txtCategoria = AreaTexto(panel)
        panel.insertaElemento(self.txtCategoria)
        panel.creceColumna(1)
        panel.cerrarPanel()
        return panel



    def comprobarSiguientePaso(self):
        self.guardaDatos()



    def guardaDatos(self):
        try:
            self.padre.instalacion.Rnombre = self.txtNombre.dameValor()
            self.padre.instalacion.Rdomicilio = self.txtDomicilio.dameValor()
            self.padre.instalacion.Rprovincia = self.txtProvincia.dameValor()
            self.padre.instalacion.Rlocalidad = self.txtLocalidad.dameValor()
            self.padre.instalacion.RRegistro = self.txtNumeroRegistro.dameValor()
            self.padre.instalacion.RcodigoPostal = self.txtCodigoPostal.dameValor()
            self.padre.instalacion.Rdni = self.txtDNI.dameValor()
            self.padre.instalacion.Rmail = self.txtCorreo.dameValor()
            self.padre.instalacion.Rtelefono = self.txtTelefono.dameValor()
            self.padre.instalacion.RCarne = self.txtCarne.dameValor()
            self.padre.instalacion.RCategoria = self.txtCategoria.dameValor()
            self.padre.instalacion.RIngeniero = self.radiosIngeniero.dameElementoSeleccionado()
            self.padre.instalacion.REmpresa = self.txtNombreEmpresa.dameValor()
            self.padre.instalacion.RnombreRepresentante = self.txtNombreRepresentante.dameValor()
            self.padre.instalacion.RcorreoRepresentante = self.txtCorreoRepresentante.dameValor()
            self.padre.instalacion.RdniRepresentante = self.txtDNIRepresentante.dameValor()
        except:
            pass



    def cargaDatos(self):
        self.txtNombre.ponTexto(self.padre.instalacion.Rnombre)
        self.txtDomicilio.ponTexto(self.padre.instalacion.Rdomicilio)
        self.txtProvincia.ponTexto(self.padre.instalacion.Rprovincia)
        self.txtLocalidad.ponTexto(self.padre.instalacion.Rlocalidad)
        self.txtCodigoPostal.ponTexto(self.padre.instalacion.RcodigoPostal)
        self.txtDNI.ponTexto(self.padre.instalacion.Rdni)
        self.txtNumeroRegistro.ponTexto(self.padre.instalacion.RRegistro)
        self.txtCorreo.ponTexto(self.padre.instalacion.Rmail)
        self.txtTelefono.ponTexto(self.padre.instalacion.Rtelefono)
        self.txtCarne.ponTexto(self.padre.instalacion.RCarne)
        self.txtCategoria.ponTexto(self.padre.instalacion.RCategoria)
        if (self.padre.instalacion.RIngeniero > -1):
            self.radiosIngeniero.radios[self.padre.instalacion.RIngeniero].SetValue(1)
        self.txtNombreEmpresa.ponTexto(self.padre.instalacion.REmpresa)
        self.txtNombreRepresentante.ponTexto(self.padre.instalacion.RnombreRepresentante)
        self.txtCorreoRepresentante.ponTexto(self.padre.instalacion.RcorreoRepresentante)
        self.txtDNIRepresentante.ponTexto(self.padre.instalacion.RdniRepresentante)

#}}}

class Paso3(PanelScroll):#{{{
    __module__ = __name__

    def __init__(self, padre, w, h, clasePrincipal):
        PanelScroll.__init__(self, padre, 2, 0)
        self.padre = clasePrincipal
        self.pasoSiguiente = ''
        self.pasoAnterior = 'Paso2'
        self.insertaElemento(self.dibujaTitulo(self))
        self.insertaElemento(self.dibujaDatos(self))
        self.creceColumna(0)
        self.cerrarPanel()
        self.SetSize([w,
         h])
        self.cargaDatos()



    def dibujaTitulo(self, padre):
        panel = Panel(padre, 0, 3)
        centrado = Etiqueta(panel, '')
        centrado.ponEstilo(15, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(centrado)
        titulo = Etiqueta(panel, '3. DATOS DE LA INSTALACI\xd3N')
        titulo.ponEstilo(15, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(titulo)
        panel.insertaElemento(centrado)
        panel.creceColumna(0)
        panel.creceColumna(2)
        panel.cerrarPanel()
        panel.SetBackgroundColour(wxBLUE)
        return panel



    def dibujaDatos(self, padre):
        panel = Panel(padre, 13, 0)
        panel.insertaElemento(self.dibujaBotonCopiaTitular(panel))
        panel.insertaElemento(self.dibujaEmplazamiento(panel))
        panel.insertaElemento(self.dibujaLocalidad(panel))
        lista = ['a - Industrias en general',
         'b - Locales h\xfamedos, polvorientos o con riesgo de corrosi\xf3n',
         'b - Bombas de extracci\xf3n o elevaci\xf3n de agua',
         'c - Locales mojados',
         'c - Generadores y convertidores',
         'c - Conductores aislados para caldeo, excluye viviendas',
         'd - Temporal para maquinaria de obras',
         'd - Temporal en locales o emplazamientos abiertos',
         'e - Edificios de viviendas',
         'f - Viviendas unifamiliares',
         'g - Garajes con ventilaci\xf3n forzada',
         'h - Garajes con ventilaci\xf3n natural',
         'i - Locales de p\xfablica concurrencia',
         'j - Maquinas de elevaci\xf3n y transporte',
         'j - Las que utilicen tensiones especiales',
         'j - R\xf3tulos luminosos',
         'j - Cercas el\xe9ctricas',
         'j - Redes a\xe9reas y subterr\xe1neas de distribici\xf3n',
         'k - Instalaciones de alumbrado exterior',
         'l - Locales con riesgo de incendio y explosi\xf3n, excepto garajes',
         'm - Quir\xf3fanos y salas de intervenci\xf3n',
         'n - Piscinas',
         'n - Fuentes',
         'o - Todas aquellas que no est\xe9n comprendidas en los grupos anteriores',
         'x - Almacenes productos no peligrosos',
         'x - Establecimientos agr\xedcolas y hort\xedcolas',
         'x - Instalaciones de telecomunicaciones, antenas de telefon\xeda y similares',
         'z - Locales de reuni\xf3n,trabajo y uso sanitario (menos 50 p)']
        self.txtTipo = Combo(panel, lista)
        EVT_COMBOBOX(self.txtTipo, self.txtTipo.GetId(), self.tipoSeleccionado)
        panel.insertaElemento(Etiqueta(panel, 'Tipo de instalaci\xf3n', wxRED))
        panel.insertaElemento(self.txtTipo)
        panel.insertaElemento(self.dibujaDatosUso(panel))
        panel.insertaElemento(self.dibujaDatosActividad(panel))
        self.radios = CajaRadio(panel, 'Instalaci\xf3n:', ['Nueva',
         'Ampliaci\xf3n',
         'Modificaci\xf3n'], check=1, numColumnas=3)
        panel.insertaElemento(self.radios.dibujaCajaCheck(self.comprobarCheck))
        panel.insertaElemento(Etiqueta(panel, 'Fecha desde y Fecha Hasta para instalaciones temporales'))
        panel.insertaElemento(self.dibujaFechas(panel))
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def comprobarCheck(self, event):
        if (event.GetEventObject().GetLabel() == 'Nueva'):
            if self.radios.radios[0].GetValue():
                self.radios.radios[1].SetValue(0)
                self.radios.radios[2].SetValue(0)
        elif self.radios.radios[0].GetValue():
            self.radios.radios[0].SetValue(0)
        self.comprobarCondiciones(event)



    def dameValorCheck(self):
        if self.radios.radios[0].GetValue():
            return 0
        if self.radios.radios[1].GetValue():
            if self.radios.radios[2].GetValue():
                return 3
            return 1
        if self.radios.radios[2].GetValue():
            return 2
        return -1



    def cargaDatosCheck(self):
        if (self.padre.instalacion.IInstalacion == 0):
            self.radios.radios[0].SetValue(1)
        if (self.padre.instalacion.IInstalacion == 1):
            self.radios.radios[1].SetValue(1)
        if (self.padre.instalacion.IInstalacion == 2):
            self.radios.radios[2].SetValue(1)
        if (self.padre.instalacion.IInstalacion == 3):
            self.radios.radios[1].SetValue(1)
            self.radios.radios[2].SetValue(1)



    def tipoSeleccionado(self, event = None):
        self.guardaDatos()
        if (self.txtTipo.dameValor()[0] == 'j'):
            if (self.padre.instalacion.IProyecto == -1):
                texto = 'Se incluir\xe1n en este tipo todas las redes de distribuci\xf3n ya\nsean p\xfablicas o privadas, de acuerdo con la definici\xf3n que se\nestablece para ambas en la ITC-BT-01, y las acometidas el\xe9ctricas,\nsiempre y cuando se den circunstancias de cruzamientos o paralelismos\npara los que sea preciso la obtenci\xf3n de los permisos\ncorrespondientes, incluidos los de paso por terrenos ajenos al titular\no promotor de la instalaci\xf3n, as\xed como cuando la longitud de\nla red o acometida sea superior a 100 metros o est\xe9 constituida\npor m\xe1s de un vano.\n\n\xbfLa instalacion lleva Proyecto?'
                ok = Confirmacion(self.padre, texto)
                if ok.mostrar():
                    self.padre.instalacion.IProyecto = 1
                else:
                    self.padre.instalacion.IProyecto = 0
        else:
            self.padre.instalacion.IProyecto = -1
        if (self.txtTipo.dameValor()[0] == 'd'):
            self.txtFechaDesde.Enable(1)
            self.txtFechaHasta.Enable(1)
        else:
            self.txtFechaDesde.Enable(0)
            self.txtFechaHasta.Enable(0)
        self.comprobarCondiciones(event)
        if self.padre.instalacion.compruebaProyecto():
            self.padre.GetMenuBar().Enable(self.padre.GetMenuBar().FindMenuItem('Ver', 'Memoria T\xe9cnica'), 0)
	    self.padre.tb.EnableTool(13,0)
        else:
            self.padre.GetMenuBar().Enable(self.padre.GetMenuBar().FindMenuItem('Ver', 'Memoria T\xe9cnica'), 1)
	    self.padre.tb.EnableTool(13,1)



    def dibujaFechas(self, padre):
        panel = Panel(padre, 0, 4)
        self.txtFechaDesde = wxMaskedCtrl(panel, -1, '', autoformat='EUDATEDDMMYYYY/')
        panel.insertaElemento(self.txtFechaDesde)
        self.txtFechaDesde.Enable(0)
        self.txtFechaHasta = wxMaskedCtrl(panel, -1, '', autoformat='EUDATEDDMMYYYY/')
        panel.insertaElemento(self.txtFechaHasta)
        self.txtFechaHasta.Enable(0)
        panel.cerrarPanel()
        return panel



    def dibujaBotonCopiaTitular(self, padre):
        panel = Panel(padre, 0, 2)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.insertaElemento(Boton(panel, 'Copia Titular', self.copiaTitular, 'socio'))
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def copiaTitular(self, event):
        self.txtEmplazamiento.ponTexto(self.padre.instalacion.domicilio)
        try:
            self.txtProvincia.seleccionaValor(self.padre.instalacion.provincia)
            self.dameListaPueblos(self.padre.instalacion.provincia)
            self.txtLocalidad.seleccionaValor(self.padre.instalacion.localidad)
        except:
            pass
        self.txtCodigoPostal.ponTexto(self.padre.instalacion.codigoPostal)



    def dibujaEmplazamiento(self, padre):
        panel = Panel(padre, 2, 0)
        panel.insertaElemento(Etiqueta(panel, 'Emplazamiento', wxRED))
        self.txtEmplazamiento = AreaTexto(panel)
        panel.insertaElemento(self.txtEmplazamiento)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaLocalidad(self, padre):
        panel = Panel(padre, 2, 3)
        panel.insertaElemento(Etiqueta(panel, 'Provincia:', wxRED))
        panel.insertaElemento(Etiqueta(panel, 'Localidad:', wxRED))
        panel.insertaElemento(Etiqueta(panel, 'C\xf3digo Postal:', wxRED))
        self.txtProvincia = Combo(panel, ['Badajoz',
         'C\xe1ceres'])
        EVT_COMBOBOX(self.txtProvincia, self.txtProvincia.GetId(), self.provinciaSeleccionada)
        panel.insertaElemento(self.txtProvincia)
        self.txtLocalidad = Combo(panel, [])
        self.txtLocalidad.Enable(0)
        EVT_COMBOBOX(self.txtLocalidad, self.txtLocalidad.GetId(), self.localidadSeleccionada)
        panel.insertaElemento(self.txtLocalidad)
        self.txtCodigoPostal = AreaTexto(panel)
        self.txtCodigoPostal.Enable(0)
        panel.insertaElemento(self.txtCodigoPostal)
        panel.creceColumna(1)
        panel.cerrarPanel()
        return panel



    def provinciaSeleccionada(self, event):
        self.dameListaPueblos(self.txtProvincia.dameValor())
        self.txtCodigoPostal.ponTexto('')



    def localidadSeleccionada(self, event = None):
        provincia = self.txtProvincia.dameValor()
        util = Utilidades()
        if (provincia == 'C\xe1ceres'):
            codigo = self.padre.caceresCP[util.convierteCadenaUNICODE(self.txtLocalidad.dameValor())]
            if (self.txtLocalidad.dameValor() == 'C\xe1ceres'):
                self.txtCodigoPostal.Enable(1)
        else:
            codigo = self.padre.badajozCP[util.convierteCadenaUNICODE(self.txtLocalidad.dameValor())]
            if (self.txtLocalidad.dameValor() == 'Badajoz'):
                self.txtCodigoPostal.Enable(1)
        self.txtCodigoPostal.ponTexto(codigo)



    def dameListaPueblos(self, provincia):
        self.txtLocalidad.Clear()
        if (provincia == 'C\xe1ceres'):
            llaves = self.padre.caceresCP.keys()
        else:
            llaves = self.padre.badajozCP.keys()
        llaves.sort()
        util = Utilidades()
        lista = util.convierteElementosISO(llaves)
        for i in lista:
            self.txtLocalidad.Append(i)

        self.txtLocalidad.Enable(1)



    def dibujaDatosUso(self, padre):
        panel = Panel(padre, 2, 2)
        panel.insertaElemento(Etiqueta(panel, 'Uso al que se destina:'))
        panel.insertaElemento(Etiqueta(panel, 'Superficie'))
        self.txtUso = AreaTexto(panel)
        panel.insertaElemento(self.txtUso)
        self.txtSuperficie = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtSuperficie, self.actividadSeleccionada)
        panel.insertaElemento(self.txtSuperficie)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaDatosActividad(self, padre):
        panel = Panel(padre, 2, 3)
        lista = ['Zonas destinadas a espectadores de pie',
         'Zonas de p\xfablico en discotecas',
         'Zonas destinadas a espectadores sentados no numerados',
         'Zonas de uso p\xfablico en bares, cafeter\xedas, etc',
         'Salones de uso m\xfaltiple en hoteles, etc',
         'Aulas',
         'Salas de juego y casinos',
         'Restaurantes',
         'Salas de espera',
         'Salas de lectura en bibliotecas',
         'Zonas p\xfablicas en museos, galer\xedas y recintos de ferias y exposiciones',
         'Vest\xedbulos generales y patios de operaciones',
         'Vest\xedbulos, vestuarios, camerinos y otros anejos a salas de espect\xe1culos y de reuni\xf3n',
         'Zonas comerciales distintas de las indicadas',
         'Aulas de escuelas infantiles',
         'Locales docentes diferentes de aulas',
         'Locales comerciales sin gran afluencia de publico (muebles, coches ,etc)',
         'Gen\xe9rico seg\xfan el REBT',
         'OTROS (si lleva proyecto se copiar\xe1 el que se especifique en el proyecto)']
        panel.insertaElemento(Etiqueta(panel, 'Actividad para el c\xe1lculo de la ocupaci\xf3n:'))
        self.etiquetaDensidad = Etiqueta(panel, 'Densidad')
        panel.insertaElemento(self.etiquetaDensidad)
        panel.insertaElemento(Etiqueta(panel, 'Ocupaci\xf3n'))
        self.txtActividad = Combo(panel, lista)
        EVT_COMBOBOX(self.txtActividad, self.txtActividad.GetId(), self.actividadSeleccionada)
        panel.insertaElemento(self.txtActividad)
        self.txtDensidad = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtDensidad, self.cambioDensidad)
        self.txtDensidad.Enable(0)
        panel.insertaElemento(self.txtDensidad)
        self.txtOcupacion = CampoMonetario(panel, 0)
        EVT_KILL_FOCUS(self.txtOcupacion, self.cambioOcupacion)
        panel.insertaElemento(self.txtOcupacion)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def cambioOcupacion(self, event):
        self.guardaDatos()
        if self.padre.instalacion.compruebaProyecto():
            self.padre.GetMenuBar().Enable(self.padre.GetMenuBar().FindMenuItem('Ver', 'Memoria T\xe9cnica'), 0)
	    self.padre.tb.EnableTool(13,0)
        else:
            self.padre.GetMenuBar().Enable(self.padre.GetMenuBar().FindMenuItem('Ver', 'Memoria T\xe9cnica'), 1)
	    self.padre.tb.EnableTool(13,1)



    def actividadSeleccionada(self, event):
        try:
            if (self.txtActividad.GetSelection() == -1):
                return 
            densidad = [4,
             2,
             2,
             1,
             1,
             0.66000000000000003,
             0.66000000000000003,
             0.5,
             0.5,
             0.5,
             0.5,
             0.5,
             0.5,
             0.33000000000000002,
             0.5,
             0.20000000000000001,
             0.20000000000000001,
             1.25]
            try:
                self.txtDensidad.ponTexto(densidad[self.txtActividad.GetSelection()])
                self.txtDensidad.Enable(0)
                self.txtOcupacion.ponTexto((self.txtDensidad.dameValor() * self.txtSuperficie.dameValor()))
                self.cambioOcupacion(event)
            except:
                self.txtDensidad.ponTexto(0)
                self.txtDensidad.Enable(1)
                self.txtOcupacion.ponTexto(0)
                self.cambioOcupacion(event)
        except:
            pass



    def cambioDensidad(self, event):
        try:
            self.txtOcupacion.ponTexto((self.txtDensidad.dameValor() * self.txtSuperficie.dameValor()))
            self.cambioOcupacion(event)
        except:
            pass



    def comprobarSiguientePaso(self):
        if (not (self.txtTipo.dameValor() == '')):
            if ((self.txtTipo.dameValor()[0] == 'f') and (not self.radios.dameElementoSeleccionado())):
                self.pasoSiguiente = 'Paso42'
            if ((self.txtTipo.dameValor()[0] == 'e') and (not self.radios.dameElementoSeleccionado())):
                self.pasoSiguiente = 'Paso43A'
            if ((self.txtTipo.dameValor()[0] == 'e') and (self.radios.dameElementoSeleccionado() == 1)):
                self.pasoSiguiente = 'Paso44A'
        else:
            self.pasoSiguiente = 'Paso41A'
        self.guardaDatos()



    def guardaDatos(self):
        try:
            self.padre.instalacion.IEmplazamiento = self.txtEmplazamiento.dameValor()
            self.padre.instalacion.Iprovincia = self.txtProvincia.dameValor()
            self.padre.instalacion.Ilocalidad = self.txtLocalidad.dameValor()
            self.padre.instalacion.IcodigoPostal = self.txtCodigoPostal.dameValor()
            self.padre.instalacion.IUso = self.txtUso.dameValor()
            self.padre.instalacion.ISuperficie = self.txtSuperficie.dameValor()
            self.padre.instalacion.IOcupacion = self.txtOcupacion.dameValor()
            self.padre.instalacion.ITipo = self.txtTipo.dameValor()
            self.padre.instalacion.IInstalacion = self.dameValorCheck()
            self.padre.instalacion.IDensidad = self.txtDensidad.dameValor()
            self.padre.instalacion.IActividad = self.txtActividad.dameValor()
            self.padre.instalacion.IfechaDesde = self.txtFechaDesde.GetValue()
            self.padre.instalacion.IfechaHasta = self.txtFechaHasta.GetValue()
        except:
            pass



    def cargaDatos(self):
        self.txtEmplazamiento.ponTexto(self.padre.instalacion.IEmplazamiento)
        try:
            self.txtProvincia.seleccionaValor(self.padre.instalacion.Iprovincia)
            self.dameListaPueblos(self.padre.instalacion.Iprovincia)
            self.txtLocalidad.seleccionaValor(self.padre.instalacion.Ilocalidad)
            self.localidadSeleccionada()
        except:
            pass
        self.txtCodigoPostal.ponTexto(self.padre.instalacion.IcodigoPostal)
        self.txtUso.ponTexto(self.padre.instalacion.IUso)
        self.txtSuperficie.ponTexto(self.padre.instalacion.ISuperficie)
        self.txtOcupacion.ponTexto(self.padre.instalacion.IOcupacion)
        self.cargaDatosCheck()
        self.txtDensidad.ponTexto(self.padre.instalacion.IDensidad)
        self.txtFechaDesde.SetValue(self.padre.instalacion.IfechaDesde)
        self.txtFechaHasta.SetValue(self.padre.instalacion.IfechaHasta)
        try:
            self.txtTipo.seleccionaValor(self.padre.instalacion.ITipo)
            self.tipoSeleccionado()
            self.txtActividad.seleccionaValor(self.padre.instalacion.IActividad)
        except:
            pass
        self.comprobarCondiciones()



    def comprobarCondiciones(self, event = None):
        if (not (self.txtTipo.dameValor() == '')):
            if (self.txtTipo.dameValor()[0] == 'f'):
                if (self.dameValorCheck() == 0):
                    self.pasoSiguiente = 'Paso42'
                    self.padre.botonSiguiente.Enable(1)
                if (self.dameValorCheck() in (1,
                 2,
                 3)):
                    self.pasoSiguiente = 'Paso41A'
                    self.padre.botonSiguiente.Enable(1)
            elif (self.txtTipo.dameValor()[0] == 'e'):
                if (self.dameValorCheck() == 0):
                    self.pasoSiguiente = 'Paso43A'
                    self.padre.botonSiguiente.Enable(1)
                if (self.dameValorCheck() == 1):
                    self.pasoSiguiente = 'Paso44A'
                    self.padre.botonSiguiente.Enable(1)
                if (self.dameValorCheck() == 2):
                    self.pasoSiguiente = 'Paso41A'
                    self.padre.botonSiguiente.Enable(1)
            else:
                self.pasoSiguiente = 'Paso41A'
                self.padre.botonSiguiente.Enable(1)

#}}}

class Paso41A(Panel): #{{{
    __module__ = __name__

    def __init__(self, padre, w, h, clasePrincipal):
        Panel.__init__(self, padre, 2, 0)
        self.padre = clasePrincipal
        self.pasoSiguiente = 'Paso41B'
        self.pasoAnterior = 'Paso3'
        self.potenciaTotalAlumbrado = 0
        self.receptores = []
        self.insertaElemento(self.dibujaTitulo(self))
        self.insertaElemento(self.dibujaDatos(self))
        self.creceColumna(0)
        self.creceFila(1)
        self.cerrarPanel()
        self.SetSize([w,
         h])
        self.cargaDatos()
	if not self.padre.instalacion.esEditable("41A"): self.Enable(0)



    def dibujaTitulo(self, padre):
        panel = Panel(padre, 0, 3)
        centrado = Etiqueta(panel, '')
        centrado.ponEstilo(13, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(centrado)
        titulo = Etiqueta(panel, '4.1.A RELACI\xd3N NOMINAL DE RECEPTORES DE ALUMBRADO')
        titulo.ponEstilo(13, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(titulo)
        panel.insertaElemento(centrado)
        panel.creceColumna(0)
        panel.creceColumna(2)
        panel.cerrarPanel()
        panel.SetBackgroundColour(wxBLUE)
        return panel



    def dibujaDatos(self, padre):
        panel = Panel(padre, 0, 2)
        panel.insertaElemento(self.capturaDatos(panel))
        panel.insertaElemento(self.dibujaListaDatos(panel))
        panel.creceFila(0)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def capturaDatos(self, padre):
        panel = Panel(padre, 4, 0)
        panel.insertaElemento(self.damePanelUnidades(panel))
        panel.insertaElemento(self.damePanelReceptor(panel))
        panel.insertaElemento(self.dibujaPotenciaTotal(panel))
        panel.insertaElemento(self.dibujaBotonAceptar(panel))
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaBotonAceptar(self, padre):
        panel = Panel(padre, 2, 0)
        panel.insertaElemento(Boton(panel, 'Aceptar', self.aceptarReceptor, 'aceptar'))
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.creceColumna(1)
        panel.cerrarPanel()
        return panel



    def aceptarReceptor(self, event):
        error = 0
        if (self.txtNumero.dameValor() == 0):
            error = 1
        if (self.txtUnidad.dameValor() == 0.0):
            error = 1
        if (self.txtReceptor.dameValor().strip() == ''):
            error = 1
        if error:
            Error(self, 'Debe rellenar todos los campos para aceptar un receptor')
        else:
            lista = [str(self.txtNumero.dameValor()),
             self.txtReceptor.dameValor(),
             str((self.txtNumero.dameValor() * self.txtUnidad.dameValor()))]
            self.listaAlumbrado.Append(lista)
            self.receptores.append(lista)
            self.txtReceptor.ponTexto('')
            self.potenciaTotal.ponTexto('Potencia Total (KW): 0')
            self.potenciaTotalAlumbrado = (self.potenciaTotalAlumbrado + (self.txtNumero.dameValor() * self.txtUnidad.dameValor()))
            self.totalAlumbrado.ponTexto(('Total Alumbrado (KW): ' + str(self.potenciaTotalAlumbrado)))
            self.txtNumero.ponTexto(0)
            self.txtUnidad.ponTexto(0)



    def damePanelUnidades(self, padre):
        panel = Panel(padre, 2, 2)
        panel.insertaElemento(Etiqueta(panel, 'Puntos de luz'))
        panel.insertaElemento(Etiqueta(panel, 'KW por punto de luz'))
        self.txtNumero = CampoMonetario(panel, 0)
        EVT_KILL_FOCUS(self.txtNumero, self.calculaPotenciaTotal)
        panel.insertaElemento(self.txtNumero)
        self.txtUnidad = CampoMonetario(panel, 3)
        EVT_KILL_FOCUS(self.txtUnidad, self.calculaPotenciaTotal)
        panel.insertaElemento(self.txtUnidad)
        panel.creceColumna(1)
        panel.cerrarPanel()
        return panel



    def calculaPotenciaTotal(self, event):
        try:
            potencia = (self.txtNumero.dameValor() * self.txtUnidad.dameValor())
            self.potenciaTotal.ponTexto(('Potencia Total (KW): ' + str(potencia)))
            event.Skip()
        except:
            pass



    def damePanelReceptor(self, padre):
        panel = Panel(padre, 2, 0)
        panel.insertaElemento(Etiqueta(panel, 'Tipo de receptor de alumbrado'))
        self.txtReceptor = AreaTexto(panel)
        panel.insertaElemento(self.txtReceptor)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaPotenciaTotal(self, padre):
        panel = Panel(padre, 0, 2)
        self.potenciaTotal = Etiqueta(panel, 'Potencia Total (KW): 0')
        self.potenciaTotal.ponNegrita()
        panel.insertaElemento(self.potenciaTotal)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaListaDatos(self, padre):
        panel = Panel(padre, 2, 0)
        self.listaAlumbrado = ListaColumna(panel, self.receptorSeleccionado, self.receptorDeseleccionado)
        self.listaAlumbrado.ponTamanio([300,
         -1])
        self.listaAlumbrado.cabeceraColumnas(['Unidades',
         'Receptores',
         'Potencia (KW)'])
        self.listaAlumbrado.SetColumnWidth(0, -2)
        self.listaAlumbrado.SetColumnWidth(1, 150)
        self.listaAlumbrado.SetColumnWidth(2, -2)
        panel.insertaElemento(self.listaAlumbrado)
        panel.insertaElemento(self.dibujaResultado(panel))
        panel.creceColumna(0)
        panel.creceFila(0)
        panel.cerrarPanel()
        return panel



    def receptorSeleccionado(self, event):
        self.botonEliminar.Enable(1)
        self.botonModificar.Enable(1)
        self.itemSeleccionado = event.m_itemIndex



    def receptorDeseleccionado(self, event):
        self.botonEliminar.Enable(0)
        self.botonModificar.Enable(0)



    def dibujaResultado(self, padre):
        panel = Panel(padre, 2, 0)
        self.totalAlumbrado = Etiqueta(panel, 'Total Alumbrado (KW): 0')
        self.totalAlumbrado.ponNegrita()
        panel.insertaElemento(self.totalAlumbrado)
        panel.insertaElemento(self.dibujaBotonesLista(panel))
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaBotonesLista(self, padre):
        panel = Panel(padre, 0, 3)
        panel.insertaElemento(Etiqueta(panel, ''))
        self.botonModificar = Boton(panel, 'Modificar', self.modificaReceptor, 'izquierda')
        self.botonModificar.Enable(0)
        panel.insertaElemento(self.botonModificar)
        self.botonEliminar = Boton(panel, 'Eliminar', self.eliminarReceptor, 'eliminar')
        self.botonEliminar.Enable(0)
        panel.insertaElemento(self.botonEliminar)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def modificaReceptor(self, event):
        (unidades, receptor, potencia,) = self.receptores[self.itemSeleccionado]
        self.txtNumero.ponTexto(int(unidades))
        self.txtReceptor.ponTexto(receptor)
        self.txtUnidad.ponTexto((float(potencia) / float(unidades)))
        self.calculaPotenciaTotal(event)
        self.eliminarReceptor(event)



    def eliminarReceptor(self, event):
        (unidades, receptor, potencia,) = self.receptores[self.itemSeleccionado]
        del self.receptores[self.itemSeleccionado]
        self.listaAlumbrado.DeleteItem(self.itemSeleccionado)
        self.potenciaTotalAlumbrado = (self.potenciaTotalAlumbrado - float(potencia))
        self.totalAlumbrado.ponTexto(('Total Alumbrado (KW): ' + str(self.potenciaTotalAlumbrado)))



    def comprobarSiguientePaso(self):
        self.guardaDatos()



    def guardaDatos(self):
        try:
            self.padre.instalacion.receptoresAlumbrado = self.receptores
        except:
            pass



    def cargaDatos(self):
        suma = 0
        for receptor in self.padre.instalacion.receptoresAlumbrado:
            self.receptores.append(receptor)
            self.listaAlumbrado.Append(receptor)
            suma = (suma + float(receptor[2]))

        self.totalAlumbrado.ponTexto(('Total Alumbrado (KW): ' + str(suma)))
        self.potenciaTotalAlumbrado = suma

#}}}

class Paso41B(Panel): #{{{
    __module__ = __name__

    def __init__(self, padre, w, h, clasePrincipal):
        Panel.__init__(self, padre, 2, 0)
        self.padre = clasePrincipal
        self.pasoSiguiente = 'Paso41C'
        self.pasoAnterior = 'Paso41A'
        self.potenciaTotalAlumbrado = 0
        self.receptores = []
        self.insertaElemento(self.dibujaTitulo(self))
        self.insertaElemento(self.dibujaDatos(self))
        self.creceColumna(0)
        self.creceFila(1)
        self.cerrarPanel()
        self.SetSize([w,
         h])
        self.cargaDatos()
	if not self.padre.instalacion.esEditable("41B"): self.Enable(0)



    def dibujaTitulo(self, padre):
        panel = Panel(padre, 0, 3)
        centrado = Etiqueta(panel, '')
        centrado.ponEstilo(13, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(centrado)
        titulo = Etiqueta(panel, '4.1.B RELACI\xd3N NOMINAL DE RECEPTORES DE FUERZA')
        titulo.ponEstilo(14, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(titulo)
        panel.insertaElemento(centrado)
        panel.creceColumna(0)
        panel.creceColumna(2)
        panel.cerrarPanel()
        panel.SetBackgroundColour(wxBLUE)
        return panel



    def dibujaDatos(self, padre):
        panel = Panel(padre, 0, 2)
        panel.insertaElemento(self.capturaDatos(panel))
        panel.insertaElemento(self.dibujaListaDatos(panel))
        panel.creceFila(0)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def capturaDatos(self, padre):
        panel = Panel(padre, 4, 0)
        panel.insertaElemento(self.damePanelUnidades(panel))
        panel.insertaElemento(self.damePanelReceptor(panel))
        panel.insertaElemento(self.dibujaPotenciaTotal(panel))
        panel.insertaElemento(self.dibujaBotonAceptar(panel))
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaBotonAceptar(self, padre):
        panel = Panel(padre, 2, 0)
        panel.insertaElemento(Boton(panel, 'Aceptar', self.aceptarReceptor, 'aceptar'))
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.creceColumna(1)
        panel.cerrarPanel()
        return panel



    def aceptarReceptor(self, event):
        error = 0
        if (self.txtNumero.dameValor() == 0):
            error = 1
        if (self.txtUnidad.dameValor() == 0.0):
            error = 1
        if (self.txtReceptor.dameValor().strip() == ''):
            error = 1
        if error:
            Error(self, 'Debe rellenar todos los campos para aceptar un receptor')
        else:
            lista = [str(self.txtNumero.dameValor()),
             self.txtReceptor.dameValor(),
             str((self.txtNumero.dameValor() * self.txtUnidad.dameValor()))]
            self.listaAlumbrado.Append(lista)
            self.receptores.append(lista)
            self.txtReceptor.ponTexto('')
            self.potenciaTotal.ponTexto('Potencia Total (KW): 0')
            self.potenciaTotalAlumbrado = (self.potenciaTotalAlumbrado + (self.txtNumero.dameValor() * self.txtUnidad.dameValor()))
            self.totalAlumbrado.ponTexto(('Total Fuerza (KW): ' + str(self.potenciaTotalAlumbrado)))
            self.txtNumero.ponTexto(0)
            self.txtUnidad.ponTexto(0)



    def damePanelUnidades(self, padre):
        panel = Panel(padre, 2, 2)
        panel.insertaElemento(Etiqueta(panel, 'N\xfamero de Receptores'))
        panel.insertaElemento(Etiqueta(panel, 'KW por Unidad'))
        self.txtNumero = CampoMonetario(panel, 0)
        EVT_KILL_FOCUS(self.txtNumero, self.calculaPotenciaTotal)
        panel.insertaElemento(self.txtNumero)
        self.txtUnidad = CampoMonetario(panel, 3)
        EVT_KILL_FOCUS(self.txtUnidad, self.calculaPotenciaTotal)
        panel.insertaElemento(self.txtUnidad)
        panel.creceColumna(1)
        panel.cerrarPanel()
        return panel



    def calculaPotenciaTotal(self, event):
        try:
            potencia = (self.txtNumero.dameValor() * self.txtUnidad.dameValor())
            self.potenciaTotal.ponTexto(('Potencia Total (kW): ' + str(potencia)))
            event.Skip()
        except:
            pass



    def damePanelReceptor(self, padre):
        panel = Panel(padre, 2, 0)
        panel.insertaElemento(Etiqueta(panel, 'Tipo de receptor de fuerza'))
        self.txtReceptor = AreaTexto(panel)
        panel.insertaElemento(self.txtReceptor)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaPotenciaTotal(self, padre):
        panel = Panel(padre, 0, 2)
        self.potenciaTotal = Etiqueta(panel, 'Potencia Total (KW): 0')
        self.potenciaTotal.ponNegrita()
        panel.insertaElemento(self.potenciaTotal)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaListaDatos(self, padre):
        panel = Panel(padre, 2, 0)
        self.listaAlumbrado = ListaColumna(panel, self.receptorSeleccionado, self.receptorDeSeleccionado)
        self.listaAlumbrado.ponTamanio([300,
         -1])
        self.listaAlumbrado.cabeceraColumnas(['Unidades',
         'Receptores',
         'Potencia (KW)'])
        self.listaAlumbrado.SetColumnWidth(0, -2)
        self.listaAlumbrado.SetColumnWidth(1, 150)
        self.listaAlumbrado.SetColumnWidth(2, -2)
        panel.insertaElemento(self.listaAlumbrado)
        panel.insertaElemento(self.dibujaResultado(panel))
        panel.creceColumna(0)
        panel.creceFila(0)
        panel.cerrarPanel()
        return panel



    def receptorSeleccionado(self, event):
        self.botonEliminar.Enable(1)
        self.botonModificar.Enable(1)
        self.itemSeleccionado = event.m_itemIndex



    def receptorDeSeleccionado(self, event):
        self.botonEliminar.Enable(0)
        self.botonModificar.Enable(0)



    def dibujaResultado(self, padre):
        panel = Panel(padre, 2, 0)
        self.totalAlumbrado = Etiqueta(panel, 'Total Fuerza (KW): 0')
        self.totalAlumbrado.ponNegrita()
        panel.insertaElemento(self.totalAlumbrado)
        panel.insertaElemento(self.dibujaBotonesLista(panel))
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaBotonesLista(self, padre):
        panel = Panel(padre, 0, 3)
        panel.insertaElemento(Etiqueta(panel, ''))
        self.botonModificar = Boton(panel, 'Modificar', self.modificaReceptor, 'izquierda')
        self.botonModificar.Enable(0)
        panel.insertaElemento(self.botonModificar)
        self.botonEliminar = Boton(panel, 'Eliminar', self.eliminarReceptor, 'eliminar')
        self.botonEliminar.Enable(0)
        panel.insertaElemento(self.botonEliminar)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def modificaReceptor(self, event):
        (unidades, receptor, potencia,) = self.receptores[self.itemSeleccionado]
        self.txtNumero.ponTexto(int(unidades))
        self.txtReceptor.ponTexto(receptor)
        self.txtUnidad.ponTexto((float(potencia) / float(unidades)))
        self.calculaPotenciaTotal(event)
        self.eliminarReceptor(event)



    def eliminarReceptor(self, event):
        (unidades, receptor, potencia,) = self.receptores[self.itemSeleccionado]
        del self.receptores[self.itemSeleccionado]
        self.listaAlumbrado.DeleteItem(self.itemSeleccionado)
        self.potenciaTotalAlumbrado = (self.potenciaTotalAlumbrado - float(potencia))
        self.totalAlumbrado.ponTexto(('Total Fuerza (KW): ' + str(self.potenciaTotalAlumbrado)))



    def comprobarSiguientePaso(self):
        self.guardaDatos()



    def guardaDatos(self):
        try:
            self.padre.instalacion.receptoresFuerza = self.receptores
        except:
            pass



    def cargaDatos(self):
        suma = 0
        for receptor in self.padre.instalacion.receptoresFuerza:
            self.receptores.append(receptor)
            self.listaAlumbrado.Append(receptor)
            suma = (suma + float(receptor[2]))

        self.totalAlumbrado.ponTexto(('Total Fuerza (KW): ' + str(suma)))
        self.potenciaTotalAlumbrado = suma

#}}}

class Paso41C(Panel): #{{{
    __module__ = __name__

    def __init__(self, padre, w, h, clasePrincipal):
        Panel.__init__(self, padre, 2, 0)
        self.padre = clasePrincipal
        self.pasoSiguiente = 'Paso5'
        self.pasoAnterior = 'Paso41B'
        self.insertaElemento(self.dibujaTitulo(self))
        self.insertaElemento(self.dibujaDatos(self))
        self.creceColumna(0)
        self.creceFila(1)
        self.cerrarPanel()
        self.SetSize([w,
         h])
        self.cargaDatos()
	if not self.padre.instalacion.esEditable("41C"): self.Enable(0)



    def dibujaTitulo(self, padre):
        panel = Panel(padre, 0, 3)
        centrado = Etiqueta(panel, '')
        centrado.ponEstilo(13, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(centrado)
        titulo = Etiqueta(panel, '4.1.C RESUMEN RELACION NOMINAL DE RECEPTORES')
        titulo.ponEstilo(14, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(titulo)
        panel.insertaElemento(centrado)
        panel.creceColumna(0)
        panel.creceColumna(2)
        panel.cerrarPanel()
        panel.SetBackgroundColour(wxBLUE)
        return panel



    def dibujaDatos(self, padre):
        panel = Panel(padre, 5, 0)
        panel.insertaElemento(self.ponTituloListas(panel, 'Relaci\xf3n nominal de receptores de alumbrado', 'Total alumbrado (KW): 0', 1))
        self.listaAlumbrado = ListaColumna(panel)
        self.listaAlumbrado.cabeceraColumnas(['Unidades',
         'Receptores',
         'Potencia'])
        self.listaAlumbrado.SetColumnWidth(0, -2)
        self.listaAlumbrado.SetColumnWidth(1, 430)
        self.listaAlumbrado.SetColumnWidth(2, -2)
        panel.insertaElemento(self.listaAlumbrado)
        panel.insertaElemento(self.ponTituloListas(panel, 'Relaci\xf3n nominal de receptores de fuerza', 'Total fuerza (KW): 0', 2))
        self.listaFuerza = ListaColumna(panel)
        self.listaFuerza.cabeceraColumnas(['Unidades',
         'Receptores',
         'Potencia'])
        self.listaFuerza.SetColumnWidth(0, -2)
        self.listaFuerza.SetColumnWidth(1, 430)
        self.listaFuerza.SetColumnWidth(2, -2)
        panel.insertaElemento(self.listaFuerza)
        panel.insertaElemento(self.dibujaPotenciaTotal(panel))
        panel.creceColumna(0)
        panel.creceFila(1)
        panel.creceFila(3)
        panel.cerrarPanel()
        return panel



    def ponTituloListas(self, padre, texto1, texto2, tipo):
        panel = Panel(padre, 0, 3)
        etiqueta = Etiqueta(panel, texto1)
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        if (tipo == 1):
            self.etiquetaAlumbrado = Etiqueta(panel, texto2)
            self.etiquetaAlumbrado.ponNegrita()
            panel.insertaElemento(self.etiquetaAlumbrado)
        else:
            self.etiquetaFuerza = Etiqueta(panel, texto2)
            self.etiquetaFuerza.ponNegrita()
            panel.insertaElemento(self.etiquetaFuerza)
        panel.cerrarPanel()
        return panel



    def dibujaPotenciaTotal(self, padre):
        panel = Panel(padre, 0, 2)
        self.etiqueta = Etiqueta(panel, 'POTENCIA TOTAL A INSTALAR (KW): 0')
        self.etiqueta.ponNegrita()
        panel.insertaElemento(self.etiqueta)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def comprobarSiguientePaso(self):
        pass


    def cargaDatos(self):
        sumaAlumbrado = 0
        sumaFuerza = 0
        for receptor in self.padre.instalacion.receptoresAlumbrado:
            self.listaAlumbrado.Append(receptor)
            sumaAlumbrado = (sumaAlumbrado + float(receptor[2]))

        self.etiquetaAlumbrado.ponTexto(('Total alumbrado (KW): ' + str(sumaAlumbrado)))
        for receptor in self.padre.instalacion.receptoresFuerza:
            self.listaFuerza.Append(receptor)
            sumaFuerza = (sumaFuerza + float(receptor[2]))

        self.etiquetaFuerza.ponTexto(('Total fuerza (KW): ' + str(sumaFuerza)))
        sumaTotal = (sumaAlumbrado + sumaFuerza)
        self.etiqueta.ponTexto(('POTENCIA TOTAL A INSTALAR (KW): ' + str(sumaTotal)))
        if self.padre.instalacion.compruebaProyecto():
            self.padre.GetMenuBar().Enable(self.padre.GetMenuBar().FindMenuItem('Ver', 'Memoria T\xe9cnica'), 0)
	    self.padre.tb.EnableTool(13,0)
        else:
            self.padre.GetMenuBar().Enable(self.padre.GetMenuBar().FindMenuItem('Ver', 'Memoria T\xe9cnica'), 1)
	    self.padre.tb.EnableTool(13,1)

#}}}

class Paso42(Panel): #{{{
    __module__ = __name__

    def __init__(self, padre, w, h, clasePrincipal):
        Panel.__init__(self, padre, 2, 0)
        self.padre = clasePrincipal
        self.pasoSiguiente = 'Paso5'
        self.pasoAnterior = 'Paso3'
        self.insertaElemento(self.dibujaTitulo(self))
        self.insertaElemento(self.dibujaDatos(self))
        self.creceColumna(0)
        self.creceFila(1)
        self.cerrarPanel()
        self.SetSize([w,
         h])
        self.cargaDatos()
	if not self.padre.instalacion.esEditable("42"): self.Enable(0)



    def dibujaTitulo(self, padre):
        panel = Panel(padre, 0, 3)
        centrado = Etiqueta(panel, '')
        centrado.ponEstilo(13, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(centrado)
        titulo = Etiqueta(panel, '4.2 PREVISI\xd3N DE POTENCIA')
        titulo.ponEstilo(15, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(titulo)
        panel.insertaElemento(centrado)
        panel.creceColumna(0)
        panel.creceColumna(2)
        panel.cerrarPanel()
        panel.SetBackgroundColour(wxBLUE)
        return panel



    def dibujaDatos(self, padre):
        panel = Panel(padre, 4, 0)
        self.radiosElectrificacion = CajaRadio(panel, 'Electrificaci\xf3n:', ['B\xe1sica',
         'Elevada'])
        panel.insertaElemento(self.radiosElectrificacion.dibujaCajaRadio())
        self.radiosElectrificacion.radios[0].Enable(0)
        self.radiosElectrificacion.radios[1].Enable(0)
        panel.insertaElemento(self.damePrevision(panel))
        self.radiosTarifaNocturna = CajaRadio(panel, '\xbfPosee instalaci\xf3n o preinstalaci\xf3n para tarifa nocturna?', ['Si',
         'No'])
        panel.insertaElemento(self.radiosTarifaNocturna.dibujaCajaRadio())
        self.radiosClimatizacion = CajaRadio(panel, '\xbfPosee instalaci\xf3n o preinstalaci\xf3n para climatizaci\xf3n?', ['Si',
         'No'])
        panel.insertaElemento(self.radiosClimatizacion.dibujaCajaRadio(self.compruebaPrevisionRadio))
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def damePrevision(self, padre):
        panel = Panel(padre, 0, 2)
        panel.insertaElemento(Etiqueta(panel, 'Previsi\xf3n de potencia (KW):'))
        self.txtPrevision = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtPrevision, self.compruebaPrevision)
        panel.insertaElemento(self.txtPrevision)
        panel.cerrarPanel()
        return panel



    def compruebaPrevisionRadio(self, event):
        dato = self.txtPrevision.dameValor()
        if (self.radiosClimatizacion.dameElementoSeleccionado() == 0):
            if (dato < 9.1999999999999993):
                Error(self.padre, 'La electrificaci\xf3n tiene que ser elevada por lo tanto la potencia ha de ser igual o superior a 9.2 (KW)')
                self.radiosClimatizacion.radios[1].SetValue(1)



    def compruebaPrevision(self, event):
        try:
            self.guardaDatos()
            dato = self.txtPrevision.dameValor()
            if (dato < 9.1999999999999993):
                if ((self.padre.instalacion.ITipo == 'f - Viviendas unifamiliares') and (self.padre.instalacion.ISuperficie > 160)):
                    Error(self.padre, 'La electrificaci\xf3n tiene que ser elevada por lo tanto la potencia ha de ser igual o superior a 9.2 (KW)')
                    self.txtPrevision.ponTexto(9.1999999999999993)
                    self.radiosElectrificacion.radios[1].SetValue(1)
                    self.radiosTarifaNocturna.radios[0].SetValue(1)
                    self.radiosClimatizacion.radios[0].SetValue(1)
                else:
                    self.radiosElectrificacion.radios[0].SetValue(1)
                    self.radiosTarifaNocturna.radios[1].SetValue(1)
                    self.radiosClimatizacion.radios[1].SetValue(1)
                    if (dato < 5.7000000000000002):
                        if ((self.padre.instalacion.ITipo == 'f - Viviendas unifamiliares') and (self.padre.instalacion.IInstalacion == 0)):
                            Error(self.padre, 'La potencia debe de ser mayor que 5.75 KW')
                            self.txtPrevision.ponTexto(5.75)
            else:
                self.radiosElectrificacion.radios[1].SetValue(1)
                self.radiosTarifaNocturna.radios[0].SetValue(1)
                self.radiosClimatizacion.radios[0].SetValue(1)
                if self.padre.instalacion.compruebaProyecto():
                    self.padre.GetMenuBar().Enable(self.padre.GetMenuBar().FindMenuItem('Ver', 'Memoria T\xe9cnica'), 0)
		    self.padre.tb.EnableTool(13,0)
                else:
                    self.padre.GetMenuBar().Enable(self.padre.GetMenuBar().FindMenuItem('Ver', 'Memoria T\xe9cnica'), 1)
		    self.padre.tb.EnableTool(13,1)
        except:
            pass



    def comprobarSiguientePaso(self):
        if ((not self.radiosElectrificacion.dameElementoSeleccionado()) and (5750 < float(self.txtPrevision.dameValor()))):
            self.pasoSiguiente = 'Paso41A'
        if (self.radiosElectrificacion.dameElementoSeleccionado() and (9200 < float(self.txtPrevision.dameValor()))):
            self.pasoSiguiente = 'Paso41A'
        self.guardaDatos()



    def guardaDatos(self):
        try:
            self.padre.instalacion.electrificacion = self.radiosElectrificacion.dameElementoSeleccionado()
            self.padre.instalacion.tarifaNocturna = self.radiosTarifaNocturna.dameElementoSeleccionado()
            self.padre.instalacion.climatizacion = self.radiosClimatizacion.dameElementoSeleccionado()
            self.padre.instalacion.prevision = self.txtPrevision.dameValor()
        except:
            pass



    def cargaDatos(self):
        if (self.padre.instalacion.electrificacion > -1):
            self.radiosElectrificacion.radios[self.padre.instalacion.electrificacion].SetValue(1)
        if (self.padre.instalacion.tarifaNocturna > -1):
            self.radiosTarifaNocturna.radios[self.padre.instalacion.tarifaNocturna].SetValue(1)
        if (self.padre.instalacion.climatizacion > -1):
            self.radiosClimatizacion.radios[self.padre.instalacion.climatizacion].SetValue(1)
        self.txtPrevision.ponTexto(self.padre.instalacion.prevision)

#}}}

class Paso43A(Panel): #{{{
    __module__ = __name__

    def __init__(self, padre, w, h, clasePrincipal):
        Panel.__init__(self, padre, 2, 0)
        self.padre = clasePrincipal
        self.pasoSiguiente = 'Paso43B'
        self.pasoAnterior = 'Paso3'
        self.insertaElemento(self.dibujaTitulo(self))
        self.insertaElemento(self.dibujaDatos(self))
        self.creceColumna(0)
        self.creceFila(1)
        self.cerrarPanel()
        self.SetSize([w,
         h])
        self.cargaDatos()
	if not self.padre.instalacion.esEditable("43A"): self.Enable(0)



    def dibujaTitulo(self, padre):
        panel = Panel(padre, 0, 3)
        centrado = Etiqueta(panel, '')
        centrado.ponEstilo(13, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(centrado)
        titulo = Etiqueta(panel, '4.3.A CARGA TOTAL DEL EDIFICIO - DATOS GENERALES')
        titulo.ponEstilo(14, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(titulo)
        panel.insertaElemento(centrado)
        panel.creceColumna(0)
        panel.creceColumna(2)
        panel.cerrarPanel()
        panel.SetBackgroundColour(wxBLUE)
        return panel



    def dibujaDatos(self, padre):
        panel = Panel(padre, 4, 0)
        panel.insertaElemento(self.dibujaCamposNumericos(panel))
        self.radiosClimatizacion = CajaRadio(panel, '\xbfIncluye instalaciones o preinstalaciones para climatizaci\xf3n?', ['Si',
         'No'])
        panel.insertaElemento(self.radiosClimatizacion.dibujaCajaRadio())
        self.radiosTarifaNocturna = CajaRadio(panel, '\xbfIncluye instalaciones o preinstalaciones para tarifa nocturna?', ['Si',
         'No'])
        panel.insertaElemento(self.radiosTarifaNocturna.dibujaCajaRadio())
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaCamposNumericos(self, padre):
        panel = Panel(padre, 2, 4)
        panel.insertaElemento(Etiqueta(panel, 'N\xba de plantas (incluidos s\xf3tanos)'))
        self.txtSotanos = CampoMonetario(panel, 0)
        panel.insertaElemento(self.txtSotanos)
        panel.insertaElemento(Etiqueta(panel, 'N\xba total de otros locales (oficinas)'))
        self.txtOficinas = CampoMonetario(panel, 0)
        panel.insertaElemento(self.txtOficinas)
        panel.insertaElemento(Etiqueta(panel, 'N\xba total de viviendas'))
        self.txtViviendas = CampoMonetario(panel, 0)
        panel.insertaElemento(self.txtViviendas)
        panel.insertaElemento(Etiqueta(panel, 'N\xba total de locales comerciales'))
        self.txtLocales = CampoMonetario(panel, 0)
        panel.insertaElemento(self.txtLocales)
        panel.cerrarPanel()
        return panel



    def comprobarSiguientePaso(self):
        self.guardaDatos()



    def guardaDatos(self):
        try:
            self.padre.instalacion.NumeroPlanta = self.txtSotanos.dameValor()
            self.padre.instalacion.NumeroViviendas = self.txtViviendas.dameValor()
            self.padre.instalacion.NumeroLocales = self.txtOficinas.dameValor()
            self.padre.instalacion.NumeroOtros = self.txtLocales.dameValor()
            self.padre.instalacion.EClimatizacion = self.radiosClimatizacion.dameElementoSeleccionado()
            self.padre.instalacion.ETarifaNocturna = self.radiosTarifaNocturna.dameElementoSeleccionado()
        except:
            pass



    def cargaDatos(self):
        self.txtSotanos.ponTexto(self.padre.instalacion.NumeroPlanta)
        self.txtViviendas.ponTexto(self.padre.instalacion.NumeroViviendas)
        self.txtOficinas.ponTexto(self.padre.instalacion.NumeroLocales)
        self.txtLocales.ponTexto(self.padre.instalacion.NumeroOtros)
        if (self.padre.instalacion.EClimatizacion > -1):
            self.radiosClimatizacion.radios[self.padre.instalacion.EClimatizacion].SetValue(1)
        if (self.padre.instalacion.ETarifaNocturna > -1):
            self.radiosTarifaNocturna.radios[self.padre.instalacion.ETarifaNocturna].SetValue(1)

#}}}

class Paso43B(Panel): #{{{
    __module__ = __name__

    def __init__(self, padre, w, h, clasePrincipal):
        Panel.__init__(self, padre, 2, 0)
        self.padre = clasePrincipal
        self.pasoSiguiente = 'Paso43C'
        self.pasoAnterior = 'Paso43A'
        self.potenciaTotalAlumbrado = 0
        self.receptores = []
        self.cargaConTarifaNocturna = [0,
         0,
         0]
        self.cargaSinTarifaNocturna = [0,
         0,
         0]
        self.insertaElemento(self.dibujaTitulo(self))
        self.insertaElemento(self.dibujaDatos(self))
        self.creceColumna(0)
        self.creceFila(1)
        self.cerrarPanel()
        self.SetSize([w,
         h])
        self.cargaDatos()
	if not self.padre.instalacion.esEditable("43B"): self.Enable(0)



    def dibujaTitulo(self, padre):
        panel = Panel(padre, 0, 3)
        centrado = Etiqueta(panel, '')
        centrado.ponEstilo(14, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(centrado)
        titulo = Etiqueta(panel, '4.3.B CARGA TOTAL DEL EDIFICIO - DATOS DE VIVIENDAS')
        titulo.ponEstilo(14, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(titulo)
        panel.insertaElemento(centrado)
        panel.creceColumna(0)
        panel.creceColumna(2)
        panel.cerrarPanel()
        panel.SetBackgroundColour(wxBLUE)
        return panel



    def dibujaDatos(self, padre):
        panel = Panel(padre, 2, 0)
        panel.insertaElemento(self.capturaDatos(panel))
        panel.insertaElemento(self.dibujaListaDatos(panel))
        panel.creceFila(1)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def capturaDatos(self, padre):
        panel = Panel(padre, 4, 0)
        panel.insertaElemento(self.damePanelUnidades(panel))
        panel.insertaElemento(self.dibujaPanelRadios(panel))
        panel.insertaElemento(self.dibujaBotonAceptar(panel))
        panel.insertaElemento(self.dibujaPanelResumen(panel))
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaBotonAceptar(self, padre):
        panel = Panel(padre, 2, 0)
        panel.insertaElemento(Boton(panel, 'Aceptar', self.aceptarReceptor, 'aceptar'))
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.creceColumna(1)
        panel.cerrarPanel()
        return panel



    def aceptarReceptor(self, event):
        error = 0
        if (self.txtNumero.dameValor() == 0):
            error = 1
        if (self.txtPotencia.dameValor() == 0.0):
            error = 1
        if (self.txtSuperficie.dameValor() == 0.0):
            error = 1
        if (self.radiosTarifaNocturna.dameElementoSeleccionado() == -1):
            error = 1
        if (self.radiosElectrificacion.dameElementoSeleccionado() == -1):
            error = 1
        if error:
            Error(self, 'Debe rellenar todos los campos')
        else:
            self.muestraResumen()
            if self.radiosTarifaNocturna.dameElementoSeleccionado():
                tarifaNocturna = 'No'
            else:
                tarifaNocturna = 'Si'
            if self.radiosElectrificacion.dameElementoSeleccionado():
                electrificacion = 'Elevada'
            else:
                electrificacion = 'Basica'
            lista = [str(self.txtNumero.dameValor()),
             self.txtSuperficie.dameValor(),
             tarifaNocturna,
             electrificacion,
             str(self.txtPotencia.dameValor()),
             str((self.txtNumero.dameValor() * self.txtPotencia.dameValor()))]
            self.listaAlumbrado.Append(lista)
            self.receptores.append(lista)
            self.txtSuperficie.ponTexto(0)
            self.etiquetaPotencia.ponTexto('Potencia Total (KW): 0')
            self.txtNumero.ponTexto(0)
            self.txtPotencia.ponTexto(0)
            self.radiosTarifaNocturna.radios[self.radiosTarifaNocturna.dameElementoSeleccionado()].SetValue(0)
            self.radiosElectrificacion.radios[self.radiosElectrificacion.dameElementoSeleccionado()].SetValue(0)



    def muestraResumen(self):
        if self.radiosTarifaNocturna.dameElementoSeleccionado():
            self.cargaSinTarifaNocturna[0] = (self.cargaSinTarifaNocturna[0] + (self.txtNumero.dameValor() * self.txtPotencia.dameValor()))
            self.cargaSinTarifaNocturna[1] = (self.cargaSinTarifaNocturna[1] + self.txtNumero.dameValor())
            try:
                potenciaMedia = (self.cargaSinTarifaNocturna[0] / self.cargaSinTarifaNocturna[1])
            except:
                potenciaMedia = 0
            self.radiosSinTarifa.radios[0].ponTexto(('Potencia media (KW): ' + str(potenciaMedia)))
            try:
                coeficiente = self.padre.coeficienteSimultaneidad[str(self.cargaSinTarifaNocturna[1])]
                coeficiente = float(coeficiente)
            except:
                coeficiente = (15.300000000000001 + ((self.cargaSinTarifaNocturna[1] - 21) * 0.5))
            self.radiosSinTarifa.radios[1].ponTexto(('Coeficiente simultaneidad: ' + str(coeficiente)))
            total = (potenciaMedia * coeficiente)
            self.cargaSinTarifaNocturna[2] = total
            self.radiosSinTarifa.radios[2].ponTexto(('Total (KW): ' + str(total)))
        else:
            self.cargaConTarifaNocturna[0] = (self.cargaConTarifaNocturna[0] + (self.txtNumero.dameValor() * self.txtPotencia.dameValor()))
            self.cargaConTarifaNocturna[1] = (self.cargaConTarifaNocturna[1] + self.txtNumero.dameValor())
            try:
                potenciaMedia = (self.cargaConTarifaNocturna[0] / self.cargaConTarifaNocturna[1])
            except:
                potenciaMedia = 0
            self.radiosConTarifa.radios[0].ponTexto(('Potencia media (KW): ' + str(potenciaMedia)))
            self.radiosConTarifa.radios[1].ponTexto(('Coeficiente simultaneidad: ' + str(self.cargaConTarifaNocturna[1])))
            total = (potenciaMedia * self.cargaConTarifaNocturna[1])
            self.radiosConTarifa.radios[2].ponTexto(('Total (KW): ' + str(total)))
            self.cargaConTarifaNocturna[2] = total
        self.potenciaTotalAlumbrado = (self.cargaSinTarifaNocturna[2] + self.cargaConTarifaNocturna[2])
        self.totalAlumbrado.ponTexto(('Carga Total prevista en vivienda (KW): ' + str(self.potenciaTotalAlumbrado)))



    def damePanelUnidades(self, padre):
        panel = Panel(padre, 2, 4)
        panel.insertaElemento(Etiqueta(panel, 'N\xba de Viviendas iguales'))
        panel.insertaElemento(Etiqueta(panel, 'Superficie'))
        panel.insertaElemento(Etiqueta(panel, 'Potencia por Vivienda'))
        panel.insertaElemento(Etiqueta(panel, ''))
        self.txtNumero = CampoMonetario(panel, 0)
        EVT_KILL_FOCUS(self.txtNumero, self.calculaPotenciaTotal)
        panel.insertaElemento(self.txtNumero)
        self.txtSuperficie = CampoMonetario(panel, 3)
        EVT_KILL_FOCUS(self.txtSuperficie, self.compruebaSuperficie)
        panel.insertaElemento(self.txtSuperficie)
        self.txtPotencia = CampoMonetario(panel, 3)
        EVT_KILL_FOCUS(self.txtPotencia, self.calculaPotenciaTotal)
        panel.insertaElemento(self.txtPotencia)
        self.etiquetaPotencia = Etiqueta(panel, 'Potencia Total (KW): 0')
        self.etiquetaPotencia.ponNegrita()
        panel.insertaElemento(self.etiquetaPotencia)
        panel.cerrarPanel()
        return panel



    def compruebaSuperficie(self, event):
        try:
            if ((self.txtSuperficie.dameValor() > 160) and (self.txtPotencia.dameValor() < 9.1999999999999993)):
                self.txtPotencia.ponTexto(9.1999999999999993)
                self.radiosElectrificacion.radios[1].SetValue(1)
            elif (self.txtPotencia.dameValor() < 9.1999999999999993):
                self.radiosElectrificacion.radios[0].SetValue(1)
        except:
            pass



    def calculaPotenciaTotal(self, event):
        try:
            if (self.txtPotencia.dameValor() < 9.1999999999999993):
                if (self.txtSuperficie.dameValor() > 160):
                    self.radiosElectrificacion.radios[1].SetValue(1)
                else:
                    self.radiosElectrificacion.radios[0].SetValue(1)
            else:
                self.radiosElectrificacion.radios[1].SetValue(1)
            totalPotencia = (self.txtNumero.dameValor() * self.txtPotencia.dameValor())
            self.etiquetaPotencia.ponTexto(('Potencia Total (KW): ' + str(totalPotencia)))
        except:
            pass



    def dibujaPanelRadios(self, padre):
        panel = Panel(padre, 0, 2)
        self.radiosTarifaNocturna = CajaRadio(panel, 'Tarifa nocturna', ['Si',
         'No'])
        panel.insertaElemento(self.radiosTarifaNocturna.dibujaCajaRadio())
        self.radiosElectrificacion = CajaRadio(panel, 'Electrificaci\xf3n', ['B\xe1sica',
         'Elevada'])
        panel.insertaElemento(self.radiosElectrificacion.dibujaCajaRadio())
        self.radiosElectrificacion.radios[0].Enable(0)
        self.radiosElectrificacion.radios[1].Enable(0)
        panel.cerrarPanel()
        return panel



    def dibujaPanelResumen(self, padre):
        panel = Panel(padre, 0, 2)
        self.radiosSinTarifa = CajaRadio(panel, 'Carga Prevista en Viviendas sin Tarifa nocturna', ['Potencia media (KW): 0',
         'Coeficiente simultaneidad: 0',
         'Total (KW): 0'], 1)
        panel.insertaElemento(self.radiosSinTarifa.dibujaCajaRadio())
        self.radiosConTarifa = CajaRadio(panel, 'Carga Prevista en Viviendas con Tarifa nocturna', ['Potencia media (KW): 0',
         'Coeficiente simultaneidad: 0',
         'Total (KW): 0'], 1)
        panel.insertaElemento(self.radiosConTarifa.dibujaCajaRadio())
        panel.creceColumna(0)
        panel.creceColumna(1)
        panel.cerrarPanel()
        return panel



    def dibujaListaDatos(self, padre):
        panel = Panel(padre, 2, 0)
        self.listaAlumbrado = ListaColumna(panel, self.receptorSeleccionado, self.receptorDeseleccionado)
        self.listaAlumbrado.cabeceraColumnas(['Unidades',
         'Superficie',
         'Tarifa Nocturna',
         'Electrificaci\xf3n',
         'Potencia',
         'Totales'])
        self.listaAlumbrado.SetColumnWidth(2, -2)
        panel.insertaElemento(self.listaAlumbrado)
        panel.insertaElemento(self.dibujaResultado(panel))
        panel.creceColumna(0)
        panel.creceFila(0)
        panel.cerrarPanel()
        return panel



    def receptorSeleccionado(self, event):
        self.botonEliminar.Enable(1)
        self.botonModificar.Enable(1)
        self.itemSeleccionado = event.m_itemIndex



    def receptorDeseleccionado(self, event):
        self.botonEliminar.Enable(0)
        self.botonModificar.Enable(0)



    def dibujaResultado(self, padre):
        panel = Panel(padre, 0, 4)
        self.botonEliminar = Boton(panel, 'Eliminar', self.eliminarReceptor, 'eliminar')
        self.botonEliminar.Enable(0)
        self.botonModificar = Boton(panel, 'Modificar', self.modificarReceptor, 'izquierda')
        self.botonModificar.Enable(0)
        self.totalAlumbrado = Etiqueta(panel, 'Carga Total prevista en viviendas (KW): 0')
        self.totalAlumbrado.ponNegrita()
        panel.insertaElemento(self.totalAlumbrado)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.insertaElemento(self.botonModificar)
        panel.insertaElemento(self.botonEliminar)
        panel.creceColumna(1)
        panel.cerrarPanel()
        return panel



    def modificarReceptor(self, event):
        (unidades, superficie, tarifa, electrificacion, potencia, total,) = self.receptores[self.itemSeleccionado]
        self.txtNumero.ponTexto(int(unidades))
        self.txtSuperficie.ponTexto(float(superficie))
        self.txtPotencia.ponTexto(float(potencia))
        if (tarifa == 'Si'):
            self.radiosTarifaNocturna.radios[0].SetValue(1)
        else:
            self.radiosTarifaNocturna.radios[1].SetValue(1)
        if (electrificacion == 'Elevada'):
            self.radiosElectrificacion.radios[1].SetValue(1)
        else:
            self.radiosElectrificacion.radios[0].SetValue(1)
        self.calculaPotenciaTotal(event)
        self.eliminarReceptor(event)



    def eliminarReceptor(self, event):
        (unidades, superficie, tarifa, electrificacion, potencia, total,) = self.receptores[self.itemSeleccionado]
        del self.receptores[self.itemSeleccionado]
        self.listaAlumbrado.DeleteItem(self.itemSeleccionado)
        self.eliminaDeResumen(tarifa, unidades, total)



    def eliminaDeResumen(self, tarifa, unidades, total):
        if (tarifa == 'No'):
            self.cargaSinTarifaNocturna[0] = (self.cargaSinTarifaNocturna[0] - float(total))
            self.cargaSinTarifaNocturna[1] = (self.cargaSinTarifaNocturna[1] - int(unidades))
            try:
                potenciaMedia = (self.cargaSinTarifaNocturna[0] / self.cargaSinTarifaNocturna[1])
            except:
                potenciaMedia = 0
            self.radiosSinTarifa.radios[0].ponTexto(('Potencia media (KW): ' + str(potenciaMedia)))
            try:
                coeficiente = self.padre.coeficienteSimultaneidad[str(self.cargaSinTarifaNocturna[1])]
                coeficiente = float(coeficiente)
            except:
                coeficiente = (15.300000000000001 + ((self.cargaSinTarifaNocturna[1] - 21) * 0.5))
            self.radiosSinTarifa.radios[1].ponTexto(('Coeficiente simultaneidad: ' + str(coeficiente)))
            total = (potenciaMedia * coeficiente)
            self.cargaSinTarifaNocturna[2] = total
            self.radiosSinTarifa.radios[2].ponTexto(('Total (KW): ' + str(total)))
        else:
            self.cargaConTarifaNocturna[0] = (self.cargaConTarifaNocturna[0] - float(total))
            self.cargaConTarifaNocturna[1] = (self.cargaConTarifaNocturna[1] - float(unidades))
            try:
                potenciaMedia = (self.cargaConTarifaNocturna[0] / self.cargaConTarifaNocturna[1])
            except:
                potenciaMedia = 0
            self.radiosConTarifa.radios[0].ponTexto(('Potencia media (KW): ' + str(potenciaMedia)))
            self.radiosConTarifa.radios[1].ponTexto(('Coeficiente simultaneidad: ' + str(self.cargaConTarifaNocturna[1])))
            total = (potenciaMedia * self.cargaConTarifaNocturna[1])
            self.radiosConTarifa.radios[2].ponTexto(('Total (KW): ' + str(total)))
            self.cargaConTarifaNocturna[2] = total
        self.potenciaTotalAlumbrado = (self.cargaSinTarifaNocturna[2] + self.cargaConTarifaNocturna[2])
        self.totalAlumbrado.ponTexto(('Carga Total prevista en viviendas (KW): ' + str(self.potenciaTotalAlumbrado)))



    def comprobarSiguientePaso(self):
        self.guardaDatos()



    def guardaDatos(self):
        try:
            self.padre.instalacion.previsionViviendas = self.receptores
            self.padre.instalacion.totalPrevisionViviendas = self.potenciaTotalAlumbrado
        except:
            pass



    def cargaDatos(self):
        self.receptores = self.padre.instalacion.previsionViviendas
        for prevision in self.padre.instalacion.previsionViviendas:
            self.muestraResumenCargaDatos(prevision[2], prevision[5], prevision[0])
            self.listaAlumbrado.Append(prevision)




    def muestraResumenCargaDatos(self, tarifa, total, unidades):
        if (tarifa == 'No'):
            self.cargaSinTarifaNocturna[0] = (self.cargaSinTarifaNocturna[0] + float(total))
            self.cargaSinTarifaNocturna[1] = (self.cargaSinTarifaNocturna[1] + int(unidades))
            try:
                potenciaMedia = (self.cargaSinTarifaNocturna[0] / self.cargaSinTarifaNocturna[1])
            except:
                potenciaMedia = 0
            self.radiosSinTarifa.radios[0].ponTexto(('Potencia media (KW): ' + str(potenciaMedia)))
            try:
                coeficiente = self.padre.coeficienteSimultaneidad[str(self.cargaSinTarifaNocturna[1])]
                coeficiente = float(coeficiente)
            except:
                coeficiente = (15.300000000000001 + ((self.cargaSinTarifaNocturna[1] - 21) * 0.5))
            self.radiosSinTarifa.radios[1].ponTexto(('Coeficiente simultaneidad: ' + str(coeficiente)))
            total = (potenciaMedia * coeficiente)
            self.cargaSinTarifaNocturna[2] = total
            self.radiosSinTarifa.radios[2].ponTexto(('Total (KW): ' + str(total)))
        else:
            self.cargaConTarifaNocturna[0] = (self.cargaConTarifaNocturna[0] + float(total))
            self.cargaConTarifaNocturna[1] = (self.cargaConTarifaNocturna[1] + int(unidades))
            try:
                potenciaMedia = (self.cargaConTarifaNocturna[0] / self.cargaConTarifaNocturna[1])
            except:
                potenciaMedia = 0
            self.radiosConTarifa.radios[0].ponTexto(('Potencia media (KW): ' + str(potenciaMedia)))
            self.radiosConTarifa.radios[1].ponTexto(('Coeficiente simultaneidad: ' + str(self.cargaConTarifaNocturna[1])))
            total = (potenciaMedia * self.cargaConTarifaNocturna[1])
            self.radiosConTarifa.radios[2].ponTexto(('Total (KW): ' + str(total)))
            self.cargaConTarifaNocturna[2] = total
        self.potenciaTotalAlumbrado = (self.cargaSinTarifaNocturna[2] + self.cargaConTarifaNocturna[2])
        self.totalAlumbrado.ponTexto(('Carga Total prevista en vivienda (KW): ' + str(self.potenciaTotalAlumbrado)))

#}}}

class Paso43C(Panel): #{{{
    __module__ = __name__

    def __init__(self, padre, w, h, clasePrincipal):
        Panel.__init__(self, padre, 2, 0)
        self.padre = clasePrincipal
        self.pasoSiguiente = 'Paso43D'
        self.pasoAnterior = 'Paso43B'
        self.potenciaTotalAlumbrado = 0
        self.receptores = []
        self.insertaElemento(self.dibujaTitulo(self))
        self.insertaElemento(self.dibujaDatos(self))
        self.creceColumna(0)
        self.creceFila(1)
        self.cerrarPanel()
        self.SetSize([w,
         h])
        self.cargaDatos()
	if not self.padre.instalacion.esEditable("43C"): self.Enable(0)



    def dibujaTitulo(self, padre):
        panel = Panel(padre, 0, 3)
        centrado = Etiqueta(panel, '')
        centrado.ponEstilo(14, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(centrado)
        titulo = Etiqueta(panel, '4.3.C CARGA TOTAL DEL EDIFICIO - DATOS DE LOCALES')
        titulo.ponEstilo(14, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(titulo)
        panel.insertaElemento(centrado)
        panel.creceColumna(0)
        panel.creceColumna(2)
        panel.cerrarPanel()
        panel.SetBackgroundColour(wxBLUE)
        return panel



    def dibujaDatos(self, padre):
        panel = Panel(padre, 2, 0)
        panel.insertaElemento(self.capturaDatos(panel))
        panel.insertaElemento(self.dibujaListaDatos(panel))
        panel.creceFila(1)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def capturaDatos(self, padre):
        panel = Panel(padre, 4, 0)
        panel.insertaElemento(self.damePanelUnidades(panel))
        panel.insertaElemento(self.dibujaBotonAceptar(panel))
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaBotonAceptar(self, padre):
        panel = Panel(padre, 2, 0)
        panel.insertaElemento(Boton(panel, 'Aceptar', self.aceptarReceptor, 'aceptar'))
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.creceColumna(1)
        panel.cerrarPanel()
        return panel



    def aceptarReceptor(self, event):
        error = 0
        if (self.txtNumero.dameValor() == 0):
            error = 1
        if (self.txtPotencia.dameValor() == 0.0):
            error = 1
        if (self.txtSuperficie.dameValor() == 0.0):
            error = 1
        if error:
            Error(self, 'Debe rellenar todos los campos')
        else:
            potenciaL = [3.4500000000000002,
             (self.txtNumero.dameValor() * self.txtPotencia.dameValor()),
             (self.txtSuperficie.dameValor() * 0.10000000000000001)]
            potencia = 0
            for i in potenciaL:
                if (potencia < i):
                    potencia = i

            lista = [str(self.txtNumero.dameValor()),
             str(self.txtSuperficie.dameValor()),
             str(self.txtPotencia.dameValor()),
             str(potencia)]
            self.listaAlumbrado.Append(lista)
            self.receptores.append(lista)
            self.txtSuperficie.ponTexto(0)
            self.etiquetaPotencia.ponTexto('Potencia Total (KW): 0')
            self.potenciaTotalAlumbrado = (self.potenciaTotalAlumbrado + (self.txtNumero.dameValor() * self.txtPotencia.dameValor()))
            self.totalAlumbrado.ponTexto(('Carga Total prevista en locales (KW): ' + str(self.potenciaTotalAlumbrado)))
            self.txtNumero.ponTexto(0)
            self.txtPotencia.ponTexto(0)



    def damePanelUnidades(self, padre):
        panel = Panel(padre, 2, 4)
        panel.insertaElemento(Etiqueta(panel, 'N\xba de Locales iguales'))
        panel.insertaElemento(Etiqueta(panel, 'Superficie'))
        panel.insertaElemento(Etiqueta(panel, 'Carga prevista por Local'))
        panel.insertaElemento(Etiqueta(panel, ''))
        self.txtNumero = CampoMonetario(panel, 0)
        EVT_KILL_FOCUS(self.txtNumero, self.calculaPotenciaTotal)
        panel.insertaElemento(self.txtNumero)
        self.txtSuperficie = CampoMonetario(panel, 2)
        panel.insertaElemento(self.txtSuperficie)
        self.txtPotencia = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtPotencia, self.calculaPotenciaTotal)
        panel.insertaElemento(self.txtPotencia)
        self.etiquetaPotencia = Etiqueta(panel, 'Potencia Total (KW): 0')
        self.etiquetaPotencia.ponNegrita()
        panel.insertaElemento(self.etiquetaPotencia)
        panel.cerrarPanel()
        return panel



    def calculaPotenciaTotal(self, event):
        try:
            totalPotencia = (self.txtNumero.dameValor() * self.txtPotencia.dameValor())
            self.etiquetaPotencia.ponTexto(('Potencia Total (KW): ' + str(totalPotencia)))
        except:
            pass



    def dibujaListaDatos(self, padre):
        panel = Panel(padre, 2, 0)
        self.listaAlumbrado = ListaColumna(panel, self.receptorSeleccionado, self.receptorDeseleccionado)
        self.listaAlumbrado.cabeceraColumnas(['Unidades',
         'Superficie',
         'Carga Prevista por Local',
         'Total'])
        self.listaAlumbrado.SetColumnWidth(2, -2)
        panel.insertaElemento(self.listaAlumbrado)
        panel.insertaElemento(self.dibujaResultado(panel))
        panel.creceColumna(0)
        panel.creceFila(0)
        panel.cerrarPanel()
        return panel



    def receptorSeleccionado(self, event):
        self.botonEliminar.Enable(1)
        self.botonModificar.Enable(1)
        self.itemSeleccionado = event.m_itemIndex



    def receptorDeseleccionado(self, event):
        self.botonEliminar.Enable(0)
        self.botonModificar.Enable(0)



    def dibujaResultado(self, padre):
        panel = Panel(padre, 0, 4)
        self.botonEliminar = Boton(panel, 'Eliminar', self.eliminarReceptor, 'eliminar')
        self.botonEliminar.Enable(0)
        self.botonModificar = Boton(panel, 'Modificar', self.modificarReceptor, 'izquierda')
        self.botonModificar.Enable(0)
        self.totalAlumbrado = Etiqueta(panel, 'Carga Total prevista en locales (KW): 0')
        self.totalAlumbrado.ponNegrita()
        panel.insertaElemento(self.totalAlumbrado)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.insertaElemento(self.botonModificar)
        panel.insertaElemento(self.botonEliminar)
        panel.creceColumna(0)
        panel.creceColumna(1)
        panel.cerrarPanel()
        return panel



    def modificarReceptor(self, event):
        (unidades, superficie, potencia, total,) = self.receptores[self.itemSeleccionado]
        self.txtNumero.ponTexto(int(unidades))
        self.txtSuperficie.ponTexto(float(superficie))
        self.txtPotencia.ponTexto(float(potencia))
        self.calculaPotenciaTotal(event)
        self.eliminarReceptor(event)



    def eliminarReceptor(self, event):
        (unidades, superficie, potencia, total,) = self.receptores[self.itemSeleccionado]
        del self.receptores[self.itemSeleccionado]
        self.listaAlumbrado.DeleteItem(self.itemSeleccionado)
        self.potenciaTotalAlumbrado = (self.potenciaTotalAlumbrado - float(total))
        self.totalAlumbrado.ponTexto(('Carga Total prevista en locales (KW): ' + str(self.potenciaTotalAlumbrado)))



    def comprobarSiguientePaso(self):
        self.guardaDatos()



    def guardaDatos(self):
        try:
            self.padre.instalacion.previsionLocales = self.receptores
            self.padre.instalacion.totalPrevisionLocales = self.potenciaTotalAlumbrado
        except:
            pass



    def cargaDatos(self):
        suma = 0
        self.receptores = self.padre.instalacion.previsionLocales
        for locales in self.padre.instalacion.previsionLocales:
            suma = (suma + float(locales[3]))
            self.listaAlumbrado.Append(locales)

        self.totalAlumbrado.ponTexto(('Carga Total prevista en locales (KW): ' + str(suma)))
        self.potenciaTotalAlumbrado = suma

#}}}

class Paso43D(Panel): #{{{
    __module__ = __name__

    def __init__(self, padre, w, h, clasePrincipal):
        Panel.__init__(self, padre, 2, 0)
        self.padre = clasePrincipal
        self.pasoSiguiente = 'Paso43E'
        self.pasoAnterior = 'Paso43C'
        self.sumaPotenciaTotal = [0,
         0,
         0,
         0,
         0,
         0,
         0,
         0]
        self.insertaElemento(self.dibujaTitulo(self))
        self.insertaElemento(self.dibujaDatos(self))
        self.creceColumna(0)
        self.creceFila(1)
        self.cerrarPanel()
        self.SetSize([w,
         h])
        self.cargaDatos()
	if not self.padre.instalacion.esEditable("43D"): self.Enable(0)



    def dibujaTitulo(self, padre):
        panel = Panel(padre, 0, 3)
        centrado = Etiqueta(panel, '')
        centrado.ponEstilo(13, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(centrado)
        titulo = Etiqueta(panel, '4.3.D CARGA TOTAL DEL EDIFICIO - SERVICIOS GENERALES')
        titulo.ponEstilo(13, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(titulo)
        panel.insertaElemento(centrado)
        panel.creceColumna(0)
        panel.creceColumna(2)
        panel.cerrarPanel()
        panel.SetBackgroundColour(wxBLUE)
        return panel



    def dibujaDatos(self, padre):
        panel = Panel(padre, 17, 0)
        etiqueta = Etiqueta(panel, 'Centro de producci\xf3n de calor')
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        panel.insertaElemento(self.dibujaDatosCalor(panel))
        etiqueta = Etiqueta(panel, 'Centro de producci\xf3n de fr\xedo')
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        panel.insertaElemento(self.dibujaDatosFrio(panel))
        etiqueta = Etiqueta(panel, 'Ascensores')
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        panel.insertaElemento(self.dibujaDatosAscensor(panel))
        etiqueta = Etiqueta(panel, 'Otros elevadores (montacargas, elevadores minusv\xe1lidos, etc...)')
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        panel.insertaElemento(self.dibujaDatosOtrosElevadores(panel))
        etiqueta = Etiqueta(panel, 'Alumbrado portal, escaleras y espacios comunes')
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        panel.insertaElemento(self.dibujaDatosAlumbrado(panel))
        etiqueta = Etiqueta(panel, 'Garaje')
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        panel.insertaElemento(self.dibujaDatosGaraje(panel))
        etiqueta = Etiqueta(panel, 'Grupos de presi\xf3n')
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        panel.insertaElemento(self.dibujaDatosGrupos(panel))
        etiqueta = Etiqueta(panel, 'Otros servicios (indicar)')
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        panel.insertaElemento(self.dibujaDatosOtrosServicios(panel))
        self.etiquetaTotal = Etiqueta(panel, 'Carga total en servicios generales (KW): 0')
        self.etiquetaTotal.ponNegrita()
        panel.insertaElemento(self.etiquetaTotal)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaDatosCalor(self, padre):
        panel = Panel(padre, 0, 6)
        panel.insertaElemento(Etiqueta(panel, 'Unidades'))
        self.txtUnidadCalor = CampoMonetario(panel, 0)
        EVT_KILL_FOCUS(self.txtUnidadCalor, self.calculaPotenciaCalor)
        panel.insertaElemento(self.txtUnidadCalor)
        panel.insertaElemento(Etiqueta(panel, 'Potencia Por Unidad'))
        self.txtPotenciaUnidadCalor = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtPotenciaUnidadCalor, self.calculaPotenciaCalor)
        panel.insertaElemento(self.txtPotenciaUnidadCalor)
        self.etiquetaTotalCalor = Etiqueta(panel, 'Totales (KW): 0')
        self.etiquetaTotalCalor.ponNegrita()
        panel.insertaElemento(self.etiquetaTotalCalor)
        panel.cerrarPanel()
        return panel



    def calculaPotenciaCalor(self, event = None):
        try:
            potencia = (self.txtUnidadCalor.dameValor() * self.txtPotenciaUnidadCalor.dameValor())
            self.etiquetaTotalCalor.ponTexto(('Totales (KW): ' + str(potencia)))
            self.sumaPotenciaTotal[0] = potencia
            self.calculaSumaTotal()
            if event:
                event.Skip()
        except:
            pass



    def dibujaDatosFrio(self, padre):
        panel = Panel(padre, 0, 6)
        panel.insertaElemento(Etiqueta(panel, 'Unidades'))
        self.txtUnidadFrio = CampoMonetario(panel, 0)
        EVT_KILL_FOCUS(self.txtUnidadFrio, self.calculaPotenciaFrio)
        panel.insertaElemento(self.txtUnidadFrio)
        panel.insertaElemento(Etiqueta(panel, 'Potencia Por Unidad'))
        self.txtPotenciaUnidadFrio = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtPotenciaUnidadFrio, self.calculaPotenciaFrio)
        panel.insertaElemento(self.txtPotenciaUnidadFrio)
        self.etiquetaTotalFrio = Etiqueta(panel, 'Totales (KW): 0')
        self.etiquetaTotalFrio.ponNegrita()
        panel.insertaElemento(self.etiquetaTotalFrio)
        panel.cerrarPanel()
        return panel



    def calculaPotenciaFrio(self, event = None):
        try:
            potencia = (self.txtUnidadFrio.dameValor() * self.txtPotenciaUnidadFrio.dameValor())
            self.etiquetaTotalFrio.ponTexto(('Totales (KW): ' + str(potencia)))
            self.sumaPotenciaTotal[1] = potencia
            self.calculaSumaTotal()
            if event:
                event.Skip()
        except:
            pass



    def dibujaDatosAscensor(self, padre):
        panel = Panel(padre, 0, 6)
        panel.insertaElemento(Etiqueta(panel, 'Unidades'))
        self.txtUnidadAscensor = CampoMonetario(panel, 0)
        EVT_KILL_FOCUS(self.txtUnidadAscensor, self.calculaPotenciaAscensor)
        panel.insertaElemento(self.txtUnidadAscensor)
        panel.insertaElemento(Etiqueta(panel, 'Potencia Por Unidad'))
        self.txtPotenciaUnidadAscensor = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtPotenciaUnidadAscensor, self.calculaPotenciaAscensor)
        panel.insertaElemento(self.txtPotenciaUnidadAscensor)
        self.etiquetaTotalAscensor = Etiqueta(panel, 'Totales (KW): 0')
        self.etiquetaTotalAscensor.ponNegrita()
        panel.insertaElemento(self.etiquetaTotalAscensor)
        panel.cerrarPanel()
        return panel



    def calculaPotenciaAscensor(self, event = None):
        try:
            potencia = (self.txtUnidadAscensor.dameValor() * self.txtPotenciaUnidadAscensor.dameValor())
            self.etiquetaTotalAscensor.ponTexto(('Totales (KW): ' + str(potencia)))
            self.sumaPotenciaTotal[2] = potencia
            self.calculaSumaTotal()
            if event:
                event.Skip()
        except:
            pass



    def dibujaDatosOtrosElevadores(self, padre):
        panel = Panel(padre, 0, 6)
        panel.insertaElemento(Etiqueta(panel, 'Unidades'))
        self.txtUnidadOtrosElevadores = CampoMonetario(panel, 0)
        EVT_KILL_FOCUS(self.txtUnidadOtrosElevadores, self.calculaPotenciaOtrosElevadores)
        panel.insertaElemento(self.txtUnidadOtrosElevadores)
        panel.insertaElemento(Etiqueta(panel, 'Potencia Por Unidad'))
        self.txtPotenciaUnidadOtrosElevadores = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtPotenciaUnidadOtrosElevadores, self.calculaPotenciaOtrosElevadores)
        panel.insertaElemento(self.txtPotenciaUnidadOtrosElevadores)
        self.etiquetaTotalOtrosElevadores = Etiqueta(panel, 'Totales (KW): 0')
        self.etiquetaTotalOtrosElevadores.ponNegrita()
        panel.insertaElemento(self.etiquetaTotalOtrosElevadores)
        panel.cerrarPanel()
        return panel



    def calculaPotenciaOtrosElevadores(self, event = None):
        try:
            potencia = (self.txtUnidadOtrosElevadores.dameValor() * self.txtPotenciaUnidadOtrosElevadores.dameValor())
            self.etiquetaTotalOtrosElevadores.ponTexto(('Totales (KW): ' + str(potencia)))
            self.sumaPotenciaTotal[3] = potencia
            self.calculaSumaTotal()
            if event:
                event.Skip()
        except:
            pass



    def dibujaDatosAlumbrado(self, padre):
        panel = Panel(padre, 0, 6)
        panel.insertaElemento(Etiqueta(panel, 'Totales (KW):'))
        self.txtTotalAlumbrado = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtTotalAlumbrado, self.calculaPotenciaAlumbrado)
        panel.insertaElemento(self.txtTotalAlumbrado)
        panel.cerrarPanel()
        return panel



    def calculaPotenciaAlumbrado(self, event = None):
        try:
            self.sumaPotenciaTotal[4] = self.txtTotalAlumbrado.dameValor()
            self.calculaSumaTotal()
            if event:
                event.Skip()
        except:
            pass



    def dibujaDatosGaraje(self, padre):
        panel = Panel(padre, 2, 5)
        panel.insertaElemento(Etiqueta(panel, 'Unidades'))
        self.txtUnidadGaraje = CampoMonetario(panel, 0)
        EVT_KILL_FOCUS(self.txtUnidadGaraje, self.calculaPotenciaGaraje)
        panel.insertaElemento(self.txtUnidadGaraje)
        panel.insertaElemento(Etiqueta(panel, 'Superficie'))
        self.txtSuperficieGaraje = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtSuperficieGaraje, self.calculaPotenciaGaraje)
        panel.insertaElemento(self.txtSuperficieGaraje)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.insertaElemento(Etiqueta(panel, 'Potencia Por Unidad'))
        self.txtPotenciaUnidadGaraje = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtPotenciaUnidadGaraje, self.calculaPotenciaGaraje)
        panel.insertaElemento(self.txtPotenciaUnidadGaraje)
        panel.insertaElemento(Etiqueta(panel, 'Ventilaci\xf3n'))
        self.txtVentilacion = Combo(panel, ['Natural',
         'Forzada'])
        EVT_COMBOBOX(self.txtVentilacion, self.txtVentilacion.GetId(), self.calculaPotenciaGaraje)
        panel.insertaElemento(self.txtVentilacion)
        self.etiquetaTotalGaraje = Etiqueta(panel, 'Totales (KW): 0')
        self.etiquetaTotalGaraje.ponNegrita()
        panel.insertaElemento(self.etiquetaTotalGaraje)
        panel.cerrarPanel()
        return panel



    def calculaPotenciaGaraje(self, event = None):
        try:
            potencia = (self.txtUnidadGaraje.dameValor() * self.txtPotenciaUnidadGaraje.dameValor())
            if (self.txtVentilacion.GetSelection() == 0):
                potSup = (self.txtSuperficieGaraje.dameValor() * 0.01)
            elif (self.txtVentilacion.GetSelection() == 1):
                potSup = (self.txtSuperficieGaraje.dameValor() * 0.02)
            else:
                potSup = 0
            resultado = [3.3999999999999999,
             potencia,
             potSup]
            potencia = 0
            if (not (resultado[1] == 0)):
                for i in resultado:
                    if (potencia < i):
                        potencia = i

            self.etiquetaTotalGaraje.ponTexto(('Totales (KW): ' + str(potencia)))
            self.sumaPotenciaTotal[5] = potencia
            self.calculaSumaTotal()
            if event:
                event.Skip()
        except:
            pass



    def dibujaDatosGrupos(self, padre):
        panel = Panel(padre, 0, 6)
        panel.insertaElemento(Etiqueta(panel, 'Unidades'))
        self.txtUnidadGrupos = CampoMonetario(panel, 0)
        EVT_KILL_FOCUS(self.txtUnidadGrupos, self.calculaPotenciaGrupos)
        panel.insertaElemento(self.txtUnidadGrupos)
        panel.insertaElemento(Etiqueta(panel, 'Potencia Por Unidad'))
        self.txtPotenciaUnidadGrupos = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtPotenciaUnidadGrupos, self.calculaPotenciaGrupos)
        panel.insertaElemento(self.txtPotenciaUnidadGrupos)
        self.etiquetaTotalGrupos = Etiqueta(panel, 'Totales (KW): 0')
        self.etiquetaTotalGrupos.ponNegrita()
        panel.insertaElemento(self.etiquetaTotalGrupos)
        panel.cerrarPanel()
        return panel



    def calculaPotenciaGrupos(self, event = None):
        try:
            potencia = (self.txtUnidadGrupos.dameValor() * self.txtPotenciaUnidadGrupos.dameValor())
            self.etiquetaTotalGrupos.ponTexto(('Totales (KW): ' + str(potencia)))
            self.sumaPotenciaTotal[6] = potencia
            self.calculaSumaTotal()
            if event:
                event.Skip()
        except:
            pass



    def dibujaDatosOtrosServicios(self, padre):
        panel = Panel(padre, 0, 6)
        self.txtOtrosServicios = AreaTexto(panel)
        panel.insertaElemento(self.txtOtrosServicios)
        panel.insertaElemento(Etiqueta(panel, 'Totales (KW):'))
        self.txtTotalOtrosServicios = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtTotalOtrosServicios, self.calculaPotenciaOtrosServicios)
        panel.insertaElemento(self.txtTotalOtrosServicios)
        panel.cerrarPanel()
        return panel



    def calculaPotenciaOtrosServicios(self, event = None):
        try:
            self.sumaPotenciaTotal[7] = self.txtTotalOtrosServicios.dameValor()
            self.calculaSumaTotal()
            if event:
                event.Skip()
        except:
            pass



    def comprobarSiguientePaso(self):
        self.guardaDatos()



    def calculaSumaTotal(self):
        suma = 0
        for i in range(len(self.sumaPotenciaTotal)):
            suma = (suma + self.sumaPotenciaTotal[i])

        self.etiquetaTotal.ponTexto(('Carga total en servicios generales (KW): ' + str(suma)))



    def guardaDatos(self):
        try:
            elemento1 = ['Central de produccion de calor',
             self.txtUnidadCalor.dameValor(),
             self.txtPotenciaUnidadCalor.dameValor(),
             (self.txtUnidadCalor.dameValor() * self.txtPotenciaUnidadCalor.dameValor())]
            elemento2 = ['Central de produccion de frio',
             self.txtUnidadFrio.dameValor(),
             self.txtPotenciaUnidadFrio.dameValor(),
             (self.txtUnidadFrio.dameValor() * self.txtPotenciaUnidadFrio.dameValor())]
            elemento3 = ['Ascensores',
             self.txtUnidadAscensor.dameValor(),
             self.txtPotenciaUnidadAscensor.dameValor(),
             (self.txtUnidadAscensor.dameValor() * self.txtPotenciaUnidadAscensor.dameValor())]
            elemento4 = ['Otros elevadores',
             self.txtUnidadOtrosElevadores.dameValor(),
             self.txtPotenciaUnidadOtrosElevadores.dameValor(),
             (self.txtUnidadOtrosElevadores.dameValor() * self.txtPotenciaUnidadOtrosElevadores.dameValor())]
            elemento5 = ['Alumbrado y espacios comunes',
             self.txtTotalAlumbrado.dameValor()]
            elemento6 = ['Garajes',
             self.txtUnidadGaraje.dameValor(),
             self.txtPotenciaUnidadGaraje.dameValor(),
             (self.txtUnidadGaraje.dameValor() * self.txtPotenciaUnidadGaraje.dameValor()),
             self.txtSuperficieGaraje.dameValor(),
             self.txtVentilacion.dameValor()]
            elemento7 = ['Grupos de presion',
             self.txtUnidadGrupos.dameValor(),
             self.txtPotenciaUnidadGrupos.dameValor(),
             (self.txtUnidadGrupos.dameValor() * self.txtPotenciaUnidadGrupos.dameValor())]
            elemento8 = ['Otros servicios',
             self.txtOtrosServicios.dameValor(),
             self.txtTotalOtrosServicios.dameValor()]
            elementos = [elemento1,
             elemento2,
             elemento3,
             elemento4,
             elemento5,
             elemento6,
             elemento7,
             elemento8]
            self.padre.instalacion.previsionServiciosGenerales = elementos
            self.padre.instalacion.totalPrevisionServicios = self.dameSumaTotal()
        except:
            pass



    def dameSumaTotal(self):
        suma = 0
        for i in range(len(self.sumaPotenciaTotal)):
            suma = (suma + self.sumaPotenciaTotal[i])

        return suma



    def cargaDatos(self):
        try:
            self.txtUnidadCalor.ponTexto(self.padre.instalacion.previsionServiciosGenerales[0][1])
            self.txtPotenciaUnidadCalor.ponTexto(self.padre.instalacion.previsionServiciosGenerales[0][2])
            self.calculaPotenciaCalor()
            self.txtUnidadFrio.ponTexto(self.padre.instalacion.previsionServiciosGenerales[1][1])
            self.txtPotenciaUnidadFrio.ponTexto(self.padre.instalacion.previsionServiciosGenerales[1][2])
            self.calculaPotenciaFrio()
            self.txtUnidadAscensor.ponTexto(self.padre.instalacion.previsionServiciosGenerales[2][1])
            self.txtPotenciaUnidadAscensor.ponTexto(self.padre.instalacion.previsionServiciosGenerales[2][2])
            self.calculaPotenciaAscensor()
            self.txtUnidadOtrosElevadores.ponTexto(self.padre.instalacion.previsionServiciosGenerales[3][1])
            self.txtPotenciaUnidadOtrosElevadores.ponTexto(self.padre.instalacion.previsionServiciosGenerales[3][2])
            self.calculaPotenciaOtrosElevadores()
            self.txtTotalAlumbrado.ponTexto(self.padre.instalacion.previsionServiciosGenerales[4][1])
            self.calculaPotenciaAlumbrado()
            self.txtUnidadGaraje.ponTexto(self.padre.instalacion.previsionServiciosGenerales[5][1])
            self.txtPotenciaUnidadGaraje.ponTexto(self.padre.instalacion.previsionServiciosGenerales[5][2])
            self.txtSuperficieGaraje.ponTexto(self.padre.instalacion.previsionServiciosGenerales[5][4])
            self.calculaPotenciaGaraje()
            self.txtUnidadGrupos.ponTexto(self.padre.instalacion.previsionServiciosGenerales[6][1])
            self.txtPotenciaUnidadGrupos.ponTexto(self.padre.instalacion.previsionServiciosGenerales[6][2])
            self.calculaPotenciaGrupos()
            self.txtOtrosServicios.ponTexto(self.padre.instalacion.previsionServiciosGenerales[7][1])
            self.txtTotalOtrosServicios.ponTexto(self.padre.instalacion.previsionServiciosGenerales[7][2])
            self.calculaPotenciaOtrosServicios()
            self.txtVentilacion.seleccionaValor(self.padre.instalacion.previsionServiciosGenerales[5][5])
        except:
            pass

#}}}

class Paso43E(Panel): #{{{
    __module__ = __name__

    def __init__(self, padre, w, h, clasePrincipal):
        Panel.__init__(self, padre, 2, 0)
        self.padre = clasePrincipal
        self.pasoSiguiente = 'Paso5'
        self.pasoAnterior = 'Paso43D'
        self.insertaElemento(self.dibujaTitulo(self))
        self.insertaElemento(self.dibujaDatos(self))
        self.creceColumna(0)
        self.creceFila(1)
        self.cerrarPanel()
        self.SetSize([w,
         h])
        self.cargaDatos()
	if not self.padre.instalacion.esEditable("43E"): self.Enable(0)



    def dibujaTitulo(self, padre):
        panel = Panel(padre, 0, 3)
        centrado = Etiqueta(panel, '')
        centrado.ponEstilo(13, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(centrado)
        titulo = Etiqueta(panel, '4.3.E RESUMEN CARGA TOTAL DEL EDIFICIO')
        titulo.ponEstilo(14, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(titulo)
        panel.insertaElemento(centrado)
        panel.creceColumna(0)
        panel.creceColumna(2)
        panel.cerrarPanel()
        panel.SetBackgroundColour(wxBLUE)
        return panel



    def dibujaDatos(self, padre):
        panel = Panel(padre, 7, 0)
        panel.insertaElemento(self.ponTituloListas(panel, 'Previsi\xf3n de carga viviendas', 'Carga total prevista en viviendas (KW): 0', 1))
        self.listaAlumbrado = ListaColumna(panel)
        self.listaAlumbrado.cabeceraColumnas(['Unidades',
         'Superficie',
         'Tarifa Nocturna',
         'Electrificaci\xf3n',
         'Potencia',
         'Totales'])
        self.listaAlumbrado.SetColumnWidth(2, -2)
        panel.insertaElemento(self.listaAlumbrado)
        panel.insertaElemento(self.ponTituloListas(panel, 'Previsi\xf3n de carga locales', 'Carga total prevista en locales (kw): 0', 2))
        self.listaFuerza = ListaColumna(panel)
        self.listaFuerza.cabeceraColumnas(['Unidades',
         'Superficie',
         'Carga Prevista por Local',
         'Total'])
        self.listaFuerza.SetColumnWidth(2, -2)
        panel.insertaElemento(self.listaFuerza)
        panel.insertaElemento(self.ponTituloListas(panel, 'Previsi\xf3n de carga servicios generales', 'Carga total prevista en servicios generales (KW): 0', 3))
        self.listaServicio = ListaColumna(panel)
        self.listaServicio.cabeceraColumnas(['Servicio',
         'Unidades',
         'Superficie',
         'Total'])
        self.listaServicio.SetColumnWidth(0, 200)
        panel.insertaElemento(self.listaServicio)
        panel.insertaElemento(self.dibujaPotenciaTotal(panel))
        panel.creceColumna(0)
        panel.creceFila(1)
        panel.creceFila(3)
        panel.creceFila(5)
        panel.cerrarPanel()
        return panel



    def ponTituloListas(self, padre, texto1, texto2, tipo):
        panel = Panel(padre, 0, 3)
        etiqueta = Etiqueta(panel, texto1)
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        if (tipo == 1):
            self.etiquetaViviendas = Etiqueta(panel, texto2)
            self.etiquetaViviendas.ponNegrita()
            panel.insertaElemento(self.etiquetaViviendas)
        elif (tipo == 2):
            self.etiquetaLocales = Etiqueta(panel, texto2)
            self.etiquetaLocales.ponNegrita()
            panel.insertaElemento(self.etiquetaLocales)
        else:
            self.etiquetaServicios = Etiqueta(panel, texto2)
            self.etiquetaServicios.ponNegrita()
            panel.insertaElemento(self.etiquetaServicios)
        panel.cerrarPanel()
        return panel



    def dibujaPotenciaTotal(self, padre):
        panel = Panel(padre, 0, 4)
        self.etiqueta = Etiqueta(panel, 'CARGA TOTAL PREVISTA DEL EDIFICIO (KW): 0')
        self.etiqueta.ponNegrita()
        panel.insertaElemento(self.etiqueta)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.creceColumna(0)
        panel.creceColumna(1)
        panel.cerrarPanel()
        return panel



    def comprobarSiguientePaso(self):
        pass


    def guardaDatos(self):
        pass


    def cargaDatos(self):
        for vivienda in self.padre.instalacion.previsionViviendas:
            self.listaAlumbrado.Append(vivienda)

        for local in self.padre.instalacion.previsionLocales:
            self.listaFuerza.Append(local)

        for i in range(len(self.padre.instalacion.previsionServiciosGenerales)):
            if ((not (i == 4)) and ((not (i == 5)) and (not (i == 7)))):
                elemento = [self.padre.instalacion.previsionServiciosGenerales[i][0],
                 self.padre.instalacion.previsionServiciosGenerales[i][1],
                 '--',
                 self.padre.instalacion.previsionServiciosGenerales[i][3]]
            elif (i == 5):
                elemento = [self.padre.instalacion.previsionServiciosGenerales[i][0],
                 self.padre.instalacion.previsionServiciosGenerales[i][1],
                 self.padre.instalacion.previsionServiciosGenerales[i][2],
                 self.padre.instalacion.previsionServiciosGenerales[i][3]]
            elif (i == 7):
                elemento = [self.padre.instalacion.previsionServiciosGenerales[i][0],
                 '--',
                 '--',
                 self.padre.instalacion.previsionServiciosGenerales[i][2]]
            else:
                elemento = [self.padre.instalacion.previsionServiciosGenerales[i][0],
                 '--',
                 '--',
                 self.padre.instalacion.previsionServiciosGenerales[i][1]]
            self.listaServicio.Append(elemento)

        self.etiquetaViviendas.ponTexto(('Carga total prevista en viviendas (KW): ' + str(self.padre.instalacion.totalPrevisionViviendas)))
        self.etiquetaLocales.ponTexto(('Carga total prevista en locales (KW): ' + str(self.padre.instalacion.totalPrevisionLocales)))
        self.etiquetaServicios.ponTexto(('Carga total prevista en servicios generales (KW): ' + str(self.padre.instalacion.totalPrevisionServicios)))
        suma = ((self.padre.instalacion.totalPrevisionViviendas + self.padre.instalacion.totalPrevisionLocales) + self.padre.instalacion.totalPrevisionServicios)
        self.etiqueta.ponTexto(('CARGA TOTAL PREVISTA DEL EDIFICIO (KW): ' + str(suma)))
        if self.padre.instalacion.compruebaProyecto():
            self.padre.GetMenuBar().Enable(self.padre.GetMenuBar().FindMenuItem('Ver', 'Memoria T\xe9cnica'), 0)
	    self.padre.tb.EnableTool(13,0)
        else:
            self.padre.GetMenuBar().Enable(self.padre.GetMenuBar().FindMenuItem('Ver', 'Memoria T\xe9cnica'), 1)
	    self.padre.tb.EnableTool(13,1)

#}}}

class Paso44A(Panel):#{{{
    __module__ = __name__

    def __init__(self, padre, w, h, clasePrincipal):
        Panel.__init__(self, padre, 2, 0)
        self.padre = clasePrincipal
        self.pasoSiguiente = 'Paso44B'
        self.pasoAnterior = 'Paso3'
        self.receptores = []
        self.insertaElemento(self.dibujaTitulo(self))
        self.insertaElemento(self.dibujaDatos(self))
        self.creceColumna(0)
        self.creceFila(1)
        self.cerrarPanel()
        self.SetSize([w,
         h])
        self.cargaDatos()
	if not self.padre.instalacion.esEditable("44A"): self.Enable(0)



    def dibujaTitulo(self, padre):
        panel = Panel(padre, 0, 3)
        centrado = Etiqueta(panel, '')
        centrado.ponEstilo(13, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(centrado)
        titulo = Etiqueta(panel, '4.4.A AMPLIACIONES DE POTENCIA - DATOS DE VIVIENDAS')
        titulo.ponEstilo(13, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(titulo)
        panel.insertaElemento(centrado)
        panel.creceColumna(0)
        panel.creceColumna(2)
        panel.cerrarPanel()
        panel.SetBackgroundColour(wxBLUE)
        return panel



    def dibujaDatos(self, padre):
        panel = Panel(padre, 5, 0)
        panel.insertaElemento(self.damePanelUnidades(panel))
        panel.insertaElemento(self.dibujaPanelRadios(panel))
        panel.insertaElemento(self.dibujaBotonAceptar(panel))
        self.listaAlumbrado = ListaColumna(panel, self.receptorSeleccionado, self.receptorDeseleccionado)
        self.listaAlumbrado.cabeceraColumnas(['Identificaci\xf3n del suministro',
         'Superficie',
         'Tarifa Nocturna',
         'Electrificaci\xf3n',
         'Potencia tras la ampliaci\xf3n'])
        self.listaAlumbrado.SetColumnWidth(0, -2)
        self.listaAlumbrado.SetColumnWidth(2, -2)
        self.listaAlumbrado.SetColumnWidth(4, -2)
        panel.insertaElemento(self.listaAlumbrado)
        panel.insertaElemento(self.dibujaBotonEliminar(panel))
        panel.creceFila(3)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def receptorSeleccionado(self, event):
        self.botonEliminar.Enable(1)
        self.botonModificar.Enable(1)
        self.itemSeleccionado = event.m_itemIndex



    def receptorDeseleccionado(self, event):
        self.botonEliminar.Enable(0)
        self.botonModificar.Enable(0)



    def dibujaBotonAceptar(self, padre):
        panel = Panel(padre, 0, 2)
        panel.insertaElemento(Boton(panel, 'Aceptar', self.aceptarReceptor, 'aceptar'))
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.creceColumna(1)
        panel.cerrarPanel()
        return panel



    def aceptarReceptor(self, event):
        error = 0
        if (self.txtIdentificacion.dameValor().strip() == ''):
            error = 1
        if (self.txtSuperficie.dameValor() == 0.0):
            error = 1
        if (self.txtPotencia.dameValor() == 0.0):
            error = 1
        if (self.radiosTarifa.dameElementoSeleccionado() == -1):
            error = 1
        if (self.radiosElectrificacion.dameElementoSeleccionado() == -1):
            error = 1
        if error:
            Error(self, 'Debe rellenar todos los campos')
        else:
            if self.radiosTarifa.dameElementoSeleccionado():
                tarifa = 'No'
            else:
                tarifa = 'Si'
            if self.radiosElectrificacion.dameElementoSeleccionado():
                electrificacion = 'Elevada'
            else:
                electrificacion = 'B\xe1sica'
            lista = [self.txtIdentificacion.dameValor(),
             str(self.txtSuperficie.dameValor()),
             tarifa,
             electrificacion,
             str(self.txtPotencia.dameValor())]
            self.listaAlumbrado.Append(lista)
            self.receptores.append(lista)
            self.txtIdentificacion.ponTexto('')
            self.txtSuperficie.ponTexto(0)
            self.txtPotencia.ponTexto(0)
            self.radiosTarifa.radios[self.radiosTarifa.dameElementoSeleccionado()].SetValue(0)
            self.radiosElectrificacion.radios[self.radiosElectrificacion.dameElementoSeleccionado()].SetValue(0)



    def dibujaBotonEliminar(self, padre):
        panel = Panel(padre, 0, 3)
        self.botonModificar = Boton(panel, 'Modificar', self.modificarReceptor, 'izquierda')
        self.botonModificar.Enable(0)
        panel.insertaElemento(self.botonModificar)
        self.botonEliminar = Boton(panel, 'Eliminar', self.eliminarReceptor, 'eliminar')
        self.botonEliminar.Enable(0)
        panel.insertaElemento(self.botonEliminar)
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.creceColumna(2)
        panel.cerrarPanel()
        return panel



    def modificarReceptor(self, event):
        (identificacion, superficie, tarifa, electrificacion, potencia,) = self.receptores[self.itemSeleccionado]
        self.txtIdentificacion.ponTexto(identificacion)
        self.txtSuperficie.ponTexto(float(superficie))
        self.txtPotencia.ponTexto(float(potencia))
        if (tarifa == 'Si'):
            self.radiosTarifa.radios[0].SetValue(1)
        else:
            self.radiosTarifa.radios[1].SetValue(1)
        self.comprobarElectrificacion(event)
        self.eliminarReceptor(event)



    def eliminarReceptor(self, event):
        (identificacion, superficie, tarifa, electrificacion, potencia,) = self.receptores[self.itemSeleccionado]
        del self.receptores[self.itemSeleccionado]
        self.listaAlumbrado.DeleteItem(self.itemSeleccionado)



    def damePanelUnidades(self, padre):
        panel = Panel(padre, 2, 3)
        panel.insertaElemento(Etiqueta(panel, 'Identificaci\xf3n del suministro:'))
        panel.insertaElemento(Etiqueta(panel, 'Superficie:'))
        panel.insertaElemento(Etiqueta(panel, 'Potencia tras la ampliaci\xf3n:'))
        self.txtIdentificacion = AreaTexto(panel)
        panel.insertaElemento(self.txtIdentificacion)
        self.txtSuperficie = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtSuperficie, self.comprobarElectrificacion)
        panel.insertaElemento(self.txtSuperficie)
        self.txtPotencia = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtPotencia, self.comprobarElectrificacion)
        panel.insertaElemento(self.txtPotencia)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def comprobarElectrificacion(self, event):
        try:
            if (self.txtSuperficie.dameValor() > 160):
                if (self.txtPotencia.dameValor() < 9.1999999999999993):
                    self.txtPotencia.ponTexto(9.1999999999999993)
                self.radiosElectrificacion.radios[1].SetValue(1)
            elif (self.txtPotencia.dameValor() < 9.1999999999999993):
                self.radiosElectrificacion.radios[0].SetValue(1)
            else:
                self.radiosElectrificacion.radios[1].SetValue(1)
        except:
            pass



    def dibujaPanelRadios(self, padre):
        panel = Panel(padre, 0, 2)
        self.radiosTarifa = CajaRadio(panel, 'Tarifa nocturna', ['Si',
         'No'])
        panel.insertaElemento(self.radiosTarifa.dibujaCajaRadio())
        self.radiosElectrificacion = CajaRadio(panel, 'Electrificaci\xf3n', ['B\xe1sica',
         'Elevada'])
        panel.insertaElemento(self.radiosElectrificacion.dibujaCajaRadio())
        self.radiosElectrificacion.radios[0].Enable(0)
        self.radiosElectrificacion.radios[1].Enable(0)
        panel.cerrarPanel()
        return panel



    def comprobarSiguientePaso(self):
        self.guardaDatos()



    def guardaDatos(self):
        try:
            self.padre.instalacion.potenciaAmpliacion = self.receptores
        except:
            pass



    def cargaDatos(self):
        self.receptores = self.padre.instalacion.potenciaAmpliacion
        for ampliacion in self.padre.instalacion.potenciaAmpliacion:
            self.listaAlumbrado.Append(ampliacion)

#}}}

class Paso44B(Panel): #{{{
    __module__ = __name__

    def __init__(self, padre, w, h, clasePrincipal):
        Panel.__init__(self, padre, 2, 0)
        self.padre = clasePrincipal
        self.pasoSiguiente = 'Paso5'
        self.pasoAnterior = 'Paso44A'
        self.insertaElemento(self.dibujaTitulo(self))
        self.insertaElemento(self.dibujaDatos(self))
        self.creceColumna(0)
        self.creceFila(1)
        self.cerrarPanel()
        self.SetSize([w,
         h])
        self.cargaDatos()
	if not self.padre.instalacion.esEditable("44B"): self.Enable(0)



    def dibujaTitulo(self, padre):
        panel = Panel(padre, 0, 3)
        centrado = Etiqueta(panel, '')
        centrado.ponEstilo(13, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(centrado)
        titulo = Etiqueta(panel, '4.4.B AMPLIACIONES DE POTENCIA - PREVISION DE CARGAS')
        titulo.ponEstilo(13, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(titulo)
        panel.insertaElemento(centrado)
        panel.creceColumna(0)
        panel.creceColumna(2)
        panel.cerrarPanel()
        panel.SetBackgroundColour(wxBLUE)
        return panel



    def dibujaDatos(self, padre):
        panel = Panel(padre, 5, 0)
        panel.insertaElemento(self.damePanelNuevasPrevisiones(panel))
        self.totalAlumbrado = Etiqueta(panel, 'Nueva previsi\xf3n total de carga del edificio (kW): 0')
        self.totalAlumbrado.ponNegrita()
        panel.insertaElemento(self.totalAlumbrado)
        self.radiosCheck = CajaRadio(panel, 'Modificaciones en instalaciones debidas a las ampliaciones', ['Ninguna',
         'Caja general de protecci\xf3n',
         'L\xednea general de alimentaci\xf3n',
         'Instalaciones interiores',
         'Interruptor general de maniobra',
         'Cajas de derivaci\xf3n',
         'Emplazamientos de contadores',
         'Fusibles de seguridad',
         'Contadores',
         'Derivaciones individuales'], check=1)
        panel.insertaElemento(self.radiosCheck.dibujaCajaRadio())
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def damePanelNuevasPrevisiones(self, padre):
        panel = Panel(padre, 4, 4)
        panel.insertaElemento(Etiqueta(panel, 'Viviendas sin tarifa nocturna (KW)'))
        self.txtViviendasCon = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtViviendasCon, self.calculaPotenciaTotal)
        panel.insertaElemento(self.txtViviendasCon)
        panel.insertaElemento(Etiqueta(panel, 'Viviendas con tarifa nocturna (KW)'))
        self.txtViviendasSin = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtViviendasSin, self.calculaPotenciaTotal)
        panel.insertaElemento(self.txtViviendasSin)
        panel.insertaElemento(Etiqueta(panel, 'Locales comerciales y oficinas (KW)'))
        self.txtLocales = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtLocales, self.calculaPotenciaTotal)
        panel.insertaElemento(self.txtLocales)
        panel.insertaElemento(Etiqueta(panel, 'Servicios generales (KW)'))
        self.txtServicios = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtServicios, self.calculaPotenciaTotal)
        panel.insertaElemento(self.txtServicios)
        panel.cerrarPanel()
        return panel



    def calculaPotenciaTotal(self, event = None):
        try:
            suma = (((self.txtViviendasCon.dameValor() + self.txtViviendasSin.dameValor()) + self.txtLocales.dameValor()) + self.txtServicios.dameValor())
            self.totalAlumbrado.ponTexto(('Nueva previsi\xf3n total de carga del edificio (KW): ' + str(suma)))
            if self.padre.instalacion.compruebaProyecto():
                self.padre.GetMenuBar().Enable(self.padre.GetMenuBar().FindMenuItem('Ver', 'Memoria T\xe9cnica'), 0)
		self.padre.tb.EnableTool(13,0)
            else:
                self.padre.GetMenuBar().Enable(self.padre.GetMenuBar().FindMenuItem('Ver', 'Memoria T\xe9cnica'), 1)
		self.padre.tb.EnableTool(13,1)
        except:
            pass



    def comprobarSiguientePaso(self):
        self.guardaDatos()



    def guardaDatos(self):
        try:
            self.padre.instalacion.viviendasSin = self.txtViviendasSin.dameValor()
            self.padre.instalacion.viviendasCon = self.txtViviendasCon.dameValor()
            self.padre.instalacion.locales = self.txtLocales.dameValor()
            self.padre.instalacion.servicios = self.txtServicios.dameValor()
            check = []
            for radio in self.radiosCheck.radios:
                check.append(radio.GetValue())

            self.padre.instalacion.listaCheck = check
        except:
            pass



    def cargaDatos(self):
        self.txtViviendasSin.ponTexto(self.padre.instalacion.viviendasSin)
        self.txtViviendasCon.ponTexto(self.padre.instalacion.viviendasCon)
        self.txtLocales.ponTexto(self.padre.instalacion.locales)
        self.txtServicios.ponTexto(self.padre.instalacion.servicios)
        self.calculaPotenciaTotal()
        for i in range(len(self.padre.instalacion.listaCheck)):
            self.radiosCheck.radios[i].SetValue(self.padre.instalacion.listaCheck[i])

#}}}

class Paso5(Panel): #{{{
    __module__ = __name__

    def __init__(self, padre, w, h, clasePrincipal):
        Panel.__init__(self, padre, 2, 0)
        self.padre = clasePrincipal
        self.pasoSiguiente = 'Paso6'
        self.pasoAnterior = 'Paso41A'
        self.insertaElemento(self.dibujaTitulo(self))
        self.insertaElemento(self.dibujaDatos(self))
        self.creceColumna(0)
        self.cerrarPanel()
        self.SetSize([w,
         h])
        self.cargaDatos()
	if not self.padre.instalacion.esEditable("5"): self.Enable(0)



    def dibujaTitulo(self, padre):
        panel = Panel(padre, 0, 3)
        centrado = Etiqueta(panel, '')
        centrado.ponEstilo(13, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(centrado)
        titulo = Etiqueta(panel, '5 MEMORIA DESCRIPTIVA DE LA INSTALACI\xd3N')
        titulo.ponEstilo(13, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(titulo)
        panel.insertaElemento(centrado)
        panel.creceColumna(0)
        panel.creceColumna(2)
        panel.cerrarPanel()
        panel.SetBackgroundColour(wxBLUE)
        return panel



    def dibujaDatos(self, padre):
        panel = Panel(padre, 15, 0)
        etiquetaTitulo = Etiqueta(panel, 'Punto de suministro')
        etiquetaTitulo.ponNegrita()
        panel.insertaElemento(etiquetaTitulo)
        panel.insertaElemento(self.dibujaPuntoSuministro(panel))
        etiquetaTitulo = Etiqueta(panel, 'Caracter\xedsticas generales de la instalaci\xf3n')
        etiquetaTitulo.ponNegrita()
        panel.insertaElemento(etiquetaTitulo)
        self.radioTipo = CajaRadio(panel, 'Tipo de suministro', ['Monof\xe1sico',
         'Trif\xe1sico'])
        panel.insertaElemento(self.radioTipo.dibujaCajaRadio())
        panel.insertaElemento(self.dibujaCaracteristicas(panel))
        etiquetaTitulo = Etiqueta(panel, 'Contadores')
        etiquetaTitulo.ponNegrita()
        panel.insertaElemento(etiquetaTitulo)
        self.radioContadores = CajaRadio(panel, 'Instalaci\xf3n', ['Individual',
         'Concentrada en un solo lugar',
         'Concentraci\xf3n en varios lugares'])
        panel.insertaElemento(self.radioContadores.dibujaCajaRadio())
        panel.insertaElemento(self.dibujaInterruptorGeneral(panel))
        etiqueta = Etiqueta(panel, 'Cuadro General de Protecci\xf3n - Interruptor general de corte')
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        panel.insertaElemento(self.dibujaCuadroGeneralProteccion(panel))
        etiqueta = Etiqueta(panel, 'Protecci\xf3n contra Sobretensiones a instalar')
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        panel.insertaElemento(self.dibujaProteccionSobretensiones(panel))
        etiqueta = Etiqueta(panel, 'Protecci\xf3n contra Sobreintensidades a instalar')
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        panel.insertaElemento(self.dibujaProteccionSobreintensidades(panel))
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def compruebaInterruptorGeneral(self, event):
        try:
            if ((self.padre.instalacion.ITipo == 'f - Viviendas unifamiliares') and (self.padre.instalacion.IInstalacion == 0)):
                if (self.padre.instalacion.prevision < 9.1999999999999993):
                    if ((self.txtInterruptorGeneral.dameValor() < 25) or (self.txtInterruptorGeneral.dameValor() > 32)):
                        Error(self.padre, 'La intensidad del interruptor debe estar comprendida entre 25 y 32 A')
                        self.txtInterruptorGeneral.ponTexto(25)
                elif (self.txtInterruptorGeneral.dameValor() < 40):
                    Error(self.padre, 'La intensidad del interruptor debe ser mayor o igual que 40 A')
                    self.txtInterruptorGeneral.ponTexto(40)
        except:
            pass



    def dibujaProteccionSobreintensidades(self, padre):
        panel = Panel(padre, 2, 0)
        self.txtCheckInterruptor = wxCheckBox(panel, -1, 'Interrup. autom\xe1ticos de protecci\xf3n contra sobrecargas y cortocircuitos')
        panel.insertaElemento(self.txtCheckInterruptor)
        self.txtCheckFusible = wxCheckBox(panel, -1, 'Fusibles calibrados de protecci\xf3n contra sobrecargas y cortocircuitos')
        panel.insertaElemento(self.txtCheckFusible)
        panel.cerrarPanel()
        return panel



    def dibujaProteccionSobretensiones(self, padre):
        panel = Panel(padre, 0, 4)
        panel.insertaElemento(Etiqueta(panel, 'Protecci\xf3n :'))
        self.txtProteccionSobreTensiones = AreaTexto(panel)
        panel.insertaElemento(self.txtProteccionSobreTensiones)
        panel.insertaElemento(Etiqueta(panel, 'Categor\xeda :'))
        self.txtProteccionCategoria = AreaTexto(panel)
        panel.insertaElemento(self.txtProteccionCategoria)
        panel.cerrarPanel()
        return panel



    def dibujaInterruptorGeneral(self, padre):
        panel = Panel(padre, 0, 2)
        panel.insertaElemento(Etiqueta(panel, 'Interruptor general de corte (A)'))
        self.txtInterruptorGeneral = CampoMonetario(panel, 2)
        panel.insertaElemento(self.txtInterruptorGeneral)
        panel.cerrarPanel()
        return panel



    def dibujaCuadroGeneralProteccion(self, padre):
        panel = Panel(padre, 0, 2)
        panel.insertaElemento(Etiqueta(panel, 'Poder de Corte (KA):'))
        self.txtPoderDeCorte = CampoMonetario(panel, 2)
        panel.insertaElemento(self.txtPoderDeCorte)
        panel.cerrarPanel()
        return panel



    def dibujaPuntoSuministro(self, padre):
        panel = Panel(padre, 2, 3)
        panel.insertaElemento(Etiqueta(panel, 'Empresa distribuidora'))
        panel.insertaElemento(Etiqueta(panel, 'Punto de conexi\xf3n'))
        panel.insertaElemento(Etiqueta(panel, 'Intensidad de cortocircuito (KA)'))
        self.listaEmpresas = self.dameNombresEmpresas()
        self.txtEmpresa = ComboWriter(panel, self.listaEmpresas)
        panel.insertaElemento(self.txtEmpresa)
        lista = ['R.D.D - Red de distribuci\xf3n de empresa distribuidora',
         'C.T.D. - Centro de transformaci\xf3n de empresa distribuidora',
         'R.D.P. - Red de distribuci\xf3n privada',
         'C.T.P. - Centro de transformaci\xf3n privado',
         'C.T.T. - Centro de transformaci\xf3n del titular de la instalaci\xf3n',
         'Otros']
        self.txtConexion = Combo(panel, lista)
        panel.insertaElemento(self.txtConexion)
        self.txtIntensidad = CampoMonetario(panel, 2)
        panel.insertaElemento(self.txtIntensidad)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaCaracteristicas(self, padre):
        panel = Panel(padre, 2, 4)
        panel.insertaElemento(Etiqueta(panel, 'Tensi\xf3n del suministro (V)', wxRED))
        panel.insertaElemento(Etiqueta(panel, ''))
        panel.insertaElemento(Etiqueta(panel, 'Potencia instalada o prevista (kW)', wxRED))
        panel.insertaElemento(Etiqueta(panel, 'Potencia maxima a contratar (kW)', wxRED))
        self.txtTensionSuministroCombo = Combo(panel, ['230',
         '400',
         'Otros'])
        EVT_COMBOBOX(self.txtTensionSuministroCombo, self.txtTensionSuministroCombo.GetId(), self.comboSuministroSeleccionado)
        panel.insertaElemento(self.txtTensionSuministroCombo)
        self.txtTensionSuministro = AreaTexto(panel)
        self.txtTensionSuministro.Enable(0)
        panel.insertaElemento(self.txtTensionSuministro)
        self.txtPotenciaInstalada = CampoMonetario(panel, 2)
        suma = self.damePotenciaInstalada()
        self.txtPotenciaInstalada.ponTexto(suma)
        if ((self.padre.instalacion.IInstalacion == 0) or (self.padre.instalacion.IInstalacion == 1)):
            self.txtPotenciaInstalada.Enable(0)
        panel.insertaElemento(self.txtPotenciaInstalada)
        self.txtPotContratar = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtPotContratar, self.comprobarPotenciaContratar)
        panel.insertaElemento(self.txtPotContratar)
        panel.cerrarPanel()
        return panel



    def comprobarPotenciaContratar(self, event):
        try:
            suma = self.txtPotenciaInstalada.dameValor()
            if (self.txtPotContratar.dameValor() < suma):
                Error(self.padre, 'La potencia a contratar debe ser igual o mayor que la prevista')
                self.txtPotContratar.ponTexto(suma)
        except:
            pass



    def comboSuministroSeleccionado(self, event):
        if (self.txtTensionSuministroCombo.dameValor() == 'Otros'):
            self.txtTensionSuministro.Enable(1)
        else:
            self.txtTensionSuministro.ponTexto(self.txtTensionSuministroCombo.dameValor())
            self.txtTensionSuministro.Enable(0)



    def damePotenciaInstalada(self):
        if (self.padre.instalacion.ITipo == ''):
            return 0
        if (self.padre.instalacion.ITipo[0] == 'f'):
            if (self.padre.instalacion.IInstalacion == 0):
                return self.padre.instalacion.prevision
            if (self.padre.instalacion.IInstalacion in (1,
             2,
             3)):
                suma = 0
                for alumbrado in self.padre.instalacion.receptoresAlumbrado:
                    suma = (suma + float(alumbrado[2]))

                for fuerza in self.padre.instalacion.receptoresFuerza:
                    suma = (suma + float(fuerza[2]))

                return suma
            return 0
        if (self.padre.instalacion.ITipo[0] == 'e'):
            if (self.padre.instalacion.IInstalacion == 0):
                suma = ((self.padre.instalacion.totalPrevisionViviendas + self.padre.instalacion.totalPrevisionLocales) + self.padre.instalacion.totalPrevisionServicios)
                return suma
            if (self.padre.instalacion.IInstalacion == 1):
                suma = (((self.padre.instalacion.viviendasSin + self.padre.instalacion.viviendasCon) + self.padre.instalacion.locales) + self.padre.instalacion.servicios)
                return suma
            if (self.padre.instalacion.IInstalacion == 2):
                suma = 0
                for alumbrado in self.padre.instalacion.receptoresAlumbrado:
                    suma = (suma + float(alumbrado[2]))

                for fuerza in self.padre.instalacion.receptoresFuerza:
                    suma = (suma + float(fuerza[2]))

                return suma
        suma = 0
        for alumbrado in self.padre.instalacion.receptoresAlumbrado:
            suma = (suma + float(alumbrado[2]))

        for fuerza in self.padre.instalacion.receptoresFuerza:
            suma = (suma + float(fuerza[2]))

        return suma



    def comprobarSiguientePaso(self):
        self.guardaDatos()
        if self.padre.instalacion.compruebaProyecto():
            self.pasoSiguiente = 'Paso10'
        else:
            self.pasoSiguiente = 'Paso6'



    def guardaDatos(self):
        if (not (self.padre.instalacion.ITipo == '')):
            if ((self.padre.instalacion.ITipo[0] == 'f') and (not self.padre.instalacion.IInstalacion)):
                self.pasoAnterior = 'Paso42'
            if ((self.padre.instalacion.ITipo[0] == 'e') and (not self.padre.instalacion.IInstalacion)):
                self.pasoAnterior = 'Paso43E'
            if ((self.padre.instalacion.ITipo[0] == 'e') and (self.padre.instalacion.IInstalacion == 1)):
                self.pasoAnterior = 'Paso44B'
        else:
            self.pasoAnterior = 'Paso41C'
        try:
            empresa = self.txtEmpresa.dameValor()
            self.padre.instalacion.empresa = empresa
            from Utilidades import Utilidades
            util = Utilidades()
            empresa = util.convierteCadenaUNICODE(empresa)
            self.listaEmpresas = util.convierteElementosUNICODE(self.listaEmpresas)
            if (not (empresa in self.listaEmpresas)):
                self.escribirEmpresaFichero(empresa)
                self.listaEmpresas.append(empresa)
            self.padre.instalacion.puntoConexion = self.txtConexion.dameValor()
            self.padre.instalacion.intensidadCC = self.txtIntensidad.dameValor()
            self.padre.instalacion.tipoSuministro = self.radioTipo.dameElementoSeleccionado()
            self.padre.instalacion.tensionSuministro = self.txtTensionSuministro.dameValor()
            self.padre.instalacion.potenciaInstalada = self.txtPotenciaInstalada.dameValor()
            self.padre.instalacion.contadorInstalacion = self.radioContadores.dameElementoSeleccionado()
            self.padre.instalacion.poderCorte = self.txtPoderDeCorte.dameValor()
            self.padre.instalacion.proteccionSobreTensiones = self.txtProteccionSobreTensiones.dameValor()
            self.padre.instalacion.proteccionCategoria = self.txtProteccionCategoria.dameValor()
            self.padre.instalacion.checkInterruptor = self.txtCheckInterruptor.GetValue()
            self.padre.instalacion.checkFusible = self.txtCheckFusible.GetValue()
            self.padre.instalacion.interruptorGeneral = self.txtInterruptorGeneral.dameValor()
            self.padre.instalacion.totalPotenciaContratar = self.txtPotContratar.dameValor()
        except:
            pass



    def cargaDatos(self):
        from Utilidades import Utilidades
        util = Utilidades()
        empresa = util.convierteCadenaISO(self.padre.instalacion.empresa)
        self.txtEmpresa.seleccionaValor(empresa)
        try:
            self.txtConexion.seleccionaValor(self.padre.instalacion.puntoConexion)
        except:
            pass
        self.txtIntensidad.ponTexto(self.padre.instalacion.intensidadCC)
        if (self.padre.instalacion.tipoSuministro > -1):
            self.radioTipo.radios[self.padre.instalacion.tipoSuministro].SetValue(1)
        self.txtTensionSuministro.Enable(0)
        if (self.padre.instalacion.tensionSuministro == ''):
            self.txtTensionSuministroCombo.SetSelection(-1)
        elif (self.padre.instalacion.tensionSuministro == '230'):
            self.txtTensionSuministroCombo.SetSelection(0)
        elif (self.padre.instalacion.tensionSuministro == '400'):
            self.txtTensionSuministroCombo.SetSelection(1)
        else:
            self.txtTensionSuministroCombo.SetSelection(3)
            self.txtTensionSuministro.Enable(1)
        self.txtTensionSuministro.ponTexto(self.padre.instalacion.tensionSuministro)
        if (self.padre.instalacion.contadorInstalacion > -1):
            self.radioContadores.radios[self.padre.instalacion.contadorInstalacion].SetValue(1)
        self.txtPoderDeCorte.ponTexto(self.padre.instalacion.poderCorte)
        self.txtProteccionSobreTensiones.ponTexto(self.padre.instalacion.proteccionSobreTensiones)
        self.txtProteccionCategoria.ponTexto(self.padre.instalacion.proteccionCategoria)
        self.txtCheckInterruptor.SetValue(self.padre.instalacion.checkInterruptor)
        self.txtCheckFusible.SetValue(self.padre.instalacion.checkFusible)
        self.txtInterruptorGeneral.ponTexto(self.padre.instalacion.interruptorGeneral)
        if (self.padre.instalacion.totalPotenciaContratar < self.txtPotenciaInstalada.dameValor()):
            self.txtPotContratar.ponTexto(self.txtPotenciaInstalada.dameValor())
        else:
            self.txtPotContratar.ponTexto(self.padre.instalacion.totalPotenciaContratar)



    def dameNombresEmpresas(self):
        resultado = []
        import xml.dom.minidom
        from Utilidades import Utilidades
        datosXML = xml.dom.minidom.parse('datos/empresas.xml')
        empresas = datosXML.childNodes[0]
        util = Utilidades()
        for empresa in empresas.childNodes:
            if isinstance(empresa, xml.dom.minidom.Element):
                resultado.append(util.convierteCadenaISO(empresa.getAttribute('nombre')))

        return resultado



    def escribirEmpresaFichero(self, nombre):
        import xml.dom.minidom
        datosXML = xml.dom.minidom.parse('datos/empresas.xml')
        empresas = datosXML.childNodes[0]
        nodo = datosXML.createElement('Empresa')
        nodo.setAttribute('nombre', nombre)
        empresas.appendChild(nodo)
        f = open('datos/empresas.xml', 'w')
        cadena = datosXML.toxml('iso-8859-15')
        f.write(cadena)
        f.close()
        datosXML.unlink()

#}}}

class Paso6(Panel): #{{{
    __module__ = __name__

    def __init__(self, padre, w, h, clasePrincipal):
        Panel.__init__(self, padre, 2, 0)
        self.padre = clasePrincipal
        self.pasoSiguiente = 'Paso7'
        self.pasoAnterior = 'Paso5'
        self.insertaElemento(self.dibujaTitulo(self))
        self.txtAclaraciones = Memo(self)
        self.insertaElemento(self.txtAclaraciones)
        self.creceColumna(0)
        self.creceFila(1)
        self.cerrarPanel()
        self.SetSize([w,
         h])
        self.cargaDatos()
	if not self.padre.instalacion.esEditable("6"): self.Enable(0)



    def dibujaTitulo(self, padre):
        panel = Panel(padre, 0, 3)
        centrado = Etiqueta(panel, '')
        centrado.ponEstilo(13, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(centrado)
        titulo = Etiqueta(panel, '6 ACLARACIONES A LA MEMORIA')
        titulo.ponEstilo(13, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(titulo)
        panel.insertaElemento(centrado)
        panel.creceColumna(0)
        panel.creceColumna(2)
        panel.cerrarPanel()
        panel.SetBackgroundColour(wxBLUE)
        return panel



    def comprobarSiguientePaso(self):
        self.guardaDatos()



    def guardaDatos(self):
        try:
            self.padre.instalacion.aclaracion = self.txtAclaraciones.dameValor()
        except:
            pass



    def cargaDatos(self):
        self.txtAclaraciones.ponTexto(self.padre.instalacion.aclaracion)

#}}}

class Paso7(Panel):#{{{
    __module__ = __name__

    def __init__(self, padre, w, h, clasePrincipal):
        Panel.__init__(self, padre, 0, 0)
        self.pasoSiguiente = 'Paso8'
        self.pasoAnterior = 'Paso6'
        self.padre = clasePrincipal
        self.clasePrincipal = clasePrincipal
        self.panelTab = wxNotebook(self, -1)
        self.insertaElemento(self.panelTab)
        self.creceColumna(0)
        self.creceFila(0)
        self.cerrarPanel()
        self.SetSize([w,
         h])
        self.cargaDatos()
	if not self.padre.instalacion.esEditable("7"): self.Enable(0)



    def insertaNuevaHoja(self, objeto = None):
        self.panelTab.AddPage(Paso7P(self.panelTab, self.clasePrincipal, objeto), '7.- Calculos Justificativos')



    def cargaDatos(self):
        if (len(self.padre.instalacion.calculosJustificativos) == 0):
            self.insertaNuevaHoja()
        else:
            for datosPestania in self.padre.instalacion.calculosJustificativos:
                self.insertaNuevaHoja(datosPestania)




    def guardaDatos(self):
        datos = []
        for i in range(self.panelTab.GetPageCount()):
            datos.append(self.panelTab.GetPage(i).guardaDatos())

        self.padre.instalacion.calculosJustificativos = datos



    def comprobarSiguientePaso(self):
        self.guardaDatos()

#}}}

class Paso7P(PanelScroll):#{{{
    __module__ = __name__

    def __init__(self, padre, clasePrincipal, objeto = None):
        PanelScroll.__init__(self, padre, 6, 0)
        self.padre = clasePrincipal
        self.insertaElemento(self.dibujaTitulo(self))
        self.insertaElemento(self.dibujaDatos(self))
        self.insertaElemento(self.dibujaNaturaleza(self))
        self.insertaElemento(self.dibujaBotonAceptar(self))
        self.resumenDatos = ListaColumna(self, self.calculoSeleccionado, self.calculoDeseleccionado)
	self.resumenDatos.SetSize([-1,60])
        listaTitulos = ['Denominaci\xf3n l\xednea',
         'II/III',
         'Tensi\xf3n (V)',
         'Potencia (W)',
         'Coef. de Calculo',
         'Potencia de Calculo (W)',
         'Longitud (m)',
         'Intensidad (A)',
         'Secci\xf3n (mm2) Cu/Al',
         'C.d.T. (%)',
         'C.d.T. Adm (%)',
         'Densidad (A/mm2)',
         'Canalizaci\xf3n',
         'Prot. Sobre. (A)',
         'Prot. Dif. (mA)']
        self.resumenDatos.cabeceraColumnas(listaTitulos)
        for i in range(len(listaTitulos)):
            if (not (i == 1)):
                self.resumenDatos.SetColumnWidth(i, -2)

        self.insertaElemento(self.resumenDatos)
        self.insertaElemento(self.dibujaBotonEliminar())
        self.creceColumna(0)
        self.creceFila(4)
        self.cerrarPanel()
        if objeto:
            self.datosHoja = objeto
            self.cargaDatos()
        else:
            self.datosHoja = DatosHojaCalculo()



    def dibujaTitulo(self, padre):
        panel = Panel(padre, 0, 3)
        centrado = Etiqueta(panel, '')
        centrado.ponEstilo(13, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(centrado)
        titulo = Etiqueta(panel, '7 CALCULOS JUSTIFICATIVOS')
        titulo.ponEstilo(13, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(titulo)
        panel.insertaElemento(centrado)
        panel.creceColumna(0)
        panel.creceColumna(2)
        panel.cerrarPanel()
        panel.SetBackgroundColour(wxBLUE)
        return panel



    def dibujaDatos(self, padre):
        panel = Panel(padre, 6, 2)
        panel.insertaElemento(self.dibujaDenominacionLinea(panel))
        panel.insertaElemento(self.dibujaTrifasicoTension(panel))
        panel.insertaElemento(self.dibujaPotencia(panel))
        panel.insertaElemento(self.dibujaCoeficienteCalculo(panel))
        panel.insertaElemento(self.dibujaFactorCorreccion(panel))
        panel.insertaElemento(self.dibujaCanalizacion(panel))
        panel.insertaElemento(self.dibujaLongitud(panel))
        panel.insertaElemento(self.dibujaFactorPotenciaMaterial(panel))
        panel.insertaElemento(self.dibujaProteccionDiferencial(panel))
        panel.cerrarPanel()
        return panel



    def dibujaDenominacionLinea(self, padre):
        panel = Panel(padre, 2, 0)
        panel.insertaElemento(Etiqueta(panel, 'Denominaci\xf3n l\xednea'))
        panelInterno = Panel(panel, 0, 5)
        self.txtLinea = Combo(panelInterno, ['L.G.A.',
         'D.I.',
         'C'])
        EVT_COMBOBOX(self.txtLinea, self.txtLinea.GetId(), self.lineaSeleccionada)
        panelInterno.insertaElemento(self.txtLinea)
        self.txtNumeroCircuito = CampoMonetario(panelInterno, 1)
        self.txtNumeroCircuito.Enable(0)
        panelInterno.insertaElemento(self.txtNumeroCircuito)
        self.txtFuerza = Combo(panelInterno, ['Fuerza',
         'Alumbrado'])
        self.txtFuerza.Enable(0)
        panelInterno.insertaElemento(self.txtFuerza)
        self.botonAyudaFuerza = Boton(panelInterno, '', self.ayudaFuerza, 'ayuda')
        self.botonAyudaFuerza.Enable(0)
        panelInterno.insertaElemento(self.botonAyudaFuerza)
        panelInterno.cerrarPanel()
        panel.insertaElemento(panelInterno)
        panel.cerrarPanel()
        return panel



    def ayudaFuerza(self, event):
        InformacionFuerzaAlumbrado(self.padre)



    def lineaSeleccionada(self, event = None):
        if (self.txtLinea.GetSelection() == 2):
            if (not (self.padre.instalacion.ITipo == '')):
                if (self.padre.instalacion.ITipo[0] == 'f'):
                    self.txtFuerza.Enable(0)
                    self.botonAyudaFuerza.Enable(0)
                else:
                    self.txtFuerza.Enable(1)
                    self.botonAyudaFuerza.Enable(1)
            else:
                self.txtFuerza.Enable(1)
                self.botonAyudaFuerza.Enable(1)
            self.txtNumeroCircuito.Enable(1)
            self.txtTensionAsignadaDICombo.Enable(0)
            self.txtTensionAsignadaDI.Enable(0)
        else:
            self.txtFuerza.SetSelection(-1)
            self.txtFuerza.Enable(0)
            self.botonAyudaFuerza.Enable(0)
            self.txtNumeroCircuito.ponTexto(0)
            self.txtNumeroCircuito.Enable(0)
            if (self.txtLinea.dameValor() == 'D.I.'):
                if ((self.padre.instalacion.contadorInstalacion == -1) or (self.padre.instalacion.contadorInstalacion == 0)):
                    self.txtPotencia.ponTexto((self.padre.instalacion.potenciaInstalada * 1000))
                else:
                    self.txtPotencia.ponTexto(0)
                self.txtTensionAsignadaDICombo.Enable(1)
                self.txtNumeroCircuito.Enable(1)
            else:
                if ((self.padre.instalacion.contadorInstalacion == 1) or (self.padre.instalacion.contadorInstalacion == 2)):
                    self.txtPotencia.ponTexto((self.padre.instalacion.potenciaInstalada * 1000))
                else:
                    self.txtPotencia.ponTexto(0)
                self.txtTensionAsignadaDICombo.Enable(0)
                self.txtTensionAsignadaDI.Enable(0)
                self.txtNumeroCircuito.ponTexto(0)
                self.txtNumeroCircuito.Enable(0)



    def dibujaTrifasicoTension(self, padre):
        panel = Panel(padre, 2, 2)
        panel.insertaElemento(Etiqueta(panel, 'II / III'))
        panel.insertaElemento(Etiqueta(panel, 'Tensi\xf3n (V)'))
        self.txtTrifasico = Combo(panel, ['II - Monof\xe1sico',
         'III - Trif\xe1sico'])
        EVT_COMBOBOX(self.txtTrifasico, self.txtTrifasico.GetId(), self.faseSeleccionada)
        panel.insertaElemento(self.txtTrifasico)
        panelInterno = Panel(panel, 0, 2)
        self.txtTension = Combo(panelInterno, ['230',
         '400',
         'Otros'])
        EVT_COMBOBOX(self.txtTension, self.txtTension.GetId(), self.tensionSeleccionada)
        panelInterno.insertaElemento(self.txtTension)
        self.txtNumeroTension = CampoMonetario(panelInterno, 0)
        self.txtNumeroTension.Enable(0)
        panelInterno.insertaElemento(self.txtNumeroTension)
        panelInterno.cerrarPanel()
        panel.insertaElemento(panelInterno)
        panel.cerrarPanel()
        return panel



    def faseSeleccionada(self, event = None):
        if (self.txtCanalizacion.GetSelection() == 1):
            if (self.txtTrifasico.GetSelection() == 0):
                self.txtNaturaleza.Append('2 cables unipolares')
                self.txtNaturaleza.Append('un cable bipolar')
            else:
                self.txtNaturaleza.Delete(3)
                self.txtNaturaleza.Delete(2)



    def tensionSeleccionada(self, event = None):
        if (not (self.txtTension.GetSelection() == -1)):
            if (self.txtTension.dameValor() == 'Otros'):
                self.txtNumeroTension.ponTexto(0)
                self.txtNumeroTension.Enable(1)
            else:
                self.txtNumeroTension.ponTexto(int(self.txtTension.dameValor()))
                self.txtNumeroTension.Enable(0)



    def dibujaPotencia(self, padre):
        panel = Panel(padre, 4, 2)
        panel.insertaElemento(Etiqueta(panel, 'Potencia (W)'))
        panel.insertaElemento(Etiqueta(panel, 'Tipo Aislamiento'))
        self.txtPotencia = CampoMonetario(panel, 2)
        panel.insertaElemento(self.txtPotencia)
        self.txtAislamiento = Combo(panel, ['XLPE',
         'PVC',
         'EPR'])
        panel.insertaElemento(self.txtAislamiento)
        panel.insertaElemento(Etiqueta(panel, 'Tension Asignada (V)'))
        panel.insertaElemento(Etiqueta(panel, ''))
        self.txtTensionAsignadaDICombo = Combo(panel, ['450',
         '750',
         '600/1000',
         'Otros'])
        EVT_COMBOBOX(self.txtTensionAsignadaDICombo, self.txtTensionAsignadaDICombo.GetId(), self.comboTensionAsignada)
        self.txtTensionAsignadaDICombo.Enable(0)
        panel.insertaElemento(self.txtTensionAsignadaDICombo)
        self.txtTensionAsignadaDI = AreaTexto(panel)
        self.txtTensionAsignadaDI.Enable(0)
        panel.insertaElemento(self.txtTensionAsignadaDI)
        panel.cerrarPanel()
        return panel



    def comboTensionAsignada(self, event = None):
        if (self.txtTensionAsignadaDICombo.dameValor() == 'Otros'):
            self.txtTensionAsignadaDI.Enable(1)
            self.txtTensionAsignadaDI.ponTexto('')
        else:
            self.txtTensionAsignadaDI.Enable(0)
            self.txtTensionAsignadaDI.ponTexto(self.txtTensionAsignadaDICombo.dameValor())



    def dibujaCoeficienteCalculo(self, padre):
        panel = Panel(padre, 3, 0)
        panel.insertaElemento(Etiqueta(panel, 'Coeficiente calculo'))
        panelInterno = Panel(panel, 0, 3)
        self.txtCanalizacion = Combo(panelInterno, ['L\xednea A\xe9rea',
         'L\xednea Subterr\xe1nea enterrada',
         'L\xednea Subterr\xe1nea al aire',
         'Instalaciones Interiores',
         'Viviendas'])
        EVT_COMBOBOX(self.txtCanalizacion, self.txtCanalizacion.GetId(), self.canalizacionSeleccionada)
        panelInterno.insertaElemento(self.txtCanalizacion)
        self.txtCoeficiente = CampoMonetario(panelInterno, 3)
        self.txtCoeficiente.Enable(0)
        self.txtCoeficiente.ponTexto(1)
        panelInterno.insertaElemento(self.txtCoeficiente)
        self.botonCalcularCoeficiente = Boton(panelInterno, 'Calcular', self.calcularCoeficiente, 'gastos')
        self.botonCalcularCoeficiente.Enable(0)
        panelInterno.insertaElemento(self.botonCalcularCoeficiente)
        self.txtAyudaCanalizacion = Etiqueta(panel, '')
        panelInterno.cerrarPanel()
        panel.insertaElemento(panelInterno)
        self.txtAyudaCanalizacion = Etiqueta(panel, '')
        panel.insertaElemento(self.txtAyudaCanalizacion)
        panel.cerrarPanel()
        return panel



    def canalizacionSeleccionada(self, event = None):
        self.txtCoeficiente.Enable(1)
        self.botonCalcularCoeficiente.Enable(1)
        self.txtNaturaleza.Enable(1)
        self.txtNaturaleza.Clear()
        listaViviendas = ['A - Conductores aislados en tubos empotrados en paredes aislantes',
         'A2 - Cables multiconductores en tubos empotrados en paredes aislantes',
         'B - Conductores aislados en tubos en montaje superficial o empotrados en obra',
         'B2 - Cables multiconductores en tubos en montaje superficial o empotrados en obra',
         'C - Cables multiconductores directamente sobre la pared',
         'E - cables multiconductores al aire libre. Distancia a la pared no inferior a 0.3 D (di\xe1metro del cable)',
         'F - Cables unipolares de contacto mutuo. Distancia a la pared no inferior a D',
         'G - Cables unipolares separado D.']
        listaAerea = ['Posada sobre fachadas',
         'Tendida con fiador de acero']
        if (self.txtTrifasico.GetSelection() == 0):
            listaSubterraneaEnterrada = ['Terna de cables unipolares',
             'Cable tripolar o tetrapolar',
             '2 cables unipolares',
             'un cable bipolar']
        else:
            listaSubterraneaEnterrada = ['Terna de cables unipolares',
             'Cable tripolar o tetrapolar']
        listaSubterraneaAire = ['Tres cables unipolares',
         'cable trif\xe1sico']
        self.txtFactorCorreccion.ponTexto(1)
        if (self.txtCanalizacion.GetSelection() == 0):
            for elemento in listaAerea:
                self.txtNaturaleza.Append(elemento)

            self.txtFactorCorreccion.Enable(1)
            self.botonFactorCorreccion.Enable(1)
        elif (self.txtCanalizacion.GetSelection() == 1):
            for elemento in listaSubterraneaEnterrada:
                self.txtNaturaleza.Append(elemento)

            self.txtFactorCorreccion.Enable(1)
            self.botonFactorCorreccion.Enable(1)
        elif (self.txtCanalizacion.GetSelection() == 2):
            for elemento in listaSubterraneaAire:
                self.txtNaturaleza.Append(elemento)

            self.txtFactorCorreccion.Enable(1)
            self.botonFactorCorreccion.Enable(1)
        else:
            for elemento in listaViviendas:
                self.txtNaturaleza.Append(elemento)

            self.txtFactorCorreccion.Enable(0)
            self.botonFactorCorreccion.Enable(0)
        if (self.txtCanalizacion.GetSelection() == 0):
            self.txtAyudaCanalizacion.ponTexto('ITC-BT-06')
        elif (self.txtCanalizacion.GetSelection() == 1):
            self.txtAyudaCanalizacion.ponTexto('ITC-BT-07')
        elif (self.txtCanalizacion.GetSelection() == 2):
            self.txtAyudaCanalizacion.ponTexto('ITC-BT-07')
        elif (self.txtCanalizacion.GetSelection() == 3):
            self.txtAyudaCanalizacion.ponTexto('ITC-BT-19')
        elif (self.txtCanalizacion.GetSelection() == 4):
            self.txtAyudaCanalizacion.ponTexto('ITC-BT-19-25')
        else:
            self.txtAyudaCanalizacion.ponTexto('')



    def calcularCoeficiente(self, event):
        canalizacion = self.txtCanalizacion.dameValor()
        if (canalizacion == 'L\xednea A\xe9rea'):
            titulo = 'Lineas aereas'
        if (canalizacion == 'L\xednea Subterr\xe1nea enterrada'):
            titulo = 'Lineas subterraneas enterradas'
        if (canalizacion == 'L\xednea Subterr\xe1nea al aire'):
            titulo = 'Lineas subterraneas al aire'
        if (canalizacion == 'Instalaciones Interiores'):
            titulo = 'Instalaciones interiores'
        if (canalizacion == 'Viviendas'):
            titulo = 'Viviendas'
        CoeficienteFacil(self.padre, ('Coeficiente de c\xe1lculo para ' + titulo), self.txtCoeficiente)



    def dibujaLongitud(self, padre):
        panel = Panel(padre, 2, 0)
        panel.insertaElemento(Etiqueta(panel, 'Longitud (m)'))
        self.txtLongitud = CampoMonetario(panel, 2)
        panel.insertaElemento(self.txtLongitud)
        panel.cerrarPanel()
        return panel



    def dibujaFactorPotenciaMaterial(self, padre):
        panel = Panel(padre, 2, 2)
        panel.insertaElemento(Etiqueta(panel, 'Factor de Potencia'))
        panel.insertaElemento(Etiqueta(panel, 'Material'))
        self.txtFactorPotencia = CampoMonetario(panel, 2)
        panel.insertaElemento(self.txtFactorPotencia)
        self.txtFactorPotencia.ponTexto(0.90000000000000002)
        self.txtMaterial = Combo(panel, ['Cobre (Cu)',
         'Aluminio (Al)'])
        panel.insertaElemento(self.txtMaterial)
        panel.cerrarPanel()
        return panel



    def dibujaNaturaleza(self, padre):
        panel = Panel(padre, 2, 0)
        panel.insertaElemento(Etiqueta(panel, 'Tipo de instalaci\xf3n'))
        lista = ['A - Conductores aislados en tubos empotrados en paredes aislantes',
         'A2 - Cables multiconductores en tubos empotrados en paredes aislantes',
         'B - Conductores aislados en tubos en montaje superficial o empotrados en obra',
         'B2 - Cables multiconductores en tubos en montaje superficial o empotrados en obra',
         'C - Cables multiconductores directamente sobre la pared',
         'E - cables multiconductores al aire libre. Distancia a la pared no inferior a 0.3 D (di\xe1metro del cable)',
         'F - Cables unipolares de contacto mutuo. Distancia a la pared no inferior a D',
         'G - Cables unipolares separado D.']
        self.txtNaturaleza = Combo(panel, lista)
        self.txtNaturaleza.Enable(0)
        panel.insertaElemento(self.txtNaturaleza)
        panel.cerrarPanel()
        return panel



    def dibujaFactorCorreccion(self, padre):
        panel = Panel(padre, 2, 2)
        panel.insertaElemento(Etiqueta(panel, 'Factor de correcci\xf3n'))
        panel.insertaElemento(Etiqueta(panel, ''))
        self.txtFactorCorreccion = CampoMonetario(panel, 2)
        self.txtFactorCorreccion.ponTexto(1)
        self.txtFactorCorreccion.Enable(0)
        panel.insertaElemento(self.txtFactorCorreccion)
        self.botonFactorCorreccion = Boton(panel, 'Calcular', self.calculaFactorCorreccion, 'gastos')
        self.botonFactorCorreccion.Enable(0)
        panel.insertaElemento(self.botonFactorCorreccion)
        panel.cerrarPanel()
        return panel



    def calculaFactorCorreccion(self, event):
        canalizacion = self.txtCanalizacion.dameValor()
        if (canalizacion == 'L\xednea A\xe9rea'):
            CoeficienteLineaAerea(self.padre, self.txtFactorCorreccion)
        if (canalizacion == 'L\xednea Subterr\xe1nea enterrada'):
            if (self.txtAislamiento.GetSelection() == -1):
                Error(self.padre, 'Debe seleccionar el tipo de aislamiento')
                return 
            CoeficienteEnterradasSubterraneas(self.padre, self.txtFactorCorreccion, self.txtAislamiento.GetSelection())
        if (canalizacion == 'L\xednea Subterr\xe1nea al aire'):
            if (self.txtTrifasico.GetSelection() == -1):
                Error(self.padre, 'Debe seleccionar la fase')
                return 
            if (self.txtAislamiento.GetSelection() == -1):
                Error(self.padre, 'Debe seleccionar el tipo de aislamiento')
                return 
            CoeficienteAireSubterraneas(self.padre, self.txtFactorCorreccion, self.txtAislamiento.GetSelection(), self.txtTrifasico.GetSelection())



    def dibujaCanalizacion(self, padre):
        panel = Panel(padre, 2, 0)
        panel.insertaElemento(Etiqueta(panel, 'Tipo de canalizaci\xf3n'))
        self.txtNuevaCanalizacion = Combo(panel, ['Al aire',
         'Directamente enterrada',
         'Enterrada bajo tubo',
         'Empotrada',
         'Empotrada bajo tubo'])
        panel.insertaElemento(self.txtNuevaCanalizacion)
        panel.cerrarPanel()
        return panel



    def dibujaProteccionDiferencial(self, padre):
        panel = Panel(padre, 2, 0)
        panel.insertaElemento(Etiqueta(panel, 'Protecci\xf3n diferencial (mA)'))
        panelInterno = Panel(panel, 0, 2)
        self.txtSensibilidad = Combo(panelInterno, ['30',
         '300',
         'Otros'])
        EVT_COMBOBOX(self.txtSensibilidad, self.txtSensibilidad.GetId(), self.sensibilidadSeleccionada)
        panelInterno.insertaElemento(self.txtSensibilidad)
        self.txtOtraSensibilidad = CampoMonetario(panelInterno, 0)
        self.txtOtraSensibilidad.Enable(0)
        panelInterno.insertaElemento(self.txtOtraSensibilidad)
        panelInterno.cerrarPanel()
        panel.insertaElemento(panelInterno)
        panel.cerrarPanel()
        return panel



    def sensibilidadSeleccionada(self, event = None):
        if (self.txtSensibilidad.dameValor() == 'Otros'):
            self.txtOtraSensibilidad.ponTexto(0)
            self.txtOtraSensibilidad.Enable(1)
        else:
            if (not (self.txtSensibilidad.GetSelection() == -1)):
                self.txtOtraSensibilidad.ponTexto(int(self.txtSensibilidad.dameValor()))
            self.txtOtraSensibilidad.Enable(0)



    def dibujaBotonAceptar(self, padre):
        panel = Panel(padre, 1, 0)
        panel.insertaElemento(Boton(panel, 'Aceptar', self.aceptarCalculo, 'aceptar'))
        panel.cerrarPanel()
        return panel



    def aceptarCalculo(self, event):
        datos = self.construyeObjetoDatos()
        if (datos.__class__ == str):
            Error(self.padre, datos)
        else:
            CalculoNuevaSeccion(self.padre, datos, self)



    def calculaProteccionSobreIntensidad(self, dato):
        dato.construyeIntensidadAdmisible()
        dato.construyeListaProtecciones()
        CalculoIntensidadesAdmisibles(self.padre, dato, self)



    def finalizaAceptar(self, datos):
        self.datosHoja.inserta(datos)
        self.resumenDatos.DeleteAllItems()
        for datos in self.datosHoja.datosCircuitos:
            self.resumenDatos.Append(datos.dameListaResumen())

        self.limpiaDatos()



    def construyeObjetoDatos(self):
        datos = DatosCircuito()
        datos.linea = self.txtLinea.GetSelection()
        datos.numeroCircuito = self.txtNumeroCircuito.dameValor()
        datos.fuerza = self.txtFuerza.GetSelection()
        if (not datos.construyeDenominacionLinea()):
            return 'La denominaci\xf3n de l\xednea esta mal construida'
        if self.datosHoja.existeLinea(datos.LDenominacionLinea):
            return 'La l\xednea tiene un nombre repetido'
        datos.fase = self.txtTrifasico.GetSelection()
        if (not datos.construyeFase()):
            return 'Debe seleccionar la fase'
        datos.comboTension = self.txtTension.GetSelection()
        datos.tension = self.txtNumeroTension.dameValor()
        if (not datos.construyeTension()):
            return 'La tensi\xf3n no esta especificada o esta mal especificada'
        datos.potencia = self.txtPotencia.dameValor()
        if (not datos.construyePotencia()):
            return 'La potencia no esta especificada o esta mal especificada'
        datos.aislamiento = self.txtAislamiento.GetSelection()
        datos.comboTensionDI = self.txtTensionAsignadaDICombo.GetSelection()
        datos.tensionDI = self.txtTensionAsignadaDI.dameValor()
        datos.tipoInstalacion = self.txtCanalizacion.GetSelection()
        datos.coeficienteCalculo = self.txtCoeficiente.dameValor()
        if (not datos.construyeCoeficienteCalculo()):
            return 'El coeficiente de c\xe1lculo esta mal calculado'
        datos.construyePotenciaCalculo()
        datos.longitud = self.txtLongitud.dameValor()
        if (not datos.construyeLongitud()):
            return 'La longitud esta mal calculada'
        datos.factorPotencia = self.txtFactorPotencia.dameValor()
        datos.material = self.txtMaterial.GetSelection()
        if (not datos.construyeIntensidad()):
            return 'El factor de potencia esta mal calculado'
        datos.factorCorreccion = self.txtFactorCorreccion.dameValor()
        if (not datos.construyeIntensidadCorregida()):
            return 'El factor de correcci\xf3n no puede ser 0'
        datos.naturaleza = self.txtNaturaleza.GetSelection()
        if (not datos.construyeSeccion()):
            return 'No tenemos suficientes datos para calcular la seccion'
        if (not datos.construyeCaidaTension()):
            return 'Se produjo un error al calcular la ca\xedda de tensi\xf3n'
        if (not datos.construyeCaidaTensionAdmisible(self.padre.instalacion.ITipo, self.padre.instalacion.contadorInstalacion)):
            return 'L.G.A. no existe, solo tenemos derivaci\xf3n individual'
        datos.compruebaSeccionValida()
        datos.ajustaMinimosSeccion()
        datos.construyeDensidad()
        datos.canalizacion = self.txtNuevaCanalizacion.GetSelection()
        if (not datos.construyeCanalizacion()):
            return 'Debe seleccionar un tipo de canalizaci\xf3n'
        datos.sensibilidadCombo = self.txtSensibilidad.GetSelection()
        datos.sensibilidadNumero = self.txtOtraSensibilidad.dameValor()
        if (not datos.construyeSensibilidad()):
            return 'Debe seleccionar un valor para la protecci\xf3n diferencial'
        return datos



    def limpiaDatos(self):
        self.txtLinea.SetSelection(-1)
        self.txtNumeroCircuito.ponTexto(0)
        self.txtNumeroCircuito.Enable(0)
        self.txtFuerza.SetSelection(-1)
        self.txtFuerza.Enable(0)
        self.botonAyudaFuerza.Enable(0)
        self.txtTrifasico.SetSelection(-1)
        self.txtTension.SetSelection(-1)
        self.txtNumeroTension.ponTexto(0)
        self.txtNumeroTension.Enable(0)
        self.txtPotencia.ponTexto(0)
        self.txtAislamiento.SetSelection(-1)
        self.txtTensionAsignadaDICombo.SetSelection(-1)
        self.txtTensionAsignadaDICombo.Enable(0)
        self.txtTensionAsignadaDI.ponTexto('')
        self.txtTensionAsignadaDI.Enable(0)
        self.txtCanalizacion.SetSelection(-1)
        self.txtCoeficiente.ponTexto(1)
        self.txtCoeficiente.Enable(0)
        self.botonCalcularCoeficiente.Enable(0)
        self.txtLongitud.ponTexto(0)
        self.txtFactorPotencia.ponTexto(0.90000000000000002)
        self.txtMaterial.SetSelection(-1)
        self.txtFactorCorreccion.ponTexto(1)
        self.txtFactorCorreccion.Enable(0)
        self.botonFactorCorreccion.Enable(0)
        self.txtNaturaleza.SetSelection(-1)
        self.txtNaturaleza.Enable(0)
        self.txtNuevaCanalizacion.SetSelection(-1)
        self.txtSensibilidad.SetSelection(-1)
        self.txtOtraSensibilidad.ponTexto(0)
        self.txtOtraSensibilidad.Enable(0)



    def dibujaBotonEliminar(self):
        panel = Panel(self, 0, 8)
        self.botonObservaciones = Boton(panel, 'Observaciones', self.verObservaciones, 'nuevo')
        panel.insertaElemento(self.botonObservaciones)
        self.botonEsquema = Boton(panel, 'Esquema', self.verEsquema, 'gantz')
        panel.insertaElemento(self.botonEsquema)
        self.botonAsignarEsquema = Boton(panel, 'Asignar Esquema', self.asignarEsquema, 'gantz')
        panel.insertaElemento(self.botonAsignarEsquema)
        self.botonVerEsquema = Boton(panel, 'Ver Esquema', self.verImagenEsquema, 'gantz')
        panel.insertaElemento(self.botonVerEsquema)
        self.botonNuevaHoja = Boton(panel, 'Nueva Hoja', self.nuevaHoja, 'factura')
        panel.insertaElemento(self.botonNuevaHoja)
        panel.insertaElemento(Etiqueta(panel, ''))
        self.botonModificar = Boton(panel, 'Modificar', self.modificarCalculo, 'izquierda')
        self.botonModificar.Enable(0)
        self.botonEliminar = Boton(panel, 'Eliminar', self.eliminarCalculo, 'eliminar')
        self.botonEliminar.Enable(0)
        panel.insertaElemento(self.botonModificar)
        panel.insertaElemento(self.botonEliminar)
        panel.creceColumna(5)
        panel.cerrarPanel()
        return panel



    def verImagenEsquema(self, event):
        if (self.datosHoja.esquema == ''):
            Error(self.padre, 'No se ha definido el esquema')
            return 
        try:
            bmp = PIL.Image.open(self.datosHoja.ficheroEsquemaAplicacion)
            bmp.show()
        except:
            Error(self.padre, 'Error al mostrar el esquema')
            return 



    def asignarEsquema(self, event):
        AsignarEsquema(self.padre, self.datosHoja)



    def calculoSeleccionado(self, event):
        self.botonEliminar.Enable(1)
        self.botonModificar.Enable(1)
        self.itemSeleccionado = event.GetText()



    def calculoDeseleccionado(self, event):
        self.botonEliminar.Enable(0)
        self.botonModificar.Enable(0)



    def verObservaciones(self, event):
        ObservacionesCalculo(self.padre, self.datosHoja)



    def verEsquema(self, event):
        if self.datosHoja.compruebaCircuitos():
            NumeroDiferenciales(self.padre, self.datosHoja)
        else:
            Error(self, 'No ha definido circuitos, No se puede mostrar el esquema unifilar')



    def nuevaHoja(self, event):
        self.padre.objeto.insertaNuevaHoja()



    def eliminarCalculo(self, event):
        self.datosHoja.elimina(self.itemSeleccionado)
        self.resumenDatos.DeleteAllItems()
        for datos in self.datosHoja.datosCircuitos:
            self.resumenDatos.Append(datos.dameListaResumen())

        self.calculoDeseleccionado(event)



    def modificarCalculo(self, event):
        dato = self.datosHoja.dameDato(self.itemSeleccionado)
        self.cargaDatosModificar(dato)
        self.eliminarCalculo(event)



    def cargaDatosModificar(self, dato):
        self.txtLinea.SetSelection(dato.linea)
        self.lineaSeleccionada()
        self.txtNumeroCircuito.ponTexto(dato.numeroCircuito)
        self.txtFuerza.SetSelection(dato.fuerza)
        self.txtTrifasico.SetSelection(dato.fase)
        self.faseSeleccionada()
        self.txtTension.SetSelection(dato.comboTension)
        self.tensionSeleccionada()
        self.txtNumeroTension.ponTexto(dato.tension)
        self.txtPotencia.ponTexto(dato.potencia)
        self.txtAislamiento.SetSelection(dato.aislamiento)
        self.txtTensionAsignadaDICombo.SetSelection(dato.comboTensionDI)
        self.comboTensionAsignada()
        self.txtTensionAsignadaDI.ponTexto(dato.tensionDI)
        self.txtCanalizacion.SetSelection(dato.tipoInstalacion)
        self.canalizacionSeleccionada()
        self.txtCoeficiente.ponTexto(dato.coeficienteCalculo)
        self.txtLongitud.ponTexto(dato.longitud)
        self.txtFactorPotencia.ponTexto(dato.factorPotencia)
        self.txtMaterial.SetSelection(dato.material)
        self.txtFactorCorreccion.ponTexto(dato.factorCorreccion)
        self.txtNaturaleza.SetSelection(dato.naturaleza)
        self.txtNuevaCanalizacion.SetSelection(dato.canalizacion)
        self.txtSensibilidad.SetSelection(dato.sensibilidadCombo)
        self.sensibilidadSeleccionada()
        self.txtOtraSensibilidad.ponTexto(dato.sensibilidadNumero)



    def guardaDatos(self):
        self.datosHoja.linea = self.txtLinea.GetSelection()
        self.datosHoja.numeroCircuito = self.txtNumeroCircuito.dameValor()
        self.datosHoja.fuerza = self.txtFuerza.GetSelection()
        self.datosHoja.fase = self.txtTrifasico.GetSelection()
        self.datosHoja.comboTension = self.txtTension.GetSelection()
        self.datosHoja.tension = self.txtNumeroTension.dameValor()
        self.datosHoja.potencia = self.txtPotencia.dameValor()
        self.datosHoja.aislamiento = self.txtAislamiento.GetSelection()
        self.datosHoja.comboTensionDI = self.txtTensionAsignadaDICombo.GetSelection()
        self.datosHoja.tensionDI = self.txtTensionAsignadaDI.dameValor()
        self.datosHoja.tipoInstalacion = self.txtCanalizacion.GetSelection()
        self.datosHoja.coeficienteCalculo = self.txtCoeficiente.dameValor()
        self.datosHoja.longitud = self.txtLongitud.dameValor()
        self.datosHoja.factorPotencia = self.txtFactorPotencia.dameValor()
        self.datosHoja.material = self.txtMaterial.GetSelection()
        self.datosHoja.factorCorreccion = self.txtFactorCorreccion.dameValor()
        self.datosHoja.naturaleza = self.txtNaturaleza.GetSelection()
        self.datosHoja.canalizacion = self.txtNuevaCanalizacion.GetSelection()
        self.datosHoja.sensibilidadCombo = self.txtSensibilidad.GetSelection()
        self.datosHoja.sensibilidadNumero = self.txtOtraSensibilidad.dameValor()
        return self.datosHoja



    def cargaDatos(self):
        self.txtLinea.SetSelection(self.datosHoja.linea)
        self.lineaSeleccionada()
        self.txtNumeroCircuito.ponTexto(self.datosHoja.numeroCircuito)
        self.txtFuerza.SetSelection(self.datosHoja.fuerza)
        self.txtTrifasico.SetSelection(self.datosHoja.fase)
        self.faseSeleccionada()
        self.txtTension.SetSelection(self.datosHoja.comboTension)
        self.tensionSeleccionada()
        self.txtNumeroTension.ponTexto(self.datosHoja.tension)
        self.txtPotencia.ponTexto(self.datosHoja.potencia)
        self.txtAislamiento.SetSelection(self.datosHoja.aislamiento)
        self.txtTensionAsignadaDICombo.SetSelection(self.datosHoja.comboTensionDI)
        self.comboTensionAsignada()
        self.txtTensionAsignadaDI.ponTexto(self.datosHoja.tensionDI)
        self.txtCanalizacion.SetSelection(self.datosHoja.tipoInstalacion)
        self.canalizacionSeleccionada()
        self.txtCoeficiente.ponTexto(self.datosHoja.coeficienteCalculo)
        self.txtLongitud.ponTexto(self.datosHoja.longitud)
        self.txtFactorPotencia.ponTexto(self.datosHoja.factorPotencia)
        self.txtMaterial.SetSelection(self.datosHoja.material)
        self.txtFactorCorreccion.ponTexto(self.datosHoja.factorCorreccion)
        self.txtNaturaleza.SetSelection(self.datosHoja.naturaleza)
        self.txtNuevaCanalizacion.SetSelection(self.datosHoja.canalizacion)
        self.txtSensibilidad.SetSelection(self.datosHoja.sensibilidadCombo)
        self.sensibilidadSeleccionada()
        self.txtOtraSensibilidad.ponTexto(self.datosHoja.sensibilidadNumero)
        self.datosHoja.datosCircuitos.sort()
        self.resumenDatos.DeleteAllItems()
        for datos in self.datosHoja.datosCircuitos:
            self.resumenDatos.Append(datos.dameListaResumen())

#}}}

class Paso8(Panel): #{{{
    __module__ = __name__

    def __init__(self, padre, w, h, clasePrincipal):
        Panel.__init__(self, padre, 6, 0)
        self.padre = clasePrincipal
        self.pasoSiguiente = 'Paso9'
        self.pasoAnterior = 'Paso7'
        self.insertaElemento(self.dibujaTitulo())
        self.insertaElemento(self.dibujaBotonImagen())
        self.insertaElemento(self.dibujaRadiosCroquis())
        self.creceColumna(0)
        self.creceFila(2)
        self.cerrarPanel()
        self.SetSize([w,
         h])
        self.cargaDatos()
	if not self.padre.instalacion.esEditable("8"): self.Enable(0)



    def dibujaBotonImagen(self):
        panel = Panel(self, 1, 0)
        panel.insertaElemento(Boton(panel, 'Imagen', self.mostrarImagenes))
        panel.cerrarPanel()
        return panel



    def mostrarImagenes(self, event):
        ImagenesCroquis(self.padre)



    def dibujaTitulo(self):
        panel = Panel(self, 0, 3)
        centrado = Etiqueta(panel, '')
        centrado.ponEstilo(13, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(centrado)
        titulo = Etiqueta(panel, '8 CROQUIS')
        titulo.ponEstilo(13, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(titulo)
        panel.insertaElemento(centrado)
        panel.creceColumna(0)
        panel.creceColumna(2)
        panel.SetBackgroundColour(wxBLUE)
        panel.cerrarPanel()
        return panel



    def dibujaRadiosCroquis(self):
        panel = Panel(self, 4, 0)
        etiqueta = Etiqueta(panel, 'Texto')
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        self.croquisMemo = Memo(panel)
        panel.insertaElemento(self.croquisMemo)
        panel.creceColumna(0)
        panel.creceFila(1)
        panel.cerrarPanel()
        return panel



    def comprobarSiguientePaso(self):
        self.guardaDatos()



    def guardaDatos(self):
        self.padre.instalacion.textoCroquis = self.croquisMemo.dameValor()



    def cargaDatos(self):
        self.croquisMemo.ponTexto(self.padre.instalacion.textoCroquis)
#}}}

class Paso9(PanelScroll): #{{{
    __module__ = __name__

    def __init__(self, padre, w, h, clasePrincipal):
        PanelScroll.__init__(self, padre, 2, 0)
        self.padre = clasePrincipal
        self.pasoSiguiente = 'Paso11'
        self.pasoAnterior = 'Paso8'
        self.insertaElemento(self.dibujaTitulo(self))
        self.insertaElemento(self.dibujaDatos(self))
        self.creceColumna(0)
        self.creceFila(1)
        self.cerrarPanel()
        self.SetSize([w,
         h])
        self.cargaDatos()
	if not self.padre.instalacion.esEditable("9"): self.Enable(0)



    def dibujaTitulo(self, padre):
        panel = Panel(padre, 0, 3)
        centrado = Etiqueta(panel, '')
        centrado.ponEstilo(13, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(centrado)
        titulo = Etiqueta(panel, '9. RESUMEN INSTALACION')
        titulo.ponEstilo(15, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(titulo)
        panel.insertaElemento(centrado)
        panel.creceColumna(0)
        panel.creceColumna(2)
        panel.cerrarPanel()
        panel.SetBackgroundColour(wxBLUE)
        return panel



    def dibujaDatos(self, padre):
        panel = Panel(padre, 12, 0)
        etiqueta = Etiqueta(panel, 'Caja General de protecci\xf3n')
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        panel.insertaElemento(self.dibujaCajaGeneral(panel))
        etiqueta = Etiqueta(panel, 'C\xe1lculos de toma de tierra')
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        panel.insertaElemento(self.dibujaCalculosTomaTierra(panel))
        panel.insertaElemento(self.dibujaResistencias(panel))
        self.checkDocumentacion = CajaRadio(panel, 'Documentaci\xf3n que se adjunta de la instalaci\xf3n el\xe9ctrica', ['Memoria t\xe9cnica de dise\xf1o',
         'Acreditaci\xf3n de representaci\xf3n o apoderamiento',
         'Proyecto T\xe9cnico',
         'Informe y/o autorizaci\xf3n de medio ambiente',
         'Certificado de direcci\xf3n de obra',
         'Permisos de paso zonas de afecci\xf3n de la instalaci\xf3n el\xe9ctrica',
         'Certificado de inspecci\xf3n inicial',
         'Hoja de datos complementario para obras',
         'Certificado de instalaci\xf3n el\xe9ctrica y anexo para el usuario',
         'Copias de insc. en registro de estbl. industriales de la maq. de obra y (D.C.E.)',
         'Anexo de las variaciones habidas en la ejecuci\xf3n de la instalaci\xf3n',
         'Informe de controles en quir\xf3fanos y salas de intervenci\xf3n, ITC-BT-38',
         'Autorizaci\xf3n de otras instalaciones industriales',
         'Otra documentaci\xf3n'], check=1)
        panel.insertaElemento(self.checkDocumentacion.dibujaCajaRadio(self.compruebaCheckDocumentacion))
        self.txtOtraDocumentacion = AreaTexto(panel)
        self.txtOtraDocumentacion.Enable(0)
        panel.insertaElemento(self.txtOtraDocumentacion)
        self.txtAportar = wxCheckBox(panel, -1, 'Se aporta solicitud de iniciaci\xf3n de expediente para la comunicaci\xf3n de datos al registro de establecimientos industriales')
        panel.insertaElemento(self.txtAportar)
        self.checkIndustrial = CajaRadio(panel, 'Datos sobre el registro industrial', ['Nuevo establecimiento',
         'Establecimiento dado de alta en el registro con n\xfamero:'], check=1)
        panel.insertaElemento(self.checkIndustrial.dibujaCajaRadio(self.compruebaCheckIndustrial))
        self.txtNumeroRegistro = AreaTexto(panel)
        self.txtNumeroRegistro.Enable(0)
        panel.insertaElemento(self.txtNumeroRegistro)
        self.checkOtras = CajaRadio(panel, 'Otras instalaciones industriales existentes en el mismo emplazamiento', ['El\xe9ctrica de alta tensi\xf3n',
         'Protecci\xf3n contra incendios en establecimientos industriales',
         'T\xe9rmicas en edificio',
         'Frigor\xedficas',
         'Ascensores / gr\xfaas',
         'Seguridad en maquinas',
         'Almacenamiento de productos qu\xedmicos',
         'Almacenamiento de productos petrol\xedferos',
         'Aparatos a presi\xf3n',
         'Gas',
         'Otras instalaciones',
         'Interiores de agua'], check=1)
        panel.insertaElemento(self.checkOtras.dibujaCajaRadio(self.compruebaCheckInstalacion))
        self.txtOtraInstalacion = AreaTexto(panel)
        self.txtOtraInstalacion.Enable(0)
        panel.insertaElemento(self.txtOtraInstalacion)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def compruebaCheckDocumentacion(self, event = None):
        if self.checkDocumentacion.radios[13].GetValue():
            self.txtOtraDocumentacion.Enable(1)
        else:
            self.txtOtraDocumentacion.Enable(0)



    def compruebaCheckInstalacion(self, event = None):
        if self.checkOtras.radios[10].GetValue():
            self.txtOtraInstalacion.Enable(1)
        else:
            self.txtOtraInstalacion.Enable(0)



    def compruebaCheckIndustrial(self, event = None):
        if self.checkIndustrial.radios[1].GetValue():
            self.txtNumeroRegistro.Enable(1)
        else:
            self.txtNumeroRegistro.Enable(0)



    def dibujaCajaGeneral(self, padre):
        panel = Panel(padre, 2, 7)
        etiqueta = Etiqueta(panel, '1.-')
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        panel.insertaElemento(Etiqueta(panel, 'In Base (A)'))
        self.txtInBase1 = CampoMonetario(panel, 0)
        panel.insertaElemento(self.txtInBase1)
        panel.insertaElemento(Etiqueta(panel, 'In Fusible (A)'))
        self.txtInFusible1 = CampoMonetario(panel, 0)
        panel.insertaElemento(self.txtInFusible1)
        panel.insertaElemento(Etiqueta(panel, 'Potencia Corte (KW)'))
        self.txtPotCorte1 = CampoMonetario(panel, 0)
        panel.insertaElemento(self.txtPotCorte1)
        etiqueta = Etiqueta(panel, '2.-')
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        panel.insertaElemento(Etiqueta(panel, 'In Base (A)'))
        self.txtInBase2 = CampoMonetario(panel, 0)
        panel.insertaElemento(self.txtInBase2)
        panel.insertaElemento(Etiqueta(panel, 'In Fusible (A)'))
        self.txtInFusible2 = CampoMonetario(panel, 0)
        panel.insertaElemento(self.txtInFusible2)
        panel.insertaElemento(Etiqueta(panel, 'Potencia Corte (KW)'))
        self.txtPotCorte2 = CampoMonetario(panel, 0)
        panel.insertaElemento(self.txtPotCorte2)
        panel.cerrarPanel()
        return panel



    def dibujaCalculosTomaTierra(self, padre):
        panel = Panel(padre, 2, 4)
        panel.insertaElemento(Etiqueta(panel, 'Tomas de tierra'))
        panel.insertaElemento(Etiqueta(panel, 'Conductores de tierra'))
        panel.insertaElemento(Etiqueta(panel, 'Resistencia calculada (Ohm)'))
        panel.insertaElemento(Etiqueta(panel, ''))
        self.txtTomaTierra = AreaTexto(panel)
        panel.insertaElemento(self.txtTomaTierra)
        self.txtConductoresTierra = AreaTexto(panel)
        panel.insertaElemento(self.txtConductoresTierra)
        self.txtResistencia = CampoMonetario(panel, 2)
        panel.insertaElemento(self.txtResistencia)
        panel.insertaElemento(Boton(panel, 'Calcular', self.calcularResistencia, 'gastos'))
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaResistencias(self, padre):
        panel = Panel(padre, 0, 4)
        panel.insertaElemento(Etiqueta(panel, 'Resistencia puesta a tierra (Ohm)'))
        self.txtResistenciaTierra = CampoMonetario(panel, 2)
        panel.insertaElemento(self.txtResistenciaTierra)
        panel.insertaElemento(Etiqueta(panel, 'Resistencia de aislamiento de la instalaci\xf3n (KOhm)'))
        self.txtResistenciaAislamiento = CampoMonetario(panel, 2)
        EVT_KILL_FOCUS(self.txtResistenciaAislamiento, self.compruebaAislamiento)
        panel.insertaElemento(self.txtResistenciaAislamiento)
        panel.cerrarPanel()
        return panel



    def compruebaAislamiento(self, event):
        try:
            if (self.txtResistenciaAislamiento.dameValor() < 500):
                Error(self.padre, 'La resistencia de aislamiento debe ser mayor o igual a 500 (KOhm)')
                self.txtResistenciaAislamiento.ponTexto(500)
        except:
            pass



    def calcularResistencia(self, event):
        ResistenciaCalculada(self.padre)



    def guardaDatos(self):
        try:
            self.padre.instalacion.inBase1 = self.txtInBase1.dameValor()
            self.padre.instalacion.inBase2 = self.txtInBase2.dameValor()
            self.padre.instalacion.inFusible1 = self.txtInFusible1.dameValor()
            self.padre.instalacion.inFusible2 = self.txtInFusible2.dameValor()
            self.padre.instalacion.inPotencia1 = self.txtPotCorte1.dameValor()
            self.padre.instalacion.inPotencia2 = self.txtPotCorte2.dameValor()
            self.padre.instalacion.tomaTierra = self.txtTomaTierra.dameValor()
            self.padre.instalacion.conductores = self.txtConductoresTierra.dameValor()
            self.padre.instalacion.resistenciaCalculada = self.txtResistencia.dameValor()
            self.padre.instalacion.resistenciaTierra = self.txtResistenciaTierra.dameValor()
            self.padre.instalacion.resistenciaAislamiento = self.txtResistenciaAislamiento.dameValor()
            lista = []
            for radio in self.checkDocumentacion.radios:
                lista.append(radio.GetValue())

            self.padre.instalacion.documentos = lista
            self.padre.instalacion.solicitud = self.txtAportar.GetValue()
            lista = []
            for radio in self.checkIndustrial.radios:
                lista.append(radio.GetValue())

            self.padre.instalacion.datosRegistro = lista
            lista = []
            for radio in self.checkOtras.radios:
                lista.append(radio.GetValue())

            self.padre.instalacion.otrasInstalaciones = lista
            if self.txtOtraDocumentacion.IsEnabled():
                self.padre.instalacion.otrosDocumentos = self.txtOtraDocumentacion.dameValor()
            else:
                self.padre.instalacion.otrosDocumentos = ''
            if self.txtOtraInstalacion.IsEnabled():
                self.padre.instalacion.otrasInstalacionesTexto = self.txtOtraInstalacion.dameValor()
            else:
                self.padre.instalacion.otrasInstalacionesTexto = ''
            if self.txtNumeroRegistro.IsEnabled():
                self.padre.instalacion.numeroRegistro = self.txtNumeroRegistro.dameValor()
            else:
                self.padre.instalacion.numeroRegistro = ''
        except:
            pass



    def cargaDatos(self):
        self.txtInBase1.ponTexto(self.padre.instalacion.inBase1)
        self.txtInBase2.ponTexto(self.padre.instalacion.inBase2)
        self.txtInFusible1.ponTexto(self.padre.instalacion.inFusible1)
        self.txtInFusible2.ponTexto(self.padre.instalacion.inFusible2)
        self.txtPotCorte1.ponTexto(self.padre.instalacion.inPotencia1)
        self.txtPotCorte2.ponTexto(self.padre.instalacion.inPotencia2)
        self.txtTomaTierra.ponTexto(self.padre.instalacion.tomaTierra)
        self.txtConductoresTierra.ponTexto(self.padre.instalacion.conductores)
        self.txtResistencia.ponTexto(self.padre.instalacion.resistenciaCalculada)
        self.txtResistenciaTierra.ponTexto(self.padre.instalacion.resistenciaTierra)
        self.txtResistenciaAislamiento.ponTexto(self.padre.instalacion.resistenciaAislamiento)
        for i in range(len(self.padre.instalacion.documentos)):
            self.checkDocumentacion.radios[i].SetValue(self.padre.instalacion.documentos[i])

        self.txtAportar.SetValue(self.padre.instalacion.solicitud)
        for i in range(len(self.padre.instalacion.datosRegistro)):
            self.checkIndustrial.radios[i].SetValue(self.padre.instalacion.datosRegistro[i])

        for i in range(len(self.padre.instalacion.otrasInstalaciones)):
            self.checkOtras.radios[i].SetValue(self.padre.instalacion.otrasInstalaciones[i])

        self.txtOtraDocumentacion.ponTexto(self.padre.instalacion.otrosDocumentos)
        self.compruebaCheckDocumentacion()
        self.txtOtraInstalacion.ponTexto(self.padre.instalacion.otrasInstalacionesTexto)
        self.compruebaCheckInstalacion()
        self.txtNumeroRegistro.ponTexto(self.padre.instalacion.numeroRegistro)
        self.compruebaCheckIndustrial()



    def comprobarSiguientePaso(self):
        self.guardaDatos()

#}}}

class Paso10(PanelScroll): #{{{
    __module__ = __name__

    def __init__(self, padre, w, h, clasePrincipal):
        PanelScroll.__init__(self, padre, 2, 0)
        self.padre = clasePrincipal
        self.pasoSiguiente = 'Paso11'
        self.pasoAnterior = 'Paso5'
        self.insertaElemento(self.dibujaTitulo(self))
        self.insertaElemento(self.dibujaDatos(self))
        self.creceColumna(0)
        self.creceFila(1)
        self.cerrarPanel()
        self.SetSize([w,
         h])
        self.cargaDatos()
	if not self.padre.instalacion.esEditable("10"): self.Enable(0)



    def dibujaTitulo(self, padre):
        panel = Panel(padre, 0, 3)
        centrado = Etiqueta(panel, '')
        centrado.ponEstilo(13, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(centrado)
        titulo = Etiqueta(panel, '10. PROYECTO')
        titulo.ponEstilo(15, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(titulo)
        panel.insertaElemento(centrado)
        panel.creceColumna(0)
        panel.creceColumna(2)
        panel.cerrarPanel()
        panel.SetBackgroundColour(wxBLUE)
        return panel



    def dibujaDatos(self, padre):
        panel = Panel(padre, 12, 0)
        etiqueta = Etiqueta(panel, 'L\xednea General de Alimentaci\xf3n')
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        panel.insertaElemento(self.dibujaDatosLGA1(panel))
        panel.insertaElemento(self.dibujaDatosLGA2(panel))
        etiqueta = Etiqueta(panel, 'Derivaci\xf3n Individual')
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        panel.insertaElemento(self.dibujaDatosDI1(panel))
        panel.insertaElemento(self.dibujaDatosDI2(panel))
        etiqueta = Etiqueta(panel, 'Protecciones Diferenciales instaladas')
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        self.checkSensibilidad = CajaRadio(panel, 'Sensibilidad (mA)', ['10',
         '30',
         '300',
         'Otras'], check=1, numColumnas=4)
        panel.insertaElemento(self.checkSensibilidad.dibujaCajaRadio(self.compruebaCheckSensibilidad))
        self.txtOtraSensibilidad = AreaTexto(panel)
        self.txtOtraSensibilidad.Enable(0)
        panel.insertaElemento(self.txtOtraSensibilidad)
        etiqueta = Etiqueta(panel, 'Organismo de Control Acreditado que ha realizado la Inspecci\xf3n Inicial')
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        panel.insertaElemento(self.dibujaDatosOCA(panel))
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def compruebaCheckSensibilidad(self, event = None):
        if self.checkSensibilidad.radios[3].GetValue():
            self.txtOtraSensibilidad.Enable(1)
        else:
            self.txtOtraSensibilidad.Enable(0)



    def dibujaDatosLGA1(self, padre):
        panel = Panel(padre, 2, 2)
        panel.insertaElemento(Etiqueta(panel, 'Instalaci\xf3n'))
        panel.insertaElemento(Etiqueta(panel, 'Conductor'))
        self.txtInstalacionLGA = AreaTexto(panel)
        panel.insertaElemento(self.txtInstalacionLGA)
        self.txtConductorLGA = AreaTexto(panel)
        panel.insertaElemento(self.txtConductorLGA)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaDatosLGA2(self, padre):
        panel = Panel(padre, 2, 3)
        panel.insertaElemento(Etiqueta(panel, 'Secci\xf3n fase/neutro/CP (mm2)'))
        panel.insertaElemento(Etiqueta(panel, 'Material aislamiento'))
        panel.insertaElemento(Etiqueta(panel, 'Potencia M\xe1xima Admisible (kW)'))
        self.txtSeccionLGA = AreaTexto(panel)
        panel.insertaElemento(self.txtSeccionLGA)
        self.txtMaterialLGA = AreaTexto(panel)
        panel.insertaElemento(self.txtMaterialLGA)
        self.txtPotenciaLGA = CampoMonetario(panel, 2)
        panel.insertaElemento(self.txtPotenciaLGA)
        panel.creceColumna(0)
        panel.creceColumna(1)
        panel.creceColumna(2)
        panel.cerrarPanel()
        return panel



    def dibujaDatosDI1(self, padre):
        panel = Panel(padre, 2, 2)
        panel.insertaElemento(Etiqueta(panel, 'Instalaci\xf3n'))
        panel.insertaElemento(Etiqueta(panel, 'Conductor'))
        self.txtInstalacionDI = AreaTexto(panel)
        panel.insertaElemento(self.txtInstalacionDI)
        self.txtConductorDI = AreaTexto(panel)
        panel.insertaElemento(self.txtConductorDI)
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaDatosDI2(self, padre):
        panel = Panel(padre, 4, 3)
        panel.insertaElemento(Etiqueta(panel, 'Secci\xf3n fase/neutro (mm2)'))
        panel.insertaElemento(Etiqueta(panel, 'Material aislamiento'))
        panel.insertaElemento(Etiqueta(panel, 'Tensi\xf3n Asignada (V)'))
        self.txtSeccionDI = AreaTexto(panel)
        panel.insertaElemento(self.txtSeccionDI)
        self.txtMaterialDI = AreaTexto(panel)
        panel.insertaElemento(self.txtMaterialDI)
        self.txtTensionDI = CampoMonetario(panel, 2)
        panel.insertaElemento(self.txtTensionDI)
        panel.insertaElemento(Etiqueta(panel, 'Intensidad Fusible (A)'))
        panel.insertaElemento(Etiqueta(panel, 'Interruptor General de Corte (A)'))
        panel.insertaElemento(Etiqueta(panel, 'Potencia M\xe1xima Admisible (kW)'))
        self.txtIntensidadDI = CampoMonetario(panel, 2)
        panel.insertaElemento(self.txtIntensidadDI)
        self.txtInterruptorDI = CampoMonetario(panel, 2)
        panel.insertaElemento(self.txtInterruptorDI)
        self.txtPotenciaDI = CampoMonetario(panel, 2)
        panel.insertaElemento(self.txtPotenciaDI)
        panel.creceColumna(0)
        panel.creceColumna(1)
        panel.creceColumna(2)
        panel.cerrarPanel()
        return panel



    def dibujaDatosOCA(self, padre):
        panel = Panel(padre, 2, 3)
        panel.insertaElemento(Etiqueta(panel, 'N\xfamero de Acreditaci\xf3n'))
        panel.insertaElemento(Etiqueta(panel, 'Referencia'))
        panel.insertaElemento(Etiqueta(panel, 'Fecha'))
        self.txtNumeroOCA = AreaTexto(panel)
        panel.insertaElemento(self.txtNumeroOCA)
        self.txtReferenciaOCA = AreaTexto(panel)
        panel.insertaElemento(self.txtReferenciaOCA)
        self.txtFechaOCA = wxMaskedCtrl(panel, -1, '', autoformat='EUDATEDDMMYYYY/')
        panel.insertaElemento(self.txtFechaOCA)
        panel.creceColumna(0)
        panel.creceColumna(1)
        panel.cerrarPanel()
        return panel



    def guardaDatos(self):
        self.padre.instalacion.instalacionLGA = self.txtInstalacionLGA.dameValor()
        self.padre.instalacion.conductorLGA = self.txtConductorLGA.dameValor()
        self.padre.instalacion.seccionLGA = self.txtSeccionLGA.dameValor()
        self.padre.instalacion.materialLGA = self.txtMaterialLGA.dameValor()
        self.padre.instalacion.potenciaLGA = self.txtPotenciaLGA.dameValor()
        self.padre.instalacion.instalacionDI = self.txtInstalacionDI.dameValor()
        self.padre.instalacion.conductorDI = self.txtConductorDI.dameValor()
        self.padre.instalacion.seccionDI = self.txtSeccionDI.dameValor()
        self.padre.instalacion.materialDI = self.txtMaterialDI.dameValor()
        self.padre.instalacion.tensionDI = self.txtTensionDI.dameValor()
        self.padre.instalacion.intensidadDI = self.txtIntensidadDI.dameValor()
        self.padre.instalacion.interruptorDI = self.txtInterruptorDI.dameValor()
        self.padre.instalacion.potenciaDI = self.txtPotenciaDI.dameValor()
        lista = []
        for radio in self.checkSensibilidad.radios:
            lista.append(radio.GetValue())

        self.padre.instalacion.sensibilidadesProyecto = lista
        if self.txtOtraSensibilidad.IsEnabled():
            self.padre.instalacion.otraSensibilidad = self.txtOtraSensibilidad.dameValor()
        else:
            self.padre.instalacion.otraSensibilidad = ''
        self.padre.instalacion.numeroOCA = self.txtNumeroOCA.dameValor()
        self.padre.instalacion.referenciaOCA = self.txtReferenciaOCA.dameValor()
        self.padre.instalacion.fechaOCA = self.txtFechaOCA.GetValue()



    def cargaDatos(self):
        self.txtInstalacionLGA.ponTexto(self.padre.instalacion.instalacionLGA)
        self.txtConductorLGA.ponTexto(self.padre.instalacion.conductorLGA)
        self.txtSeccionLGA.ponTexto(self.padre.instalacion.seccionLGA)
        self.txtMaterialLGA.ponTexto(self.padre.instalacion.materialLGA)
        self.txtPotenciaLGA.ponTexto(self.padre.instalacion.potenciaLGA)
        self.txtInstalacionDI.ponTexto(self.padre.instalacion.instalacionDI)
        self.txtConductorDI.ponTexto(self.padre.instalacion.conductorDI)
        self.txtSeccionDI.ponTexto(self.padre.instalacion.seccionDI)
        self.txtMaterialDI.ponTexto(self.padre.instalacion.materialDI)
        self.txtTensionDI.ponTexto(self.padre.instalacion.tensionDI)
        self.txtIntensidadDI.ponTexto(self.padre.instalacion.intensidadDI)
        self.txtInterruptorDI.ponTexto(self.padre.instalacion.interruptorDI)
        self.txtPotenciaDI.ponTexto(self.padre.instalacion.potenciaDI)
        for i in range(len(self.padre.instalacion.sensibilidadesProyecto)):
            self.checkSensibilidad.radios[i].SetValue(self.padre.instalacion.sensibilidadesProyecto[i])

        self.txtOtraSensibilidad.ponTexto(self.padre.instalacion.otraSensibilidad)
        self.compruebaCheckSensibilidad()
        self.txtNumeroOCA.ponTexto(self.padre.instalacion.numeroOCA)
        self.txtReferenciaOCA.ponTexto(self.padre.instalacion.referenciaOCA)
        self.txtFechaOCA.SetValue(self.padre.instalacion.fechaOCA)



    def comprobarSiguientePaso(self):
        self.guardaDatos()

#}}}

class Paso11(Panel): #{{{
    __module__ = __name__

    def __init__(self, padre, w, h, clasePrincipal):
        Panel.__init__(self, padre, 2, 0)
        self.padre = clasePrincipal
        self.pasoSiguiente = ''
        self.pasoAnterior = 'Paso10'
        self.insertaElemento(self.dibujaTitulo(self))
        self.insertaElemento(self.dibujaDatos(self))
        self.creceColumna(0)
        self.creceFila(1)
        self.cerrarPanel()
        self.SetSize([w,
         h])
        self.cargaDatos()
	if not self.padre.instalacion.esEditable("11"): self.Enable(0)



    def dibujaTitulo(self, padre):
        panel = Panel(padre, 0, 3)
        centrado = Etiqueta(panel, '')
        centrado.ponEstilo(13, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(centrado)
        titulo = Etiqueta(panel, '11. FECHA Y FIRMA')
        titulo.ponEstilo(15, wxDECORATIVE, wxNORMAL, wxBOLD)
        panel.insertaElemento(titulo)
        panel.insertaElemento(centrado)
        panel.creceColumna(0)
        panel.creceColumna(2)
        panel.cerrarPanel()
        panel.SetBackgroundColour(wxBLUE)
        return panel



    def dibujaDatos(self, padre):
        panel = Panel(padre, 4, 0)
        panel.insertaElemento(Etiqueta(panel, 'Fecha en la que el instalador autorizado suscribe el presente certificado, ha realizado las verificaciones correspondientes, seg\xfan la reglamentaci\xf3n vigente\nde aplicaci\xf3n, a la instalaci\xf3n el\xe9ctrica de Baja Tensi\xf3n'))
        panel.insertaElemento(self.dibujaFechaBajaTension(panel))
        etiqueta = Etiqueta(panel, 'Firma')
        etiqueta.ponNegrita()
        panel.insertaElemento(etiqueta)
        panel.insertaElemento(self.dibujaDatosFirma(panel))
        panel.creceColumna(0)
        panel.cerrarPanel()
        return panel



    def dibujaFechaBajaTension(self, padre):
        panel = Panel(padre, 0, 2)
        self.txtFechaBajaTension = wxMaskedCtrl(panel, -1, '', autoformat='EUDATEDDMMYYYY/')
        panel.insertaElemento(self.txtFechaBajaTension)
        panel.cerrarPanel()
        return panel



    def dibujaDatosFirma(self, padre):
        panel = Panel(padre, 0, 5)
        panel.insertaElemento(Etiqueta(panel, 'En '))
        self.txtLugar = AreaTexto(panel)
        panel.insertaElemento(self.txtLugar)
        panel.insertaElemento(Etiqueta(panel, ' , a '))
        self.txtFechaFirma = wxMaskedCtrl(panel, -1, '', autoformat='EUDATEDDMMYYYY/')
        panel.insertaElemento(self.txtFechaFirma)
        panel.cerrarPanel()
        return panel



    def guardaDatos(self):
        if self.padre.instalacion.compruebaProyecto():
            self.pasoAnterior = 'Paso10'
        else:
            self.pasoAnterior = 'Paso9'
        try:
            self.padre.instalacion.fechaBajaTension = self.txtFechaBajaTension.GetValue()
            self.padre.instalacion.lugar = self.txtLugar.dameValor()
            self.padre.instalacion.fechaFirma = self.txtFechaFirma.GetValue()
        except:
            pass



    def cargaDatos(self):
        self.txtFechaBajaTension.SetValue(self.padre.instalacion.fechaBajaTension)
        self.txtLugar.ponTexto(self.padre.instalacion.lugar)
        self.txtFechaFirma.SetValue(self.padre.instalacion.fechaFirma)



    def comprobarSiguientePaso(self):
        self.guardaDatos()

#}}}


# local variables:
# tab-width: 4
